#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <csgom>
#include <nfvault>

#if AMXX_VERSION_NUM < 183
#include <dhudmessage>
#define client_disconnected		client_disconnect
#endif

#define PLUGIN 				"CSGOM: Register system"
#define VERSION 			"1.0"
#define AUTHOR 				"EFFx"

#define m_iMenuCode 			205

enum
{
	BANK_ACCEPTED,
	BANK_LOCKED,
	BANK_ACESS_ACEITO,
	BANK_SENHA_RECUSADA,
	BANK_WELCOME		
}

const KEYSMENU = MENU_KEY_1|MENU_KEY_2|MENU_KEY_3|MENU_KEY_4|MENU_KEY_5|MENU_KEY_6|MENU_KEY_7|MENU_KEY_8|MENU_KEY_9|MENU_KEY_0
const OFFSET_CSMENUCODE = 205

new g_registrado[33]
new g_tentativas[33]

// Criar conta
new login_registro[33][20], password_registro[33][20], password_confirm[33][20]
new login_logar[33][10], password_logar[33][10]
new change_password_old[33], change_password_new[33]
new conta_banco[33][100]

//Banco de dados   MAX: 2.000.000.000
new register_data[128]
new const register_key[] = "Contas_Registro"

new g_mensagens
new cvar_tentativas, cvar_bantime

new szText[555 char]
new g_mMessageBarTime

enum
{
	ACTION_VERIFY_ACCOUNTDATA = 1,
	ACTION_REMOVE_ACCOUNTDATA,
	ACTION_BAN_ACCOUNTDATA
}

#define PL_ACTION g_menu_data[id][0]

new g_menu_data[32+1][1]
new PlayerID[33]

new const MP3_ENTRADA[] = "csgom/entrance.wav"
new const BaseDadosRegistro[] = "register_csgom"

#include <hamsandwich>

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_clcmd("chooseteam", "protecao"); // Nao entrar no jogo se nao estiver registrado/logado
	register_clcmd("jointeam", "protecao"); // Nao entrar no jogo se nao estiver registrado/logado
	
	RegisterHam(Ham_Spawn, "player", "playerSpawn", 1)
	
	register_message(get_user_msgid("VGUIMenu"), "protecao2"); // ShowMenu & VGUIMenu (Protees)
	register_menucmd(register_menuid("Terrorist_Select",1),511,"cmd_joinclass"); // Menus de escolha de time
	register_menucmd(register_menuid("CT_Select",1),511,"cmd_joinclass"); // Menus de escolha de time
	
	register_menu("Master Main Menu", KEYSMENU, "menu_registro_master")
	
	register_clcmd("[CSGOM]Register_Login", "registrar_login"); // Criar Login
	register_clcmd("[CSGOM]Register_Pass", "registrar_senha"); // Criar Senha
	register_clcmd("[CSGOM]Confirm_Pass", "registrar_confirmar_senha"); // Confirmar Senha
	
	register_clcmd("[CSGOM]Account_Login", "logar_login"); // Logar Conta
	register_clcmd("[CSGOM]Account_Pass", "logar_senha"); // Logar Conta
	
	register_clcmd("[CSGOM]Current_Pass", "cmd_change_password_old") // Trocar Senha
	register_clcmd("[CSGOM]New_Pass", "cmd_change_password_new") // Trocar Senha
	
	register_clcmd("say", "say_commands")
	register_clcmd("say_team", "say_commands")
	
	register_forward(FM_PlayerPreThink, "fw_PreThink");

	cvar_tentativas = register_cvar("csgom_registers_attempts", "5")
	cvar_bantime = register_cvar("csgom_register_bantime", "5")
	
	g_mMessageBarTime = get_user_msgid("BarTime")
	g_mensagens = CreateHudSyncObj()
	
	nfv_file(BaseDadosRegistro, register_data, charsmax(register_data))
}

new bool:g_bCanSelectTeam[33]
public playerSpawn(id)
{
	if(is_user_alive(id) && g_bCanSelectTeam[id])
	{
		g_bCanSelectTeam[id] = false
	}
}

public plugin_precache()
{
	precache_sound("csgom/accepted.wav")
	precache_sound("csgom/error.wav")
	
	precache_sound(MP3_ENTRADA)	
}

public native_get_user_registrado(id) 
	return g_registrado[id] && !g_bCanSelectTeam[id];

const REGISTER_TIME = 120
const TASK_COUNTDOWN = 317317
new g_iUserCountDown[33]

public client_putinserver(id)
{
	if(!is_user_bot(id) && !is_user_hltv(id))
	{		
		set_task(0.5, "mostrar_menu_registro", id)
		set_task(0.6, "som_entrada", id)
	}
}

public som_entrada(id)
{
	g_iUserCountDown[id] = REGISTER_TIME
	
	set_task(1.0, "printRegisterCountDown", id + TASK_COUNTDOWN, .flags = "b")
	barTime(id, REGISTER_TIME)
		
	client_cmd( id, "spk %s", MP3_ENTRADA );
}

public printRegisterCountDown(id)
{
	id -= TASK_COUNTDOWN
	
	if(!g_iUserCountDown[id])
	{
		server_cmd("kick #%i ^"You did not registered on the server!^"", get_user_userid(id))
		remove_task(id + TASK_COUNTDOWN)
		return
	}
	
	set_dhudmessage(200, 80, 0, -1.0, 0.45, 0, 1.0, 1.0)
	show_dhudmessage(id, "You have %d seconds to register!^nPress 'M' to return back to the register menu.", g_iUserCountDown[id])	
	g_iUserCountDown[id]--
}

public client_connect(id)
{
	g_registrado[id] = false;
	g_tentativas[id] = 0
	
	login_logar[id] = " "
	password_logar[id] = " "
	conta_banco[id] = " "
	
	remove_task(id)
	return PLUGIN_CONTINUE;
}

public client_disconnected(id)
{
	g_registrado[id] = false;
	
	login_logar[id] = " "
	password_logar[id] = " "
	conta_banco[id] = " "
	
	remove_task(id + TASK_COUNTDOWN)
	remove_task(id)
}

public plugin_natives()
{
	register_native("is_user_registered", "native_get_user_registrado", 1);
	register_native("account_menu", "mostrar_menu_registro", 1);
}

public protecao2(iMsgID, iDest, iReceiver)
{
	if(get_msg_arg_int(1) != 2)
	{
		return PLUGIN_CONTINUE
	}
	return g_registrado[iReceiver] ? PLUGIN_CONTINUE : PLUGIN_HANDLED
}

public protecao(id)
{
	if(!g_registrado[id] && !g_bCanSelectTeam[id])
	{
		mostrar_menu_registro(id)
		set_pdata_int(id, m_iMenuCode, 0)
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

public cmd_joinclass(id)
	return (g_registrado[id] && !g_bCanSelectTeam[id]) ? PLUGIN_HANDLED : PLUGIN_CONTINUE

public mostrar_menu_registro(id)
{    
	static menu[555], len
	len = 0

	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "\yRegister System^n\wSERVER \y| \rCSGOM ™^n^n" : "\yRegister System^n\wSERVER \y| \rCSGOM ™^n^n")
		
	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "\dCurrent bank:\r ( %i \yCSGOM \r)\d^n^n" : "", csgom_getmoney(id))

	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "\d1. New account^n" : "\r1. \wNew account^n")
	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "\d2. Login^n^n" : "\r2. \wLogin^n^n")
	
	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "\r3. \wChange password^n" : "\d3. Change password^n")
	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "\r4. \wLog out^n^n" : "\d4. Log out^n^n")
	len += formatex(menu[len], charsmax(menu) - len, g_registrado[id] ? "^n^n" : "\r5. Help menu^n^n^n")

	len += formatex(menu[len], charsmax(menu) - len, "\r0. \wSair")

	// Fix for AMXX custom menus
	set_pdata_int(id, OFFSET_CSMENUCODE, 0)
	show_menu(id, KEYSMENU, menu, -1, "Master Main Menu")
	
	return PLUGIN_HANDLED;
}

public menu_registro_master(id, key)
{ 
	show_menu(id, 0, "^n")
	switch(key)
	{
		case 0:
		{
			if(!g_registrado[id])
			{
				client_cmd(id, "messagemode [CSGOM]Register_Login")
				
				ClearSyncHud(id , g_mensagens)
				
				set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5) 
				ShowSyncHudMsg(id, g_mensagens, "Type a nickname for your account. ^nObs: You dont need to write your current nickname!")
				EmitSound(id, BANK_ACCEPTED)

			}
			else mostrar_menu_registro(id), EmitSound(id, BANK_LOCKED), ChatColor(id, "You are already logged in.")
		}
		case 1:
		{
			if(!g_registrado[id])
			{
				client_cmd(id, "messagemode [CSGOM]Account_Login")
			
				ClearSyncHud(id , g_mensagens)
				
				set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5) 
				ShowSyncHudMsg(id, g_mensagens, "Type your account nickname.")
				EmitSound(id, BANK_ACCEPTED)

			}
			else mostrar_menu_registro(id), EmitSound(id, BANK_LOCKED), ChatColor(id, "You are already logged in.")
		}
		case 2:
		{
			if(!g_registrado[id]) mostrar_menu_registro(id), EmitSound(id, BANK_LOCKED), ClearSyncHud(id , g_mensagens), set_hudmessage(255, 1, 1, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5), ShowSyncHudMsg(id, g_mensagens, "You are not logged in.")
			else trocar_senha(id)
		}
		case 3:
		{
			if(!g_registrado[id]) mostrar_menu_registro(id), EmitSound(id, BANK_LOCKED), ClearSyncHud(id , g_mensagens), set_hudmessage(255, 1, 1, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5), ShowSyncHudMsg(id, g_mensagens, "You are not logged in.")
			else sair_da_conta(id)
		}
		case 4:
		{
			if(!g_registrado[id])
			menu_ajuda(id)
		}
		case 5,6,7,8: mostrar_menu_registro(id)
		case 9: if(!g_registrado[id]) mostrar_menu_registro(id)
		
	}
	return PLUGIN_HANDLED
}

public trocar_senha(id)
{
	if(!g_registrado[id])
		return PLUGIN_HANDLED
		
	ClearSyncHud(id , g_mensagens)
	
	set_hudmessage(1, 255, 0, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5) 
	ShowSyncHudMsg(id, g_mensagens, "Type your account password.")
	EmitSound(id, BANK_ACCEPTED)

	client_cmd(id, "messagemode [CSGOM]Current_Pass")
	return PLUGIN_CONTINUE
}

public cmd_change_password_old(id)
{
	if(!g_registrado[id])
		return PLUGIN_HANDLED
	
	read_args(change_password_old[id], charsmax(change_password_old))
	remove_quotes(change_password_old[id])
	trim(change_password_old[id])
	
	new data[521]; nfv_get_data(register_data, register_key, login_logar[id], data[id], charsmax(data))
	parse(data[id], password_logar[id], 190)		

	if(equal(change_password_old[id], password_logar[id]))
	{
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5) 
		ShowSyncHudMsg(id, g_mensagens, "Type a new password to your account. ^nTip: Never put an old password.")
		EmitSound(id, BANK_ACCEPTED)
		client_cmd(id, "messagemode [CSGOM]New_Pass")
	}
	else
	{
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "Invalid password.")
		EmitSound(id, BANK_SENHA_RECUSADA)
		mostrar_menu_registro(id)
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

public cmd_change_password_new(id)
{
	if(!g_registrado[id])
		return PLUGIN_HANDLED
	
	read_args(change_password_new[id], charsmax(change_password_new))
	remove_quotes(change_password_new[id])
	trim(change_password_new[id])

	new symbol[30]; read_args(symbol, charsmax(symbol))
	remove_quotes(symbol)
	trim(symbol)
	
	if (!valid_symbol(change_password_new[id], strlen(change_password_new[id])))
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens,"You cannot use invalid chars or spaces on your password.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (strlen(change_password_new[id]) <= 2)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens,"You must use more than 3 characters.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (strlen(change_password_new[id]) >= 20)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens,"You cannot use more than 20 characters.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (equal(change_password_new[id], login_registro[id]))
	{
		mostrar_menu_registro(id)
			
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You cant use the same password as the nickname.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (contain(change_password_new[id], login_registro[id]) != -1)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 3.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You cant use some parts of your nickname on your password.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	
	set_dhudmessage(0, 255, 255, -1.0, 0.5, 0, 6.0, 3.0, 0.1, 0.1);
	show_dhudmessage(id, "...CHANGING PASSWORD & UPDATING DATA...");
	
	set_task(3.0, "salvando", id)
		
	nfv_set_data(register_data, register_key, login_logar[id], change_password_new[id])

	return PLUGIN_CONTINUE
}

public salvando(id)
{
	ChatColor(id, "Your password has been changed to: !g( %s )", change_password_new[id])
	EmitSound(id, BANK_ACCEPTED)	
}	

public sair_da_conta(id)
{
	if(!g_registrado[id]) return PLUGIN_HANDLED
	
	g_registrado[id] = false;
	g_tentativas[id] = 0
	
	login_registro[id] = ""
	password_registro[id] = ""
	password_confirm[id] = ""
	login_logar[id] = ""
	password_logar[id] = ""
	conta_banco[id] = ""
	
	user_silentkill(id)
	cs_set_user_team(id, CS_TEAM_UNASSIGNED)

	mostrar_menu_registro(id)
	return PLUGIN_HANDLED
}

public menu_ajuda(id)
{
	new menu = menu_create("\rHelp menu:", "menu_ajuda_handler")
		
	menu_additem(menu, "\wHow to register", "1")
	menu_additem(menu, "\wHow to login", "2")
	
	menu_setprop(menu, MPROP_EXITNAME, "\wExit")

	menu_display(id, menu, 0)
	
	return PLUGIN_HANDLED;
}

public menu_ajuda_handler(id, menu, item)
{
	if( item == MENU_EXIT )
	{
		mostrar_menu_registro(id)
		return PLUGIN_HANDLED;
	}

	new data[6], iName[64], access, callback;
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback);
	
	switch (str_to_num(data))
	{
		case 1: 
		{
			show_motd(id, "Register_Help.txt","How to regist")
			menu_ajuda(id)
		}
		case 2: 
		{
			show_motd(id, "Login_Help.txt","How to login")
			menu_ajuda(id)
		}
	}
	
	return PLUGIN_HANDLED;
}

public registrar_login(id)
{
	if(g_registrado[id]) return PLUGIN_HANDLED
	
	read_args(login_registro[id], 99)
	remove_quotes(login_registro[id])
	trim(login_registro[id])
	
	new symbol[30]; read_args(symbol, charsmax(symbol))
	remove_quotes(symbol)
	trim(symbol)

	if (!valid_symbol(symbol, strlen(symbol)))
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You cannot use invalid chars or spaces on your password.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (strlen(login_registro[id]) < 3)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You must use more than 3 characters.")
		EmitSound(id, BANK_LOCKED)
			
		return PLUGIN_HANDLED
	}
	if (strlen(login_registro[id]) > 20)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You cannot use more than 20 characters.")
		EmitSound(id, BANK_LOCKED)
			
		return PLUGIN_HANDLED
	}
	
	static data[128]
	if (nfv_get_data(register_data, register_key, login_registro[id], data, charsmax(data)))
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "This nickname already exists.")
		EmitSound(id, BANK_LOCKED)
	}
	else
	{
		client_cmd(id, "messagemode [CSGOM]Register_Pass")
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "Type a password to your account.^nObs:Use a secure password.")
		EmitSound(id, BANK_ACCEPTED)
	}

	return PLUGIN_CONTINUE
}

public registrar_senha(id)
{
	if(g_registrado[id]) return PLUGIN_HANDLED
	
	read_args(password_registro[id], 99)
	remove_quotes(password_registro[id])
	trim(password_registro[id])
	
	new symbol[30]; read_args(symbol, charsmax(symbol))
	remove_quotes(symbol)
	trim(symbol)
	
	if (!valid_symbol(symbol, strlen(symbol)))
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens,"You cannot use invalid chars or spaces on your password.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	
	if (strlen(password_registro[id]) <= 2)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens,"Sua Senha deve haver no minimo 3 Digitos.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (strlen(password_registro[id]) >= 20)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens,"Sua Senha deve haver no maximo 20 Digitos.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (equal(password_registro[id], login_registro[id]))
	{
		mostrar_menu_registro(id)
			
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You cant use the same password as the nickname.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	if (contain(password_registro[id], login_registro[id]) != -1)
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
	
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "You cant use some parts of your nickname on your password.")
		EmitSound(id, BANK_LOCKED)
		
		return PLUGIN_HANDLED
	}
	
	client_cmd(id, "messagemode [CSGOM]Confirm_Pass")
		
	ClearSyncHud(id , g_mensagens)
	
	set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
	ShowSyncHudMsg(id, g_mensagens, "Confirm your password")
	EmitSound(id, BANK_ACCEPTED)
		
	return PLUGIN_HANDLED;
}

public registrar_confirmar_senha(id)
{      
	if(g_registrado[id]) return PLUGIN_HANDLED
	
	read_args(password_confirm[id], 99)
	remove_quotes(password_confirm[id])
	trim(password_confirm[id])
       
	if(equal(password_registro[id], password_confirm[id]))
	{
		menu_confirm(id)
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "Verify your data to confirm your account.")
		EmitSound(id, BANK_ACCEPTED)
	}
	else
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)

		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "Wrong password.")
		EmitSound(id, BANK_LOCKED)
	}
	return PLUGIN_HANDLED
}

public menu_confirm(id)
{
	static item[255]
	
	formatex(item, charsmax(item), "\r( CSGOM ) \dFinish registration:^n^n\rYour nickname: \d%s^n\rYour password: \d%s", login_registro[id], password_registro[id])
	new menu = menu_create(item, "menu_confirm_handler")
		
	menu_additem(menu, "\wConfirm", "1")
	menu_additem(menu, "\wCancel", "2")
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER)

	menu_display(id, menu, 0)
	
	return PLUGIN_HANDLED;
}

public menu_confirm_handler(id, menu, item)
{
	new data[6], iName[64], access, callback;
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback);
	
	switch (str_to_num(data))
	{
		case 1: 
		{
			// Registrar Conta
			nfv_set_data(register_data, register_key, login_registro[id], password_registro[id])

			ClearSyncHud(id , g_mensagens)
			
			set_dhudmessage(0, 255, 255, -1.0, 0.5, 0, 6.0, 3.0, 0.1, 0.1);
			show_dhudmessage(id, "...SAVING ACCOUNT & UPDATING DATAS...");
			
			set_task(3.0, "registrando", id)
		}
		case 2: 
		{
			mostrar_menu_registro(id)
			
			ClearSyncHud(id , g_mensagens)
			
			set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
			ShowSyncHudMsg(id, g_mensagens, "Confirm your account again!")
			EmitSound(id, BANK_LOCKED)
		}
	}
	
	return PLUGIN_HANDLED;
}

public registrando(id)
{
	mostrar_menu_registro(id)
	
	ChatColor(id, "Your nickname: !g%s", login_registro[id])
	ChatColor(id, "Your password: !g%s", password_registro[id])
	
	EmitSound(id, BANK_ACESS_ACEITO)
}

public logar_login(id)
{
	if(g_registrado[id]) return PLUGIN_HANDLED
	
	read_args(login_logar[id], 99)
	remove_quotes(login_logar[id])
	trim(login_logar[id])
	
	new players[32], pnum, tempid
	get_players(players, pnum)
		
	for( new i; i<pnum; i++ )
	{
		tempid = players[i]
		
		if(id != tempid)
			if(equal(login_logar[id], login_logar[tempid]))
			{
				ClearSyncHud(id , g_mensagens)
				
				set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
				ShowSyncHudMsg(id, g_mensagens, "This acount is already logged in the server.")
				EmitSound(id, BANK_LOCKED)
				
				return PLUGIN_HANDLED
			}
	}
	new data[192]
	if(!nfv_get_data(register_data, register_key, login_logar[id], data, charsmax(data)))
	{
		mostrar_menu_registro(id)
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "This account does not exists!")
		EmitSound(id, BANK_LOCKED)
	}
	else
	{
		client_cmd(id, "messagemode [CSGOM]Account_Pass")
		
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "Type your account password.")
		EmitSound(id, BANK_ACCEPTED)
		
		return PLUGIN_HANDLED;
	}
	return PLUGIN_HANDLED;
}

public logar_senha(id)
{
	if(g_registrado[id]) return PLUGIN_HANDLED
	
 	read_args(password_logar[id], 99)
	remove_quotes(password_logar[id])
	trim(password_logar[id])

	new data[140]
	nfv_get_data(register_data, register_key, login_logar[id], data, charsmax(data))
	
	if(equali(data, password_logar[id]))
	{
		barTime(id, 0)
		ClearSyncHud(id , g_mensagens)
		remove_task(id + TASK_COUNTDOWN)
			
		set_dhudmessage(220, 80, 0, -1.0, 0.55, 0, 6.0, 4.0, 0.1, 0.1);
		show_dhudmessage(id, "...SUCCESSFULY LOGGED IN !!! LOADING YOUR DATA...");

		barTime(id, 4)
		set_task(4.0, "openJoinMenu", id)
		
		g_bCanSelectTeam[id] = true
		g_registrado[id] = true;
	}
	else
	{
		mostrar_menu_registro(id)
		
		g_tentativas[id]++
		if(g_tentativas[id] >= get_pcvar_num(cvar_tentativas))
		{
			server_cmd("amx_banip #%i %i ^"banned for %d minutes due many invalid passwords^"", get_user_userid(id), get_pcvar_num(cvar_bantime), get_pcvar_num(cvar_bantime))
		}
		ClearSyncHud(id , g_mensagens)
		
		set_hudmessage(1, 255, 1, 0.04, 0.15, 0, 3.0, 10.0, 0.04, 1.5)
		ShowSyncHudMsg(id, g_mensagens, "Incorrect password [ %d / %d ]", g_tentativas[id], get_pcvar_num(cvar_tentativas))
		ChatColor(id, "Attempts: !g%d !y/ !g%d", g_tentativas[id], get_pcvar_num(cvar_tentativas))
		EmitSound(id, BANK_SENHA_RECUSADA)
	}
	return PLUGIN_HANDLED
}

public openJoinMenu(id)
{
	client_cmd(id, "chooseteam")
	
	set_dhudmessage(220, 220, 220, -1.0, 0.3, 0, 6.0, 3.0, 0.1, 0.1);
	show_dhudmessage(id, "...DATA SUCCESSFULY LOADED...^nCHOOSE YOUR TEAM AND HAVE FUN");
}

public say_commands(id)
{
	if(!g_registrado[id]) return PLUGIN_HANDLED
	
	new text[70], arg1[32], arg2[32], arg3[6]
	read_args(text, sizeof(text) - 1)
	remove_quotes(text)
	arg1[0] = '^0'
	arg2[0] = '^0'
	arg3[0] = '^0'
	parse(text, arg1, sizeof(arg1) - 1, arg2, sizeof(arg2) - 1, arg3, sizeof(arg3) - 1)

	if (equali(arg1, "/", 1) || equali(arg1, ".", 1) || equali(arg1, "!", 1))
		format(arg1, 31, arg1[1])

	if (arg3[0])
		return PLUGIN_CONTINUE

	if (equali(arg1, "conta") || equali(arg1, "account") || equali(arg1, "registro")
	|| equali(arg1, "register") || equali(arg1, "reg") || equali(arg1, "login"))
	{
		mostrar_menu_registro(id)
		return PLUGIN_HANDLED
	}
	if (equali(arg1, "bkadmin") || equali(arg1, "bkadm"))
	{
		cmd_admin_menu(id)
		return PLUGIN_HANDLED
	}
	if( equali(arg1, "cash") )
	{
		if (!arg2[0])
		{
			ChatColor(id, "Your bank: !g( %i CSGOM )", csgom_getmoney(id))
			return PLUGIN_HANDLED
		}
		else
		{
			new id2 = cmd_target(id, arg2, 2)
			if (!id2)
				return PLUGIN_CONTINUE
					
			static id2name[32]
			get_user_name(id2, id2name, 31)
			
			ChatColor(id, "Player !g%s !yhas !g( %i CSGOM )", id2name, csgom_getmoney(id2))
			return PLUGIN_HANDLED

		}
	}
	else if( equali(arg1, "cash") )
	{
		if (!arg2[0])
		{	
			ChatColor(id, "You have !g( %i CSGOM )", csgom_getmoney(id))
			return PLUGIN_HANDLED
		}
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public cmd_admin_menu(id)
{
	new menu = menu_create("\r(CSGOM) \dBank:", "cmd_admin_menu_handler")

	menu_additem(menu, "Verify Data", "1")
	
	menu_additem(menu, "Remove Data \r[Make sure]", "2")
	menu_additem(menu, "Ban Data \r[Make sure]^n", "3")
	
	menu_setprop(menu, MPROP_BACKNAME, "Voltar")
	menu_setprop(menu, MPROP_NEXTNAME, "Proximo")
	menu_setprop(menu, MPROP_EXITNAME, "Sair")

	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0)

	return PLUGIN_HANDLED
}

public cmd_admin_menu_handler(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}
	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	new key = str_to_num(data)

	switch(key)
	{
		case ACTION_VERIFY_ACCOUNTDATA:
		{
			PL_ACTION = ACTION_VERIFY_ACCOUNTDATA
			formatex(szText, charsmax(szText), "\ySelect a player")
			cmd_admin_submenu_playerlist(id)
		}
		case ACTION_REMOVE_ACCOUNTDATA:
		{
			PL_ACTION = ACTION_REMOVE_ACCOUNTDATA
			formatex(szText, charsmax(szText), "\ySelect a player \r[Make sure]")
			cmd_admin_submenu_playerlist(id)
		}
		case ACTION_BAN_ACCOUNTDATA:
		{
			PL_ACTION = ACTION_BAN_ACCOUNTDATA
			formatex(szText, charsmax(szText), "\ySelect a player")
			cmd_admin_submenu_playerlist(id)
		}
	}
	return PLUGIN_HANDLED;
}

public cmd_admin_submenu_playerlist(id)
{
	new menu = menu_create(szText, "cmd_admin_submenu_handler")

	new players[32], pnum, tempid
	new szName[32], szTempid[10]
	get_players(players, pnum)
	for(new i; i<pnum; i++)
	{
		tempid = players[i]

		get_user_name(tempid, szName, 31)
		num_to_str(tempid, szTempid, 9)

		menu_additem(menu, szName, szTempid, 0)
	}
	menu_setprop(menu, MPROP_BACKNAME, "\wBack")
	menu_setprop(menu, MPROP_NEXTNAME, "\wNext")
	menu_setprop(menu, MPROP_EXITNAME, "\wExit")
	menu_display(id, menu, 0);
	return PLUGIN_HANDLED
}

public cmd_admin_submenu_handler(id, menu, item)
{
	if(item == MENU_EXIT)
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}
	new data[6], iName[64]
	new access, callback
	menu_item_getinfo(menu, item, access, data,5, iName, 63, callback)
	PlayerID[id] = str_to_num(data)
	
	new AdminName[32]; get_user_name(id, AdminName, 31)
	new PlayerName[32]; get_user_name(PlayerID[id], PlayerName, 31)

	if(!is_user_connected(PlayerID[id]))
	{
		ChatColor(id, "Player !g%s !yis not on the server.", PlayerName)
		EmitSound(id, BANK_LOCKED)
		cmd_admin_menu(id)
		return PLUGIN_HANDLED
	}
	if(!g_registrado[PlayerID[id]])
	{
		ChatColor(id, "Player !g%s !yis not logged in.", PlayerName)
		EmitSound(id, BANK_LOCKED)
		cmd_admin_menu(id)
		return PLUGIN_HANDLED
	}
	switch (PL_ACTION)
	{
		case ACTION_VERIFY_ACCOUNTDATA:
		{		
			static motd[1500], len; len = 0
			len += formatex(motd[len], charsmax(motd) - len, "html><head><style type=^"text/css^">body{background-color: #000000;font-family:Verdana,Tahoma;}</style><meta http-equiv=^"Content-Type^" content=^"text/html; charset=windows-1257^"><font size=^"3^" color=^"#e0a518^"><b><center>Player account: %s</center></b></font></head><p><br /><font size=^"3^" color=^"#c0c0ff^">", PlayerName)
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"2^" color=#ff0000><center> > CSGOM <</font></center>")
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"1^" color=#ff0000><center> Nickname: <font color=#00c000>%s</font></center>", login_logar[PlayerID[id]])
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"1^" color=#ff0000><center> Password: <font color=#00c000>%s</font></center>", password_logar[PlayerID[id]])
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"1^" color=#ff0000><center> Bank value: <font color=#00c000>%i</font></center>", csgom_getmoney(PlayerID[id]))
			show_motd(id, motd)
			return PLUGIN_HANDLED
		}
		case ACTION_REMOVE_ACCOUNTDATA:
		{
			set_hudmessage(random_num(0,255), random_num(0,255), random_num(0,255), -1.0, -0.5, 1, 5.0, 5.0)
			show_hudmessage(0, "ADMIN: '%s'^nRemoved an account: '%s'^nOwner of '%s' was: '%s'", AdminName, login_logar[PlayerID[id]], login_logar[PlayerID[id]], PlayerName)
			
			nfv_take_data(register_data, register_key, login_logar[PlayerID[id]])
			sair_da_conta(PlayerID[id])
			
			static motd[1500], len; len = 0
			len += formatex(motd[len], charsmax(motd) - len, "html><head><style type=^"text/css^">body{background-color: #000000;font-family:Verdana,Tahoma;}</style><meta http-equiv=^"Content-Type^" content=^"text/html; charset=windows-1257^"><font size=^"2^" color=^"#e0a518^"><b><center>Account Data Removed</center></b></font></head><p><br /><font size=^"1^" color=^"#c0c0ff^">")
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"2^" color=#ff0000><center> Admin: <font color=#00c000>%s</font></center>", AdminName)
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"2^" color=#ff0000><center> Removed all data of your account</font></center>")
			show_motd(PlayerID[id], motd)
			return PLUGIN_HANDLED
		}
		case ACTION_BAN_ACCOUNTDATA:
		{
			set_hudmessage(random_num(0,255), random_num(0,255), random_num(0,255), -1.0, -0.5, 2, 5.0, 5.0)
			show_hudmessage(0, "Admin: '%s'^nBaned an account: '%s'^nOwner of: '%s' was: '%s'", AdminName, login_logar[PlayerID[id]], login_logar[PlayerID[id]], PlayerName)
			
			nfv_prune(register_key, login_logar[PlayerID[id]], -1, -1)
			sair_da_conta(PlayerID[id])

			static motd[1500], len; len = 0
			len += formatex(motd[len], charsmax(motd) - len, "html><head><style type=^"text/css^">body{background-color: #000000;font-family:Verdana,Tahoma;}</style><meta http-equiv=^"Content-Type^" content=^"text/html; charset=windows-1257^"><font size=^"2^" color=^"#e0a518^"><b><center>Account Data Banned</center></b></font></head><p><br /><font size=^"1^" color=^"#c0c0ff^">")
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"2^" color=#ff0000><center> Admin: <font color=#00c000>%s</font></center>", AdminName)
			len += formatex(motd[len], charsmax(motd) - len, "<p><font size=^"2^" color=#ff0000><center> Banned your account</font></center>")
			show_motd(PlayerID[id], motd)
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_HANDLED
}

stock EmitSound(id, sound)
{
	switch(sound)
	{
		case BANK_LOCKED: client_cmd(id, "spk csgom/error")
		case BANK_ACESS_ACEITO: client_cmd(id, "spk ^"access granted^"");
		case BANK_SENHA_RECUSADA: client_cmd(id, "spk ^"access denied^"");	
		case BANK_WELCOME: client_cmd(id, "mp3 play ^"%s^"", MP3_ENTRADA) 	
	}
}

public fw_PreThink(iPlayer)
{
	if(g_registrado[iPlayer])
	{
		return FMRES_IGNORED;
	}
	
	static iMsgScreenFade;
	if (!iMsgScreenFade)
	{
		iMsgScreenFade = get_user_msgid("ScreenFade");
	}
	
	message_begin(MSG_ONE, iMsgScreenFade, _, iPlayer);
	write_short((1<<12));
	write_short(0);
	write_short(0x0004);
	write_byte(1);
	write_byte(1);
	write_byte(1);
	write_byte(255);
	message_end();
	
	return FMRES_IGNORED;
}

bool:valid_symbol(iMessage[], iLength)
{
	new bool:bReturn = true
	for(new i;i < iLength;i++)
	{
		if(!isalnum(iMessage[i]))
		{
			bReturn = false
			break
		}
	}
	return bReturn
}

barTime(id, iTime)
{
	if(is_user_connected(id))
	{
		message_begin(MSG_ONE, g_mMessageBarTime, .player = id)
		write_short(iTime)
		message_end()  
	}
}
