#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <xs>

#define MAX_PLAYERS		32

enum
{
	normal,
	slower,
	medium
}

const m_pPlayer  = 		41
const XoCGrenade = 		4

new const GrenadeClassNames[][] =
{
	"weapon_flashbang",
	"weapon_hegrenade",
	"weapon_smokegrenade"
}

new const Float:VelocityMultiplier[] =
{
	1.0,
	0.5,
	0.7
}

new HandleThrowType[MAX_PLAYERS+1]
new bool:g_bIsFreezeTime

public plugin_init()
{
	new const PluginVersion[] = "1.2"
	register_plugin("CSGOM: Pop Grenades",PluginVersion,"EFFx/HamletEagle")

	register_event("HLTV", "freezeTimeStart", "a", "1=0", "2=0")  
	register_logevent("freezeTimeEnd", 2, "1=Round_Start") 
	
	for(new i; i < sizeof GrenadeClassNames; i++)
	{
		RegisterHam(Ham_Item_Deploy, GrenadeClassNames[i], "CBasePlayerWpn_Deploy", false)
		RegisterHam(Ham_Weapon_SecondaryAttack, GrenadeClassNames[i], "CBasePlayerWpn_SecondaryAttack", false)
	}
}

public CBasePlayerWpn_Deploy(const grenadeEntity)
{
	HandleThrowType[get_pdata_cbase(grenadeEntity, m_pPlayer, XoCGrenade)] = normal
}

public freezeTimeStart()
{
	g_bIsFreezeTime = true
}

public freezeTimeEnd()
{
	g_bIsFreezeTime = false
}

public CBasePlayerWpn_SecondaryAttack(const grenadeEntity)
{
	if(pev_valid(grenadeEntity) && !g_bIsFreezeTime)
	{
		new id = get_pdata_cbase(grenadeEntity, m_pPlayer, XoCGrenade)
		new buttons = pev(id, pev_button)
		
		if(buttons & IN_ATTACK)
		{
			HandleThrowType[id] = medium
		}
		else 
		{
			HandleThrowType[id] = slower
		}
		
		ExecuteHamB(Ham_Weapon_PrimaryAttack, grenadeEntity)
	}
}

public grenade_throw(id, grenadeEntity, grenadeWeaponIndex) 
{
	if(pev_valid(grenadeEntity))
	{
		new Float:grenadeVelocity[3]
		pev(grenadeEntity, pev_velocity, grenadeVelocity)
		
		new Float:multiplier = VelocityMultiplier[HandleThrowType[id]]
		xs_vec_mul_scalar(grenadeVelocity, multiplier, grenadeVelocity)
		set_pev(grenadeEntity, pev_velocity, grenadeVelocity)
		
		HandleThrowType[id] = normal
	}
}  
