#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <hamsandwich>
#include <csgom>
#include <nvault>
#include <nvault_util>
#include <nvault_array>
#include <time>

#if AMXX_VERSION_NUM < 183
#define client_disconnected		client_disconnect
#endif

#define MAX_EXP 			3000
#define STATS_KILLS            	 	0
#define STATS_DEATHS           	 	1
#define MAX_POSITIONS			10

#define STATS_KILLS            	 	0
#define STATS_DEATHS            	1
#define STATS_HS                	2

enum _:dData
{
	szRankName[32],
	iPontos
}

new const g_mPlayerData[][dData] = 
{
	{"Unranked", 0},
	{"Silver I", 50},
	{"Silver II", 75},
	{"Silver III", 100},
	{"Silver IV", 125},
	{"Silver Elite", 150},
	{"Silver Elite Master", 175},
	{"Gold Nova I", 225},
	{"Gold Nova II", 275},
	{"Gold Nova III", 325},
	{"Gold Nova Master", 375},
	{"Master Guardian I", 425},
	{"Master Guardian II", 475},
	{"Master Guardian Elite", 550},
	{"DMG", 650},
	{"Legendary Eagle", 750},
	{"Legendary Eagle Master", 1000},
	{"Supreme", 2000},
	{"The Global Elite", MAX_EXP}
}

new g_iMaxRanks = sizeof g_mPlayerData - 1

new const g_szRankUpSound[] = 		"events/task_complete.wav"

const CONST_SHOTGUNS =			(1 << CSW_M3)|(1 << CSW_XM1014)
const CONST_PISTOLS =			(1 << CSW_USP)|(1 << CSW_GLOCK18)|(1 << CSW_DEAGLE)|(1 << CSW_ELITE)|(1 << CSW_FIVESEVEN)|(1 << CSW_P228)
const CONST_RIFLES = 			(1 << CSW_MAC10)|(1 << CSW_AUG)|(1 << CSW_UMP45)|
					(1 << CSW_GALIL)|(1 << CSW_FAMAS)|(1 << CSW_MP5NAVY)|
					(1 << CSW_M4A1)|(1 << CSW_TMP)|(1 << CSW_SG552)|
					(1 << CSW_AK47)|(1 << CSW_P90)|(1 << CSW_SCOUT)|
					(1 << CSW_M249)|(1 << CSW_SG550)|(1 << CSW_G3SG1)|
					(1 << CSW_AWP)

new g_iMsgSayText

native is_user_registered(id)
native getUserActivity(id)

new g_nVault, g_nVaultTop
new const VaultName[] = "rank_top15"

new g_hHudPrintAlive, g_hHudPrintDead

const OFFSET_CSMENUCODE = 205

enum PlayerData
{
	PlayerName[32],
	iELO,
	iRank,
	iUserHeadShots,
	iUserKills,
	iHsRatio
}

new g_iUserData[MAX_PLAYERS + 1][ PlayerData ]
const MaxPlayerSupport = 3000

new g_AuthID[MAX_PLAYERS + 1][34]

public plugin_init() 
{
	new const Version[] = "1.2"
	register_plugin("CSGOM: Rank", Version, "EFFx")
	
	register_dictionary("time.txt")
	
	register_cvar("EFFx_rank_system", Version, FCVAR_SERVER|FCVAR_SPONLY)
	register_menucmd(register_menuid("Top15 Menu"), 1023, "rank_handler")
	
	register_logevent("BombPlanted", 3, "2=Planted_The_Bomb")
	register_logevent("BombDefused", 3, "2=Defused_The_Bomb")
	register_event("DeathMsg", "event_Death", "a")
	
	g_nVault = nvault_open("Level")
	if((g_nVaultTop = nvault_open(VaultName)) == INVALID_HANDLE )
	{
		set_fail_state( "Failed to open vault" );
	}
	
	g_hHudPrintAlive = CreateHudSyncObj()
	g_hHudPrintDead = CreateHudSyncObj()
	
	register_concmd("amx_give_elo", "cmdGiveELO", ADMIN_KICK, "<nick> <value> - give/took ELO to an user (use negative value to take from)")
	
	register_clcmd("say", "cmdSay")
	register_clcmd("say_team", "cmdSayTeam")
	register_clcmd("say /rank", "cmdRank")
	
	register_clcmd("say /top15", "cmdTop10")
	register_clcmd("say .top15", "cmdTop10")
	
	register_message((g_iMsgSayText = get_user_msgid("SayText")), "col_changer")
	set_task(1.0, "printMoney", .flags = "b")
}

public plugin_end() nvault_close(g_nVault)
	
public plugin_precache()
{
	precache_sound(g_szRankUpSound)
}

public plugin_natives()
{
	register_native("get_user_elo", "_getelo", 1)
	register_native("set_user_elo", "_setelo")
}

public _getelo(id) return g_iUserData[id][iELO]

public _setelo()
{
	new id = get_param(1)
	g_iUserData[id][iELO] = get_param(2)
	saveData(id)	
}

new g_menuPosition[33]

public BombPlanted()
{
	new id = getUserId()
	if(isEnemyTeamWithPlayers(id))
	{
		ChatColor(id, "You got^x04 +3^x01 ELO point for planting the bomb!")
		
		g_iUserData[id][iELO] += 3
		saveData(id)
	}
}

public BombDefused()
{
	new id = getUserId()
	if(isEnemyTeamWithPlayers(id))
	{
		ChatColor(id, "You got^x04 +3^x01 ELO point for defusing the bomb!")
		
		g_iUserData[id][iELO] += 3
		saveData(id)
	}
}

isEnemyTeamWithPlayers(id)
{
	new iPlayers[32], iNum
	get_players(iPlayers, iNum, "e", (get_user_team(id) == 2) ? "TERRORIST" : "CT")
	return bool:(iNum > 1)
}

getUserId()
{
	new LogUser[80], szName[MAX_PLAYERS]
	read_logargv(0, LogUser, charsmax(LogUser))
	parse_loguser(LogUser, szName, charsmax(szName))

	return get_user_index(szName)
}

public cmdGiveELO(id, iLevel, iCid)
{
	if(!cmd_access(id, iLevel, iCid, 3))
		return PLUGIN_HANDLED

	new szTarget[MAX_PLAYERS], szValue[10]
	read_argv(1, szTarget, charsmax(szTarget))
	read_argv(2, szValue, charsmax(szValue))
	
	new iTarget = cmd_target(id, szTarget, CMDTARGET_NO_BOTS)
	if(!iTarget)
		return PLUGIN_HANDLED
		
	new szAdminName[MAX_PLAYERS], szTargetName[MAX_PLAYERS]
	get_user_name(id, szAdminName, charsmax(szAdminName))
	get_user_name(iTarget, szTargetName, charsmax(szTargetName))
	
	new iValue = str_to_num(szValue)
	new bool:bValueType = bool:(containi(szValue, "-") != -1)

	g_iUserData[iTarget][iELO] += iValue
	
	new iNewRankID = g_iUserData[iTarget][iRank]
	for(new i;i < sizeof g_mPlayerData;i++)
	{
		if(g_iUserData[iTarget][iELO] > g_mPlayerData[i][iPontos])
		{
			iNewRankID = i
		}
	}
	g_iUserData[iTarget][iRank] = min(iNewRankID, g_iMaxRanks)
	
	ChatColor(0, "Admin^x04 %s^x01 %s^x04 %d^x01 ELO%s %s^x01 %s.", szAdminName, bValueType ? "took" : "gave", iValue, (iValue > 1) ? "S" : "", bValueType ? "from" : "to", szTargetName)
	saveData(iTarget)
	return PLUGIN_HANDLED
}

public event_Death()
{
	new iKiller = read_data(1), iVictim = read_data(2)
	if(!is_user_connected(iVictim))
		return
		
	new iDefaultValues[4], iValueToAdd
	iDefaultValues[0] = 3
	iDefaultValues[2] = 3
	iDefaultValues[3] = 2
	
	g_iUserData[iKiller][iUserKills]++
	if(read_data(3))
	{
		g_iUserData[iKiller][iUserHeadShots]++
	}
	g_iUserData[iKiller][iHsRatio] = floatround(float(g_iUserData[iKiller][iUserKills]) / float(g_iUserData[iKiller][iUserHeadShots]))
	switch(g_iUserData[iKiller][iHsRatio])
	{
		case 5: iValueToAdd = 1
		case 10: iValueToAdd = 2
		case 20: iValueToAdd = 3
		case 35: iValueToAdd = 4
		case 50: iValueToAdd = 5
		case 65: iValueToAdd = 6
		case 80: iValueToAdd = 7
	}

	if(iValueToAdd)
	{
		for(new i;i < sizeof iDefaultValues;i++)
		{
			iDefaultValues[i] = iValueToAdd
		}
	}
	
	if(iKiller == iVictim)
	{
		iDefaultValues[0] = 0
		iDefaultValues[1] = 0
		iDefaultValues[2] = 0
		iDefaultValues[3] = 0
	}
	
	new szWeapon[17]
	read_data(4, szWeapon, charsmax(szWeapon))
	if(containi(szWeapon, "knife") != -1)
	{
		g_iUserData[iKiller][iELO] += iDefaultValues[0]
		
		g_iUserData[iVictim][iELO] -= 3
		checkRankDown(iVictim)
	}
	else if(containi(szWeapon, "grenade") != -1)
	{
		g_iUserData[iKiller][iELO] += iDefaultValues[1]
		g_iUserData[iVictim][iELO] -= 3
		checkRankDown(iVictim)
	}
	else
	{
		if(read_data(3))
		{
			g_iUserData[iVictim][iELO] -= 2
			checkRankDown(iVictim)
			
			g_iUserData[iKiller][iELO] += iDefaultValues[2]
		}
		else 
		{
			g_iUserData[iVictim][iELO] -= 1
			checkRankDown(iVictim)
			
			g_iUserData[iKiller][iELO] += iDefaultValues[3]
		}
	}
	
	new iNextRankXpValue
	if(g_iUserData[iKiller][iRank] < g_iMaxRanks)
	{
		iNextRankXpValue = g_mPlayerData[g_iUserData[iKiller][iRank] + 1][iPontos]
	}
	
	new szKillerName[32]
	get_user_name(iKiller, szKillerName, charsmax(szKillerName))
	
	if(iNextRankXpValue && (g_iUserData[iKiller][iELO] >= iNextRankXpValue))
	{
		g_iUserData[iKiller][iRank] = clamp((g_iUserData[iKiller][iRank] + 1), 0, g_iMaxRanks)	
			
		ChatColor(iKiller, "Congratulations, you've ranked up to:^x04 %s!", g_mPlayerData[g_iUserData[iKiller][iRank]][szRankName])
		ChatColor(0, "Player^x04 %s^x01 has been ranked up to:^x04 %s", szKillerName, g_mPlayerData[g_iUserData[iKiller][iRank]][szRankName])
		client_cmd(0, "spk ^"%s^"", g_szRankUpSound)
	}
	
	if(g_iUserData[iVictim][iELO] < 0)
	{
		g_iUserData[iVictim][iELO] = 0
	}
	saveData(iKiller)
	saveData(iVictim)
}

checkRankDown(iUserID)
{
	new iCurrentRank = g_iUserData[iUserID][iRank], iActualRankToCheck
	for(new i;i < sizeof g_mPlayerData;i++)
	{
		if(g_iUserData[iUserID][iELO] > g_mPlayerData[i][iPontos])
		{
			iActualRankToCheck = i
		}
	}
	
	if(iCurrentRank > iActualRankToCheck)
	{
		g_iUserData[iUserID][iRank] = iActualRankToCheck
		
		ChatColor(iUserID, "Sadly, you've turned back to to:^x04 %s!", g_mPlayerData[g_iUserData[iUserID][iRank]][szRankName])
		saveData(iUserID)
	}	
}

public client_connect(id)
{
	loadData(id)

	get_user_authid(id, g_AuthID[id], charsmax(g_AuthID[]))
	nvault_get_array(g_nVaultTop, g_AuthID[id], g_iUserData[id][PlayerData:0], sizeof(g_iUserData[]))
}

public client_authorized(id)
{
        get_user_name(id, g_iUserData[id][PlayerName], charsmax(g_iUserData[][PlayerName]))
        nvault_set_array(g_nVaultTop, g_AuthID[id], g_iUserData[id][PlayerData:0], sizeof(g_iUserData[]))
}

public cmdTop10(id)
{
	displayTop15(id, g_menuPosition[id] = 0)
}

displayTop15(id, iPosition, bool:bReturnPosition = false)
{
	if(!bReturnPosition && iPosition < 0)
		return 0
		
	new iStart = iPosition * 6
	new iEnd = iStart + 6
	
	new iVault, iCount
	iVault = nvault_util_open(VaultName)
	iCount = nvault_util_count(iVault)
	
	new iMax = clamp(iCount, 1, 15)
	if(iMax > iCount)
	{
		iMax = iCount
	}
	else if(iEnd > iMax)
	{
		iEnd = iMax
	}
	
	new keys = MENU_KEY_0
	enum _:Info
	{
		nVaultOffset,
		iUserELO,
		iR
	}

	static iSortData[MaxPlayerSupport][Info]
	new iRow, iNextOffset, iCurrentOffset, szKey[45], iReturnValue, pdVal[PlayerData]

	nvault_close(g_nVaultTop)
	g_nVaultTop = nvault_open(VaultName)
	
	for(iRow = 0; iRow < iCount && iRow < MaxPlayerSupport; iRow++)
	{
		iNextOffset = nvault_util_read_array(iVault, iNextOffset, szKey, charsmax(szKey), pdVal[PlayerData:0], sizeof(pdVal))
		
		iSortData[iRow][nVaultOffset] = iCurrentOffset
		iSortData[iRow][iUserELO] = pdVal[iELO]
		iSortData[iRow][iR] = pdVal[iRank]
		
		iCurrentOffset = iNextOffset
	}
	
	SortCustom2D(iSortData, min(iCount, MaxPlayerSupport), "CompareStats")
	
	static menu[5000]
	formatex(menu, charsmax(menu), "\r[ \wCSGOM \d| \yTOP15\r ]^n^n")
	
	for(iRow = iStart;iRow < iEnd;++iRow)
	{
		iCurrentOffset = iSortData[iRow][nVaultOffset]
		nvault_util_read_array(iVault, iCurrentOffset, szKey, charsmax(szKey), pdVal[PlayerData:0], sizeof(pdVal))

		if(bReturnPosition && (equal(g_AuthID[id], szKey)))
		{
			iReturnValue = (iRow + 1)
			break
		}
		
		formatex
		(
			menu, 
			charsmax(menu),
			"%s\r[%d]\y %s\d -\r %d\w ELO \d|\w Rank:\r %s^n",
			menu,
			(iRow + 1),
			pdVal[PlayerName],
			pdVal[iELO],
			g_mPlayerData[pdVal[iRank]][szRankName]
		)
	}
	nvault_util_close(iVault)
	if(iEnd != iMax)
	{
		formatex(menu, charsmax(menu), "%s^n\wPess \y9\w for more^n\wPress\y 0\w to %s", menu, iPosition ? "turn back" : "exit")
		keys |= MENU_KEY_9
	}
	else
	{
		formatex(menu, charsmax(menu), "%s^n\wPress\y 0\w to %s", menu, iPosition ? "turn back" : "exit")
	}
	
	if(!bReturnPosition)
	{
		set_pdata_int(id, OFFSET_CSMENUCODE, 0)
		show_menu(id, keys, menu, -1, "Top15 Menu")
	}
	return iReturnValue
}

public CompareStats(elem1[], elem2[]) 
{ 
	if(elem1[1] > elem2[1]) 
		return -1
	else if(elem1[1] < elem2[1]) 
		return 1
	
	return 0; 
} 

public rank_handler(id, iItem)
{
	switch(iItem)
	{
		case 8:
		{
			displayTop15(id, ++g_menuPosition[id]);
		}
		case 9:
		{
			displayTop15(id, --g_menuPosition[id]);
		}
	}
	return PLUGIN_HANDLED
}

public printMoney()
{
	static iCount
	iCount = nvault_util_count(nvault_util_open(VaultName))
	
	set_hudmessage(40, 21, 60, 0.02, 0.25, 0, 1.0, 1.0)
	
	new iPlayers[MAX_PLAYERS], iNum, szUserMusicKit[MAX_PLAYERS], szBalance[50], szRankStatus[50]
	get_players(iPlayers, iNum, "a")
	if(!iNum)
		return
		
	for(new i, id;i < iNum;i++)
	{
		if(!is_user_registered((id = iPlayers[i])))
			continue
			
		if(is_user_alive(id))
		{
			formatex(szBalance, charsmax(szBalance), "Balance:^n- %d CSGO Coins^n- %d CSGO Gold", csgom_getmoney(id), csgom_get_goldmoney(id))
		}

		getUserMusicKit(id, szUserMusicKit)
		
		if(!g_iUserData[id][iRank])
		{
			formatex(szRankStatus, charsmax(szRankStatus), "- Not yet positioned")
		}
		else formatex(szRankStatus, charsmax(szRankStatus), "- %d of %d players", displayTop15(id, 0, true), iCount)
		
		ShowSyncHudMsg
		(
			id, 
			g_hHudPrintAlive,
			"Music Kit: %s^n^n%s^n^nRank:^n- %d ELO^n- %s^n%s", 
			szUserMusicKit,
			szBalance,
			g_iUserData[id][iELO],
			g_mPlayerData[g_iUserData[id][iRank]][szRankName],
			szRankStatus
		)
	}
	
	set_hudmessage(40, 21, 60, 0.02, 0.25, 0, 1.0, 1.0)
	get_players(iPlayers, iNum, "b")
	if(!iNum)
		return

	for(new i, id, iSpectating, szSpectatingName[MAX_PLAYERS];i < iNum;i++)
	{
		id = iPlayers[i]
		
		iSpectating = entity_get_int(id, EV_INT_iuser2)
		if(!iSpectating || !is_user_connected(iSpectating))
			continue
			
		getUserMusicKit(iSpectating, szUserMusicKit)
		get_user_name(iSpectating, szSpectatingName, charsmax(szSpectatingName))
		formatex(szBalance, charsmax(szBalance), "Balance:^n- %d CSGO Coins^n- %d CSGO Gold", csgom_getmoney(iSpectating), csgom_get_goldmoney(iSpectating))
		
		if(!g_iUserData[iSpectating][iRank])
		{
			formatex(szRankStatus, charsmax(szRankStatus), "- Not yet positioned")
		}
		else formatex(szRankStatus, charsmax(szRankStatus), "- %d of %d players", displayTop15(iSpectating, 0, true), iCount)
		
		ShowSyncHudMsg
		(
			id, 
			g_hHudPrintDead,
			"Spectating %s:^n^nMusic Kit: %s^n^n%s^n^nRank:^n- %d ELO^n- %s^n%s", 
			szSpectatingName,
			szUserMusicKit,
			szBalance,
			g_iUserData[iSpectating][iELO],
			g_mPlayerData[g_iUserData[iSpectating][iRank]][szRankName],
			szRankStatus
		)
	}
}

public cmdRank(id)
{
	new szUserActivity[50]
	get_time_length(id, (getUserActivity(id) * 60), 0, szUserActivity, charsmax(szUserActivity))
	
	static iCount
	iCount = nvault_util_count(nvault_util_open(VaultName))
	
	ChatColor(id, "^x04========================================")
	ChatColor(id, "Your position in the server's rank system:^x04 %d^x01 of^x04 %d^x01 players.", displayTop15(id, 0, true), iCount)
	
	if(g_iUserData[id][iELO] >= MAX_EXP)
	{
		ChatColor(id, "Your rank:^x04 %s^x01, ELO:^x04 %d^x01, Activity:^x04 %s.", g_mPlayerData[g_iUserData[id][iRank]][szRankName], g_iUserData[id][iELO], szUserActivity[0] ? szUserActivity : "Less than 1 minute")
	}
	else
	{		
		ChatColor(id, "Your rank:^x04 %s^x01, ELO:^x04 %d^x01, Activity:^x04 %s.", g_mPlayerData[g_iUserData[id][iRank]][szRankName], g_iUserData[id][iELO], szUserActivity[0] ? szUserActivity : "Less than 1 minute")
	}
	ChatColor(id, "^x04========================================")
	return PLUGIN_HANDLED
}


public col_changer(msg_id, msg_dest, rcvr)
{
	static sBuffer[23]
	get_msg_arg_string(2,sBuffer,charsmax(sBuffer))
	
	if(equal(sBuffer,"#Cstrike_Name_Change")) 
		return PLUGIN_HANDLED

	return PLUGIN_HANDLED
}

public cmdSay(id)
{
	new szMessage[192], szMsg[192]
	read_args(szMessage, charsmax(szMessage))
	remove_quotes(szMessage)
	
	switch(szMessage[0])
	{
		case '/', '.', '!', '@', ' ', EOS:
		{
			return PLUGIN_CONTINUE
		}
	}

	new szUserName[32]
	get_user_name(id, szUserName, charsmax(szUserName))

	new szColor[11]
	get_user_team(id, szColor, charsmax(szColor))
	
	new szPatente[32]
	formatex(szPatente, charsmax(szPatente), g_mPlayerData[g_iUserData[id][iRank]][szRankName])
	
	new szTag[32]
	if(has_flag(id, "a"))
		copy(szTag, charsmax(szTag), "[Owner] ")
		
	else if(has_flag(id, "n"))
		copy(szTag, charsmax(szTag), "[CO-Owner] ")
		
	else if(has_flag(id, "q"))
		copy(szTag, charsmax(szTag), "[Admin] ")
		
	else if(has_flag(id, "b")) 
		copy(szTag, charsmax(szTag), "[VIP] ")

	else if(has_flag(id, "u")) 
		copy(szTag, charsmax(szTag), "[Pawner] ")
	
	formatex(szMsg, charsmax(szMsg), "^x03%s ^x04[%d ELO] ^x01[^x04%s^x01] ^x04%s^x03%s^x01 :%s %s", is_user_alive(id) ? "" : "*DEAD* ", g_iUserData[id][iELO], szPatente, szTag, szUserName, (szTag[0] || (g_iUserData[id][iELO] >= MAX_EXP)) ? "^x04" : "", szMessage)
	
	new iPlayers[32], iNum
	get_players(iPlayers, iNum, !is_user_alive(id) ? "b" : "")
	for(new i;i < iNum;i++)
	{
		showMsg(iPlayers[i], szColor, szMsg)
	}
	return PLUGIN_CONTINUE
}

public cmdSayTeam(id)
{
	new szMessage[192], szMsg[192]
	read_args(szMessage, charsmax(szMessage))
	remove_quotes(szMessage)
	
	switch(szMessage[0])
	{
		case '/', '.', '!', '@', EOS:
		{
			return PLUGIN_CONTINUE
		}
	}
	
	new szUserName[32], szChatTeam[23]
	get_user_name(id, szUserName, charsmax(szUserName))
	
	switch(get_user_team(id))
	{
		case 1:	
		{
			szChatTeam = "(Terrorists)"
		}
		case 2:	
		{
			szChatTeam = "(Counter-Terrorists)"
		}
		default:	
		{
			szChatTeam = "(Spectator)"
		}
	}

	new szColor[11]
	get_user_team(id, szColor, charsmax(szColor))
	
	new szPatente[32]
	formatex(szPatente, charsmax(szPatente), g_mPlayerData[g_iUserData[id][iRank]][szRankName])
	
	new szTag[32]
	if(has_flag(id, "a"))
		copy(szTag, charsmax(szTag), "[Owner] ")
		
	else if(has_flag(id, "n"))
		copy(szTag, charsmax(szTag), "[CO-Owner] ")
		
	else if(has_flag(id, "q"))
		copy(szTag, charsmax(szTag), "[Admin] ")
		
	else if(has_flag(id, "b")) 
		copy(szTag, charsmax(szTag), "[VIP] ")

	else if(has_flag(id, "u")) 
		copy(szTag, charsmax(szTag), "[Pawner] ")

	formatex(szMsg, charsmax(szMsg), "^x01%s %s ^x04[%d ELO] ^x01[^x04%s^x01]^x04 %s^x03 %s^x01 :%s %s", szChatTeam, (is_user_alive(id)) ? "" : "*DEAD* ", g_iUserData[id][iELO], szPatente, szTag, szUserName, (szTag[0] || (g_iUserData[id][iELO] >= MAX_EXP)) ? "^x04" : "", szMessage)
	
	new iPlayers[32], iNum
	get_players(iPlayers, iNum, "e", (get_user_team(id) == 1) ? "TERRORIST" : "CT")
	for(new i;i < iNum;i++)
	{
		showMsg(iPlayers[i], szColor, szMsg)
	}
	return PLUGIN_CONTINUE
}

showMsg(iPlayer, szColor[], szMsg[])
{
	new szTeamName[11]
	get_user_team(iPlayer, szTeamName, charsmax(szTeamName))

	changeTeamInfo(iPlayer, szColor)
	displayMessage(iPlayer, szMsg)
	changeTeamInfo(iPlayer, szTeamName)
}

changeTeamInfo(iPlayer, szTeam[])
{
	message_begin(MSG_ONE, get_user_msgid("TeamInfo"), .player = iPlayer)
	write_byte(iPlayer)
	write_string(szTeam)
	message_end()
}

displayMessage(iPlayer, szMsg[])
{
	message_begin(MSG_ONE, g_iMsgSayText, .player = iPlayer)
	write_byte(iPlayer)
	write_string(szMsg)
	message_end()
}

saveData(id)
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save", szSteam)
	format(vaultdata, charsmax(vaultdata), "%i %i %i %i %i", g_iUserData[id][iELO], g_iUserData[id][iHsRatio], g_iUserData[id][iUserKills], g_iUserData[id][iUserHeadShots], g_iUserData[id][iRank])
	
	nvault_set(g_nVault, vaultkey, vaultdata)
	nvault_set_array(g_nVaultTop, g_AuthID[id], g_iUserData[id][PlayerData:0], sizeof(g_iUserData[]))
}

loadData(id) 
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save", szSteam)
	format(vaultdata, charsmax(vaultdata), "%i %i %i %i %i", g_iUserData[id][iELO], g_iUserData[id][iHsRatio], g_iUserData[id][iUserKills], g_iUserData[id][iUserHeadShots], g_iUserData[id][iRank])

	nvault_get(g_nVault, vaultkey, vaultdata, charsmax(vaultdata))
	
	new szELO[10], szHsRatio[10], szKills[10], szHeadShot[10], szSaveRank[10]
	parse
	(
		vaultdata, 
		szELO, charsmax(szELO), 
		szHsRatio, charsmax(szHsRatio),
		szKills, charsmax(szKills), 
		szHeadShot, charsmax(szHeadShot),
		szSaveRank, charsmax(szSaveRank)
	)
	
	g_iUserData[id][iELO] = str_to_num(szELO)
	g_iUserData[id][iHsRatio] = str_to_num(szHsRatio)
	g_iUserData[id][iUserKills] = str_to_num(szKills)
	g_iUserData[id][iUserHeadShots] = str_to_num(szHeadShot)
	g_iUserData[id][iRank] = str_to_num(szSaveRank)
}
