#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>

#define MAX_PLAYERS 			32
#define m_afButtonPressed		246
#define MINIMUM_SPEED			105

const Float:g_fMultiplyValue = 		1.3

new pCvarPluginEnabled

public plugin_init() 
{
	new const PluginVersion[] = "1.2"
	register_plugin("CSGOM: Run boost", PluginVersion, "EFFx")
	
	RegisterHam(Ham_Player_Jump,"player","ham_Player_Jump_Pre",0)
	pCvarPluginEnabled = register_cvar("runboost_enabled","1")
}

public ham_Player_Jump_Pre(id)
{
	if(!is_user_alive(id) || !get_pcvar_num(pCvarPluginEnabled))
		return HAM_IGNORED

	new iGroundEntity = pev(id, pev_groundentity)
	if(!is_user_alive(iGroundEntity))
		return HAM_IGNORED

	if(isAllowedToBoost(iGroundEntity) && isAllowedToBoost(id)) // player is receiving boost + both players have enough speed
	{
		static afButtonPressed; afButtonPressed = get_pdata_int(id, m_afButtonPressed)
		if(~afButtonPressed & IN_JUMP)
		{
			return HAM_IGNORED
		}
		
		new Float:fVecVelocity[3]
		pev(id, pev_velocity, fVecVelocity)
		multiply(fVecVelocity)
		set_pev(id, pev_velocity, fVecVelocity)

		set_pdata_int(id, m_afButtonPressed, afButtonPressed & ~IN_JUMP)
		return HAM_SUPERCEDE
	}
	return HAM_IGNORED
}

multiply(Float:fOut[3])
{
	fOut[0] *= g_fMultiplyValue
	fOut[1] *= g_fMultiplyValue
}

bool:isAllowedToBoost(id)
{
	new Float:fVecVelocity[3]
	pev(id, pev_velocity, fVecVelocity)
	return bool:(floatround(vector_length(fVecVelocity)) >= MINIMUM_SPEED)
}
