#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <nvault>
#include <csgom>

#define PLUGIN 				"CSGOM: AK Skins system"
#define VERSION 			"1.0"
#define AUTHOR 				"EFFx"

#define MAX_MODEL_LENGTH		64
#define MAX_MODELS_SKINS		30
#define CSW_WEAPON			CSW_AK47
#define STATTRACK_CHANGE		5

stock const m_rgpPlayerItems_CBasePlayer[6] = {367,368,...}

new g_iHasModel[MAX_PLAYERS + 1][MAX_MODELS_SKINS]
new g_iUserModel[MAX_PLAYERS + 1]
new g_iWeaponKillST[MAX_PLAYERS + 1][MAX_MODELS_SKINS]
new g_iUserSkinRarity[MAX_PLAYERS + 1][MAX_MODELS_SKINS]
new g_iUserCurrentModelKills[MAX_PLAYERS +1][MAX_MODELS_SKINS]
new bool:g_bIsWeaponST[MAX_PLAYERS + 1][MAX_MODELS_SKINS]

new g_iRealOwner[MAX_PLAYERS + 1][60]
new g_szCustomSkinToUse[MAX_PLAYERS + 1]

new g_mMessageScreenFade, g_mMessageStatusIcon

new Array:g_arModels
new g_nVault, g_nVaultStattrack, g_nVaultRarity, g_nVaultModelKills

new const g_szDefaultVModel[] = "models/csgom/skins/v_ak47_default.mdl"

new const g_szSlots[] =
{
    0, // NULL
    2, // CSW_P228
    0, // NULL
    1, // CSW_SCOUT
    4, // CSW_HEGRENADE
    1, // CSW_XM1014
    5, // CSW_C4
    1, // CSW_MAC10
    1, // CSW_AUG
    4, // CSW_SMOKEGRENADE
    2, // CSW_ELITE
    2, // CSW_FIVESEVEN
    1, // CSW_UMP45
    1, // CSW_SG550
    1, // CSW_GALIL
    1, // CSW_FAMAS
    2, // CSW_USP
    2, // CSW_GLOCK
    1, // CSW_AWP
    1, // CSW_MP5NAVY
    1, // CSW_M249
    1, // CSW_M3
    1, // CSW_M4A1
    1, // CSW_TMP
    1, // CSW_G3SG1
    4, // CSW_FLASHBANG
    2, // CSW_DEAGLE
    1, // CSW_SG552
    1, // CSW_AK47
    3, // CSW_KNIFE
    1 // CSW_P90
}

new g_forwardGotCustomWeapon, g_iReturn
new g_iMaxPrice[MAX_PLAYERS + 1], g_iSelectedSkinID[MAX_PLAYERS + 1]
new bool:g_bStattrack[MAX_PLAYERS + 1]

new const WEAPONENTNAMES[][] = 
{   
	"", "weapon_p228", "", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10",
    	"weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550",
    	"weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249",
    	"weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle", "weapon_sg552",
    	"weapon_ak47", "weapon_knife", "weapon_p90" 
}

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	g_mMessageScreenFade = get_user_msgid("ScreenFade")
	g_mMessageStatusIcon = get_user_msgid("StatusIcon")
	
	g_forwardGotCustomWeapon = CreateMultiForward("gotWeaponFromAnotherPlayer", ET_STOP, FP_CELL, FP_CELL, FP_CELL)
	
	g_nVault = nvault_open("CSGOM_AKs")
	g_nVaultStattrack = nvault_open("CSGOM_StatTrack_AKs")
	g_nVaultRarity = nvault_open("CSGOM_Rarity_AKs")
	g_nVaultModelKills = nvault_open("CSGOM_ModelKills_AKs")

	register_clcmd("[CSGOM]Market_SkinPrice", "cmdSetAKPrice")
	register_event("DeathMsg", "msg_Death", "a")
	register_event("CurWeapon", "update_icon", "ab")
	register_event("TextMsg", "Event_GameWillRestartIn", "a", "2=#Game_will_restart_in")
	
	register_forward(FM_Touch, "forward_touch")
	register_forward(FM_SetModel, "forward_SetModel")
	
	for (new i = 1; i < sizeof WEAPONENTNAMES; i++)
	{
		if(WEAPONENTNAMES[i][0])
		{
			RegisterHam(Ham_CS_Item_CanDrop, WEAPONENTNAMES[i], "OnItemDropPre", 0)
		}
	}
	
	RegisterHam(Ham_Weapon_Reload, "weapon_ak47", "Weapon_Reload", 1)
	RegisterHam(Ham_Item_Deploy, "weapon_ak47", "ham_AKDeploy_Post", 1)
	RegisterHam(Ham_TakeDamage, "player", "ham_PlayerTakeDamage_Pre", 0)
	
	set_task(1.0, "printStattrackStatus", .flags = "b")
}

new bool:g_bCantPickup[MAX_PLAYERS + 1]

public Event_GameWillRestartIn()
{
	new iPlayers[MAX_PLAYERS], iNum
	get_players(iPlayers, iNum)
	for(new i;i < iNum;i++)
	{
		resetSkins(iPlayers[i])
	}
}

public OnItemDropPre(ent)
{
	static id; id = get_pdata_cbase(ent, m_pPlayer, XTRA_OFS_WEAPON)
	if(is_user_connected(id))
	{
		g_bCantPickup[id] = true

		new iArg[2]
		iArg[0] = id
		iArg[1] = cs_get_weapon_id(ent)
		set_task(0.1, "setData", _, iArg, sizeof iArg)
	}
}

public setData(iArg[2])
{
	new id = iArg[0], iEntityWeaponID = iArg[1]
	
	g_iRealOwner[id][iEntityWeaponID] = 0
	if(iEntityWeaponID == CSW_WEAPON)
	{
		g_szCustomSkinToUse[id] = -1
	}
	else ExecuteForward(g_forwardGotCustomWeapon, g_iReturn, id, iEntityWeaponID, DEFAULT_CODE_VALUE)
	g_bCantPickup[id] = false
}

public cmdSetAKPrice(id)
{
	new szArg[MAX_PLAYERS]
	read_args(szArg, charsmax(szArg))
	remove_quotes(szArg)
	
	new iPrice = str_to_num(szArg)
	if(iPrice < 0)
	{
		ChatColor(id, "You can not use a value lower than zero!")
		client_cmd(id, "messagemode [CSGOM]Market_SkinPrice")
		return PLUGIN_HANDLED
	}
	else if(iPrice > g_iMaxPrice[id])
	{
		ChatColor(id, "You can not use a value higher than^x04 %d!", g_iMaxPrice[id])
		client_cmd(id, "messagemode [CSGOM]Market_SkinPrice")
		return PLUGIN_HANDLED
	}	
	new arrayData[cModelsArray], szUserName[MAX_PLAYERS]
	ArrayGetArray(g_arModels, g_iSelectedSkinID[id], arrayData)
	registerItemInInventory(id, CSW_WEAPON, g_iSelectedSkinID[id], iPrice, g_bStattrack[id], arrayData[szModelName])

	g_iMaxPrice[id] = 0
	g_bStattrack[id] = false
	
	get_user_name(id, szUserName, charsmax(szUserName))
	ChatColor(0, "Player^x04 %s^x01 is selling his^x04 %s^x01 on the market for^x04 %d$.", szUserName, arrayData[szModelName], iPrice)
	return PLUGIN_HANDLED
}

public boughtSkinFromMarket(iBuyer, iSeller, iSkinID, iWID, bool:bIsStt, iPrice)
{
	if(iWID != CSW_WEAPON)
		return
		
	if(!g_iHasModel[iSeller][iSkinID])
	{
		ChatColor(iBuyer, "That player does not have that skin anymore, you can not buy it!")
		return
	}	
	else if(!is_user_connected(iSeller))
	{
		ChatColor(iBuyer, "That player is not on the server anymore, you can not buy it!")
		return
	}
	
	if(g_iUserModel[iSeller] == iSkinID)
	{
		g_iUserModel[iSeller] = -1
	}
	
	new arrayData[cModelsArray], szSellerName[MAX_PLAYERS], szBuyerName[MAX_PLAYERS]
	ArrayGetArray(g_arModels, g_iSelectedSkinID[iSeller], arrayData)
	get_user_name(iSeller, szSellerName, charsmax(szSellerName))
	get_user_name(iBuyer, szBuyerName, charsmax(szBuyerName))
	ChatColor(iBuyer, "You successfuly bought^x04 %s^x01's %s%s for^x04 %d$^x01.", szSellerName, bIsStt ? "StatTrack (TM) " : "", arrayData[szModelName], iPrice)
	ChatColor(iSeller, "Player^x04 %s^x01 just bought your^x04 %s%s.", szSellerName, bIsStt ? "StatTrack (TM) " : "", arrayData[szModelName])
	
	g_iHasModel[iBuyer][iSkinID]++
	g_iHasModel[iSeller][iSkinID]--
	
	g_bIsWeaponST[iSeller][iSkinID] = false
	g_bIsWeaponST[iBuyer][iSkinID] = bIsStt
	
	csgom_setmoney(iSeller, (csgom_getmoney(iSeller) + iPrice))
	csgom_setmoney(iBuyer, (csgom_getmoney(iBuyer) - iPrice))
	g_iSelectedSkinID[iSeller] = -1
}

public cmdOpenInventory(id)
{
	static szTittle[60]
	formatex(szTittle, charsmax(szTittle), "CSGOM - Inventory")
	
	new iMenu = menu_create(szTittle, "handler_inventory"), szItemID[3], iItemsAdedd
	for(new i, arrayData[cModelsArray], szItemFormat[80];i < ArraySize(g_arModels);i++)
	{
		ArrayGetArray(g_arModels, i, arrayData)
	
		if(g_iHasModel[id][i])
		{
			formatex
			(
				szItemFormat, charsmax(szItemFormat), 
				"%s%s%s", 
				g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
				arrayData[szModelName],
				(g_iSelectedSkinID[id] == i) ? "\d (MARKET)" : ""
			)
			num_to_str(i, szItemID, charsmax(szItemID))
			menu_additem(iMenu, szItemFormat)
			iItemsAdedd++
		}
	}
	
	if(!iItemsAdedd)
	{
		menu_additem(iMenu, "\dYour inventory is empty!")
	}
	menu_display(id, iMenu)
	return PLUGIN_HANDLED
}

public handler_inventory(id, iMenu, iItem)
{
	if((iItem == MENU_EXIT))
	{
		menu_destroy(iMenu)
		return
	}
	menu_display(id, iMenu)
}
	
public update_icon(id) 
{
	if(is_user_alive(id))
	{
		if(get_user_weapon(id) == CSW_WEAPON)
		{
			new iUserModel = g_iUserModel[id]
			if(g_szCustomSkinToUse[id] != -1)
			{
				iUserModel = g_szCustomSkinToUse[id]
			}

			new icon_color[3]
			getRarityColorToHud(iUserModel, g_arModels, icon_color)
			
			removeWeaponIcon(id, "d_ak47")
			if(is_user_connected(id)) 
			{
				message_begin(MSG_ONE,g_mMessageStatusIcon,{0,0,0},id)
				write_byte(1)
				write_string("d_ak47")
				write_byte(icon_color[0])
				write_byte(icon_color[1])
				write_byte(icon_color[2])
				message_end()
			}
		}
		else removeWeaponIcon(id, "d_ak47")
	}
	return PLUGIN_CONTINUE
} 

public forward_touch(ent, toucher) 
{
	if(!pev_valid(ent))
		return FMRES_IGNORED
		
	new szClassNameTouched[32], iEntityWeaponID
	pev(ent, pev_classname, szClassNameTouched, charsmax(szClassNameTouched))
	if(!equal(szClassNameTouched, "weaponbox"))
		return FMRES_IGNORED
		
	if(is_user_connected(toucher))
	{
		if(g_bCantPickup[toucher])
			return FMRES_SUPERCEDE
			
		for (new i = global_get(glb_maxClients) + 1; i < global_get(glb_maxEntities); ++i) 
		{
			if (!pev_valid(i) || ent != pev(i, pev_owner))
				continue
					
			iEntityWeaponID = cs_get_weapon_id(i)
			if(HasUserWeaponSlot(toucher, g_szSlots[iEntityWeaponID]))
			{
				break
			}
				
			new owner = pev(i, pev_iuser2)
			if(owner)
			{
				if(!is_user_connected(owner))
				{
					set_pev(i, pev_iuser2, 0)
					continue
				}
					
				if(owner != toucher)
				{
					g_iRealOwner[toucher][iEntityWeaponID] = owner
					if(iEntityWeaponID == CSW_WEAPON)
					{
						if(g_iUserModel[owner] != -1)
						{
							g_szCustomSkinToUse[toucher] = g_iUserModel[owner]
						}
						else g_szCustomSkinToUse[toucher] = DEFAULT_CODE_VALUE
					}
					else
					{
						ExecuteForward(g_forwardGotCustomWeapon, g_iReturn, toucher, iEntityWeaponID, owner)
					}
				}
			}
		}
	}
	return FMRES_IGNORED
}

public ham_PlayerTakeDamage_Pre(iVictim, iInflictor, iAttacker, Float:fDamage, iDamageBits)
{	
	if(!is_user_connected(iVictim) || !is_user_connected(iAttacker))
		return HAM_IGNORED
		
	new iUserModelID = g_iUserModel[iAttacker]
	if((iUserModelID == -1) || get_user_weapon(iAttacker) != CSW_WEAPON)
		return HAM_IGNORED
	
	SetHamParamFloat(4, fDamage * g_iRarityDamageMultiplier[g_iUserSkinRarity[iAttacker][iUserModelID]])
	return HAM_IGNORED
}

public Weapon_Reload(iEnt)
{
	if(get_pdata_int(iEnt, m_fInReload, 4))
	{
		new id = get_pdata_cbase(iEnt, m_pPlayer, XTRA_OFS_WEAPON)
		
		new iUserModelID = g_iUserModel[id]
		if((iUserModelID == -1) || get_user_weapon(id) != CSW_WEAPON)
			return HAM_IGNORED
		
		new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, 5) * g_iRaritySpeedMultiplier[rRarity:g_iUserSkinRarity[id][iUserModelID]]
		set_pdata_float(id, m_flNextAttack, flNextAttack, 5)
	}
	return HAM_IGNORED
}

public printStattrackStatus()
{
	new iPlayers[MAX_PLAYERS], iNum, arrayData[cModelsArray], szConfirmedKills[10]
	get_players(iPlayers, iNum, "a")
	for(new i, id, iUserModel, iWeaponID,  iRGB[3] = {255, 255, 255}, szMessageFmt[192];i < iNum;i++)
	{
		id = iPlayers[i]

		iWeaponID = get_user_weapon(id)
		
		if((g_iRealOwner[id][iWeaponID] > 0) && (g_iRealOwner[id][iWeaponID] != id))
		{
			static szOwnerName[32]
			get_user_name(g_iRealOwner[id][iWeaponID], szOwnerName, charsmax(szOwnerName))
			
			add(szOwnerName, charsmax(szOwnerName), "'s")

			set_hudmessage(200, 200, 200, -1.0, 0.74, 0, 1.0, 1.0)
			show_hudmessage(id, szOwnerName)
			printForSpecs(id, iRGB, szOwnerName)
		}

		if(isDefaultWeapons(iWeaponID))
		{
			static szWeaponName[20]
			get_weaponname(max(get_user_weapon(id), 1), szWeaponName, charsmax(szWeaponName))
			
			replace(szWeaponName, charsmax(szWeaponName), "weapon_", "")
			replace(szWeaponName, charsmax(szWeaponName), "mp5navy", "mp7")
			replace(szWeaponName, charsmax(szWeaponName), "sg552", "sig")
			replace(szWeaponName, charsmax(szWeaponName), "m3", "nova")
			strtoupper(szWeaponName)

			set_hudmessage(255, 255, 255, -1.0, 0.77, 0, 1.0, 1.0)
			formatex(szMessageFmt, charsmax(szMessageFmt), "CS:GO | %s", szWeaponName)
			show_hudmessage(id, szMessageFmt)

			printForSpecs(id, iRGB, szMessageFmt)
			continue
		}
		
		if(get_user_weapon(id) != CSW_WEAPON)
			continue
		
		if(g_szCustomSkinToUse[id] != -1)
		{
			iUserModel = g_szCustomSkinToUse[id]
		}
		else iUserModel = g_iUserModel[id]
		
		getRarityColorToHud(iUserModel, g_arModels, iRGB)
		if((iUserModel == -1) || (iUserModel == DEFAULT_CODE_VALUE))
		{
			formatex(szMessageFmt, charsmax(szMessageFmt), "CS:GO | AK-47")
		}
		else
		{
			new szMath[30], szCount[30], iRealOwner = g_iRealOwner[id][iWeaponID]
			if(g_iRealOwner[id][iWeaponID])
			{
				getRarityMath(g_iUserSkinRarity[iRealOwner][g_iUserModel[iRealOwner]], szMath, charsmax(szMath))
				getNextRarityCount
				(
					g_iUserSkinRarity[iRealOwner][g_iUserModel[iRealOwner]], 
					g_iUserCurrentModelKills[iRealOwner][g_iUserModel[iRealOwner]],
					szCount, 
					charsmax(szCount)
				)
				
				formatex(szMessageFmt, charsmax(szMessageFmt), "%s %s^n%s^n", g_szRarityNames[rRarity:g_iUserSkinRarity[iRealOwner][g_iUserModel[iRealOwner]]], szMath, szCount)
			}
			else 
			{
				getRarityMath(g_iUserSkinRarity[id][g_iUserModel[id]], szMath, charsmax(szMath))
				getNextRarityCount
				(
					g_iUserSkinRarity[id][g_iUserModel[id]], 
					g_iUserCurrentModelKills[id][g_iUserModel[id]],
					szCount, 
					charsmax(szCount)
				)
				
				formatex(szMessageFmt, charsmax(szMessageFmt), "%s %s^n%s^n", g_szRarityNames[rRarity:g_iUserSkinRarity[id][g_iUserModel[id]]], szMath, szCount)
			}
			
			if(iUserModel == DEFAULT_CODE_VALUE)
			{
				iUserModel = -1
			}
			
			ArrayGetArray(g_arModels, iUserModel, arrayData)
			if(g_bIsWeaponST[id][iUserModel])
			{
				if((g_iRealOwner[id][iWeaponID] > 0) && (g_iRealOwner[id][iWeaponID] != id))
				{
					szConfirmedKills = "*ERROR*"
				}
				else num_to_str(g_iWeaponKillST[id][iUserModel], szConfirmedKills, charsmax(szConfirmedKills))
				formatex(szMessageFmt, charsmax(szMessageFmt), "%sWeapon: %s (Stattrack*)^nConfirmed Kills: %s", szMessageFmt, arrayData[szModelName], szConfirmedKills)
			}
			else formatex(szMessageFmt, charsmax(szMessageFmt), "%s%s", szMessageFmt, arrayData[szModelName])
		}
		
		set_hudmessage(iRGB[0], iRGB[1], iRGB[2], -1.0, 0.77, 0, 1.0, 1.0)
		show_hudmessage(id, szMessageFmt)
		printForSpecs(id, iRGB, szMessageFmt)
	}
}

public plugin_end()
{
	nvault_close(g_nVault)
	nvault_close(g_nVaultStattrack)
	nvault_close(g_nVaultRarity)
	nvault_close(g_nVaultModelKills)
}

public plugin_natives()
{
	register_native("getRandomAK", "_getRandom")
	register_native("giveRandomAK", "_giveRandomAK")
	register_native("openAkMenu", "_open")
}

public _getRandom()
{
	new iSkinID = -1, iSkinChance, iRandomSkin = random_num(0, ArraySize(g_arModels) - 1), iMaxAttempts
	while(iSkinID == -1)
	{
		iRandomSkin = random_num(0, ArraySize(g_arModels) - 1)
		getRarityColorToHud(iRandomSkin, g_arModels, .bReturnChance = true, .iChanceReturn = iSkinChance)
		
		if(random_num(1, 100) <= iSkinChance)
		{
			iSkinID = iRandomSkin
			break
		}
		
		iMaxAttempts++
		if(iMaxAttempts >= MAX_ATTEMPTS)
			break
	}
	new arrayData[cModelsArray], szModel[MAX_PLAYERS]
	ArrayGetArray(g_arModels, iSkinID, arrayData)
	copy(szModel, charsmax(szModel), arrayData[szModelName])
		
	set_string(1, szModel, charsmax(szModel))
	return iSkinID
}

public giveUserSkin(id, iWeaponID, iSkinID, bool:bIsStatTrack, bool:bUseless, bool:bGive)
{
	if(iWeaponID == CSW_WEAPON)
	{
		if(bGive) g_iHasModel[id][iSkinID]++
		else g_iHasModel[id][iSkinID]--
		
		g_iUserSkinRarity[id][iSkinID] = _:rFactoryNew
		g_bIsWeaponST[id][iSkinID] = bIsStatTrack
	}
}

public _open()
{
	cmdModels(get_param(1), get_param(2))
}

public _giveRandomAK()
{
	new id = get_param(1)
	
	new iSkinID = -1, iSkinChance, iRandomSkin = random_num(0, ArraySize(g_arModels) - 1), iMaxAttempts
	while(iSkinID == -1)
	{
		iRandomSkin = random_num(0, ArraySize(g_arModels) - 1)
		getRarityColorToHud(iRandomSkin, g_arModels, .bReturnChance = true, .iChanceReturn = iSkinChance)
		
		if(random_num(1, 100) <= iSkinChance)
		{
			iSkinID = iRandomSkin
			break
		}
		
		iMaxAttempts++
		if(iMaxAttempts >= MAX_ATTEMPTS)
			break
	}
	
	new arrayData[cModelsArray]
	ArrayGetArray(g_arModels, iSkinID, arrayData)
	if(g_iHasModel[id][iSkinID] > 0)
	{
		ChatColor(id, "You received^x04 %d^x01 CSGOM Gold since you already have the^x04 %s^x01.", GOLD_VALUE, arrayData[szModelName])
		csgom_set_goldmoney(id, csgom_get_goldmoney(id) + GOLD_VALUE)
		return
	}
	
	if(g_iUserModel[id] == -1)
	{
		g_iUserModel[id] = iSkinID
	}
	g_iHasModel[id][iSkinID]++
	g_iUserSkinRarity[id][iSkinID] = _:rFactoryNew
			
	g_bIsWeaponST[id][iSkinID] = (random_num(1, (get_user_flags(id) & ADMIN_RESERVATION) ? 90 : 100) <= STATTRACK_CHANGE) ? true : false
	if(g_bIsWeaponST[id][iSkinID])
	{
		ChatColor(id, "You received the Stat Track status on this skin by %d percent of chance!", STATTRACK_CHANGE)
	}
	
	ChatColor(id, "You received the^x04 %s^x01 skin! Congratulations!!!", arrayData[szModelName])

	new szUserName[32]
	get_user_name(id, szUserName, charsmax(szUserName))
	ChatColor(0, "Player^x04 %s^x01 opened a case and got^x04 %s.", szUserName, arrayData[szModelName])

	saveData(id)
}

public plugin_precache()
{
	g_arModels = ArrayCreate(cModelsArray)
	
	precache_model(g_szDefaultVModel)
	readAKModels()
}

public client_connect(id)
{
	resetSkins(id)	
	
	g_iUserModel[id] = -1
	g_iMaxPrice[id] = g_iSelectedSkinID[id] = -1
	
	if(!is_user_bot(id))
	{
		loadData(id)
	}
}

public forward_SetModel(iEnt, szModel[])
{
	if(!pev_valid(iEnt))
		return FMRES_IGNORED
		
	new iDropperOwner = pev(iEnt, pev_owner)
	if(!is_user_connected(iDropperOwner))
		return FMRES_IGNORED

	static class[MAX_PLAYERS]
	pev(iEnt, pev_classname, class, charsmax(class))
	if(equal(class, "weaponbox"))
	{
		for (new iEntityWeaponID, iRealOwner, i = global_get(glb_maxClients) + 1; i < global_get(glb_maxEntities); ++i) 
		{
			if (!pev_valid(i) || iEnt != pev(i, pev_owner))
				continue
				
			iEntityWeaponID = cs_get_weapon_id(i)
			iRealOwner = pev(i, pev_iuser2)
			if(!iRealOwner)
			{
				if(g_iRealOwner[iDropperOwner][iEntityWeaponID] && is_user_connected(g_iRealOwner[iDropperOwner][iEntityWeaponID]))
				{
					set_pev(i, pev_iuser2, g_iRealOwner[iDropperOwner][iEntityWeaponID])
				}
				else 
				{
					if(is_user_connected(iDropperOwner))
					{
						set_pev(i, pev_iuser2, iDropperOwner)
					}
				}
			}
		}
	}
	
	if(equal(szModel, "models/w_ak47.mdl"))
	{
		new iUserModel = g_iUserModel[iDropperOwner]
		if(g_szCustomSkinToUse[iDropperOwner] != -1)
		{
			iUserModel = g_szCustomSkinToUse[iDropperOwner]
			if(iUserModel == DEFAULT_CODE_VALUE)
			{
				iUserModel = -1
			}
		}
		
		if(iUserModel == -1)
			return FMRES_IGNORED
			
		new iSkinChance
		getRarityColorToHud(iUserModel, g_arModels, .bReturnChance = true, .iChanceReturn = iSkinChance)
			
		new szModel[MAX_MODEL_LENGTH]
		switch(iSkinChance)
		{
			case MIL_CHANCE: 		szModel = g_szRarityModels[1]
			case RESTRICTED_CHANCE: 	szModel = g_szRarityModels[2]
			case CLASS_CHANCE: 		szModel = g_szRarityModels[3]
			case COVERT_CHANCE: 		szModel = g_szRarityModels[4]
			case RARE_CHANCE: 		szModel = g_szRarityModels[5]
			default: 			szModel = ""
		}
		
		static xGunDrop
		xGunDrop = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))

		if(!pev_valid(xGunDrop))
			return FMRES_IGNORED
		
		set_pev(xGunDrop, pev_classname, DROP_GUN_CLASSNAME)
		engfunc(EngFunc_SetModel, xGunDrop, szModel)
		set_pev(xGunDrop, pev_iuser1, iEnt)
		set_pev(xGunDrop, pev_framerate, 1.0)
		set_pev(xGunDrop, pev_animtime, get_gametime())
		set_pev(xGunDrop, pev_movetype, MOVETYPE_FOLLOW)
		set_pev(xGunDrop, pev_aiment, iEnt)
		set_pev(xGunDrop, pev_nextthink, get_gametime())
	}
	return FMRES_IGNORED
}
	
public msg_Death()
{
	new iAttacker = read_data(1), iVictim = read_data(2)
	if(iAttacker == iVictim)
		return
		
	resetSkins(iVictim)
	removeWeaponIcon(iVictim, "d_ak47")

	if(g_iUserModel[iAttacker] == -1) 
		return
		
	if((g_iRealOwner[iAttacker][get_user_weapon(iAttacker)] > 0) && (g_iRealOwner[iAttacker][get_user_weapon(iAttacker)] != iAttacker))
		return
		
	new szWeapon[17], iUserWeaponID = g_iUserModel[iAttacker]
	read_data(4, szWeapon, charsmax(szWeapon))
	if(containi(szWeapon, "ak47") != -1)
	{
		if(g_bIsWeaponST[iAttacker][iUserWeaponID])
		{
			g_iWeaponKillST[iAttacker][iUserWeaponID]++
		}

		g_iUserCurrentModelKills[iAttacker][iUserWeaponID]++
		if(g_iUserCurrentModelKills[iAttacker][iUserWeaponID] > g_iRaritiesKills[max((g_iUserSkinRarity[iAttacker][iUserWeaponID] - 1), 0)])
		{
			g_iUserSkinRarity[iAttacker][iUserWeaponID]--
		}
		saveData(iAttacker)
	}
}

public ham_AKDeploy_Post(const iAK)
{
	static id; id = get_pdata_cbase(iAK, m_pPlayer, XTRA_OFS_WEAPON)
	if(is_user_connected(id))
	{
		new arrayData[cModelsArray]
		if(g_szCustomSkinToUse[id] != -1)
		{
			if(g_szCustomSkinToUse[id] == DEFAULT_CODE_VALUE)
			{
				set_pev(id, pev_viewmodel2, g_szDefaultVModel)
			}
			else
			{
				ArrayGetArray(g_arModels, g_szCustomSkinToUse[id], arrayData)
				set_pev(id, pev_viewmodel2, arrayData[szViewModel])
			}
		}
		else
		{
			if(g_iUserModel[id] == -1)
			{		
				set_pev(id, pev_viewmodel2, g_szDefaultVModel)
			}
			else
			{
				ArrayGetArray(g_arModels, g_iUserModel[id], arrayData)
				set_pev(id, pev_viewmodel2, arrayData[szViewModel])
			}	
		}
	}
}

new g_iUserMethod[33]
cmdModels(id, iMethod)
{
	if(iMethod == INVENTORY)
	{
		cmdOpenInventory(id)
		return PLUGIN_HANDLED
	}
	
	static szTittle[60]
	formatex(szTittle, charsmax(szTittle), "CSGOM - AK Models^n\dGOMoney: %d", csgom_getmoney(id))
	
	g_iUserMethod[id] = iMethod
	new iMenu = menu_create(szTittle, "handler_models")
	for(new i, arrayData[cModelsArray], szItemFormat[80];i < ArraySize(g_arModels);i++)
	{
		ArrayGetArray(g_arModels, i, arrayData)
	
		switch(iMethod)
		{
			case BUY_SKINS:
			{
				if(g_iHasModel[id][i])
				{
					formatex
					(
						szItemFormat, charsmax(szItemFormat), 
						"\d%s (ALREADY HAVE)", 
						arrayData[szModelName]
					)
				}
				else
				{
					formatex
					(
						szItemFormat, charsmax(szItemFormat), 
						"%s - [\r%d \rGOMoney\w]", 
						arrayData[szModelName], 
						arrayData[iModelPrice]
					)
				}
				menu_additem(iMenu, szItemFormat)
			}
			case USE_SKINS, INVENTORY, FIX_WEAPON:
			{
				if(g_iSelectedSkinID[id] == i)
				{
					formatex
					(
						szItemFormat, charsmax(szItemFormat), 
						"%s%s\d (MARKET)", 
						g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
						arrayData[szModelName]
					)
					menu_additem(iMenu, szItemFormat)
					continue
				}
				else
				{
					if(g_iHasModel[id][i])
					{
						formatex
						(
							szItemFormat, charsmax(szItemFormat), 
							"%s%s - [\r%s\w]", 
							g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
							arrayData[szModelName], 
							(g_iUserModel[id] == i) ? "\yON\w" : "\rOFF\w"
						)
						menu_additem(iMenu, szItemFormat)
						continue
					}
					else
					{
						formatex
						(
							szItemFormat, charsmax(szItemFormat), 
							"\d%s", 
							arrayData[szModelName]
						)
						menu_additem(iMenu, szItemFormat)
					}
				}
			}
			case MARKET:
			{
				if(g_iHasModel[id][i])
				{
					if(g_iSelectedSkinID[id] == i)
					{
						formatex
						(
							szItemFormat, charsmax(szItemFormat), 
							"%s%s\d (MARKET)", 
							g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
							arrayData[szModelName]
						)
					}
					else
					{
						formatex
						(
							szItemFormat, charsmax(szItemFormat), 
							"%s%s - [\r%d$ MAX\w]", 
							g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
							arrayData[szModelName], 
							convertSkinPrice(g_bIsWeaponST[id][i], arrayData[iModelPrice])
						)
					}
					menu_additem(iMenu, szItemFormat)
					continue
				}
				else
				{
					formatex
					(
						szItemFormat, charsmax(szItemFormat), 
						"\d%s%s", 
						g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
						arrayData[szModelName]
					)
					menu_additem(iMenu, szItemFormat)
				}
			}
			case TRADE:
			{
				if(g_iHasModel[id][i])
				{
					if(g_iSelectedSkinID[id] == i)
					{
						formatex
						(
							szItemFormat, charsmax(szItemFormat), 
							"%s%s\d (MARKET)", 
							g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
							arrayData[szModelName]
						)
					}
					else
					{
						formatex
						(
							szItemFormat, charsmax(szItemFormat), 
							"%s%s", 
							g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
							arrayData[szModelName]
						)
					}
					menu_additem(iMenu, szItemFormat)
					continue
				}
				else
				{
					formatex
					(
						szItemFormat, charsmax(szItemFormat), 
						"\d%s%s", 
						g_bIsWeaponST[id][i] ? "\d(StatTrack)\w " : "",
						arrayData[szModelName]
					)
					menu_additem(iMenu, szItemFormat)
				}
			}
		}
	}
	
	menu_display(id, iMenu)
	return PLUGIN_HANDLED
}

native openTradeMenu(id)

public handler_models(id, iMenu, iItem)
{
	if((iItem == MENU_EXIT))
	{
		menu_destroy(iMenu)
		return
	}

	new arrayData[cModelsArray]
	ArrayGetArray(g_arModels, iItem, arrayData)
	
	switch(g_iUserMethod[id])
	{
		case USE_SKINS:
		{	
			if(!g_iHasModel[id][iItem])
			{
				ChatColor(id, "You do not have that skin, try again later.")
				menu_display(id, iMenu)
				return
			}
			else if(g_iUserModel[id] == iItem)
			{
				ChatColor(id, "You've selected the default skin!")
				g_iUserModel[id] = -1
				cmdModels(id, g_iUserMethod[id])
				saveData(id)
				return
			}
			else if(g_iSelectedSkinID[id] == iItem)
			{
				ChatColor(id, "That skin is currently in the market place, you cannot use it.")
				menu_display(id, iMenu)
				return
			}
			g_iUserModel[id] = iItem
			
			if(get_user_weapon(id) == CSW_WEAPON && is_user_alive(id))
			{
				set_pev(id, pev_viewmodel2, arrayData[szViewModel])
			}
			
			cmdModels(id, g_iUserMethod[id])
			saveData(id)
			ChatColor(id, "You've selected %s.", arrayData[szModelName])
		}
		case BUY_SKINS:
		{
			if(csgom_getmoney(id) < arrayData[iModelPrice])
			{
				ChatColor(id, "Not enough money to buy %s.", arrayData[szModelName])
				menu_display(id, iMenu)
				return
			}
			else if(g_iHasModel[id][iItem] > 0)
			{
				ChatColor(id, "You already have the %s.", arrayData[szModelName])
				menu_display(id, iMenu)
				return
			}
			askMenu(id, iItem)
		}
		case MARKET:
		{
			if(g_iSelectedSkinID[id] == iItem)
			{
				ChatColor(id, "You are already selling that skin!")
				menu_display(id, iMenu)
				return
			}
			else if(g_iUserModel[id] == iItem)
			{
				ChatColor(id, "You cannot sell the skin you are currently using!")
				menu_display(id, iMenu)
				return
			}
			else if(!g_iHasModel[id][iItem])
			{
				ChatColor(id, "You do not have that skin.")
				menu_display(id, iMenu)
				return
			}
			g_iMaxPrice[id] = convertSkinPrice(g_bIsWeaponST[id][iItem], arrayData[iModelPrice])
			g_bStattrack[id] = g_bIsWeaponST[id][iItem]
			g_iSelectedSkinID[id] = iItem
			client_cmd(id, "messagemode [CSGOM]Market_SkinPrice")
			ChatColor(id, "Type the price of the^x04 %s^x01 from^x04 1^x01 to^x04 %d$.", arrayData[szModelName], convertSkinPrice(g_bIsWeaponST[id][iItem], arrayData[iModelPrice]))
		}
		case FIX_WEAPON:
		{
			if(!g_iHasModel[id][iItem])
			{
				ChatColor(id, "You do not have that skin.")
				menu_display(id, iMenu)
				return
			}
			else if(csgom_get_goldmoney(id) < arrayData[iModelPrice])
			{
				ChatColor(id, "Not enough money to restore %s.", arrayData[szModelName])
				menu_display(id, iMenu)
				return
			}

			new iItemID = g_iUserModel[id]
			if(g_iUserSkinRarity[id][iItemID] == _:rFactoryNew)
			{
				ChatColor(id, "Your %s is already Factory New!", arrayData[szModelName])
				menu_display(id, iMenu)
				return
			}
			g_iUserSkinRarity[id][iItemID] = rFactoryNew
			g_iUserCurrentModelKills[id][iItemID] = 0
			
			saveData(id)
			
			csgom_set_goldmoney(id, (csgom_get_goldmoney(id) - PRICE_TO_RESTORE))
			ChatColor(id, "You successfuly restored %s for %d CSGO Gold", arrayData[szModelName], PRICE_TO_RESTORE)	
		}
		case TRADE:
		{
			if(g_iSelectedSkinID[id] == iItem)
			{
				ChatColor(id, "You are selling that skin!")
				menu_display(id, iMenu)
				return
			}
			else if(g_iUserModel[id] == iItem)
			{
				ChatColor(id, "You cannot trade the skin you are currently using!")
				menu_display(id, iMenu)
				return
			}
			else if(!g_iHasModel[id][iItem])
			{
				ChatColor(id, "You do not have that skin.")
				menu_display(id, iMenu)
				return
			}
			registerTradeItem(id, iItem, g_bIsWeaponST[id][iItem], arrayData[szModelName], CSW_WEAPON)
			openTradeMenu(id)
		}
	}
}

askMenu(id, iItemID)
{
	static szTittle[80]
	formatex(szTittle, charsmax(szTittle), "CSGOM - AK Models^n\dAre you sure?^n\dGOMoney: %d", csgom_getmoney(id))
	
	new iMenu = menu_create(szTittle, "askmenu_handler"), szItemID[10]
	num_to_str(iItemID, szItemID, charsmax(szItemID))
	
	menu_additem(iMenu, "Confirm", szItemID)
	menu_additem(iMenu, "I won't")
	
	menu_display(id, iMenu)
}

public askmenu_handler(id, iMenu, iItem)
{
	switch(iItem)
	{
		case MENU_EXIT:
		{
			menu_destroy(iMenu)
		}
		case 0:
		{
			new szData[10], szItemName[MAX_MODEL_LENGTH], _access, item_callback
			menu_item_getinfo(iMenu, iItem, _access, szData,charsmax(szData), szItemName, charsmax(szItemName), item_callback)
			
			new iItemID = str_to_num(szData), arrayData[cModelsArray], iPrice
			ArrayGetArray(g_arModels, iItemID, arrayData)
				
			iPrice = arrayData[iModelPrice]
			if(getDiscountValue(iPrice, id))
			{
				ChatColor(id, "Since you are^x04 Very Important Person^x01, you got^x04 10 percent^x01 discount on^x04 %s^x01 and paid^x04 %d$ GOMoney.", arrayData[szModelName], iPrice)
			}
			else ChatColor(id, "You successfuly bought %s for %d GOMoney.", arrayData[szModelName], iPrice)
				
			g_iUserModel[id] = iItemID
			g_iHasModel[id][iItemID]++
			g_iUserSkinRarity[id][iItemID] = rFactoryNew

			if(get_user_weapon(id) == CSW_WEAPON && is_user_alive(id))
			{
				set_pev(id, pev_viewmodel2, arrayData[szViewModel])
			}
			
			g_bIsWeaponST[id][iItemID] = (random_num(1, (get_user_flags(id) & ADMIN_RESERVATION) ? 90 : 100) <= STATTRACK_CHANGE) ? true : false
			if(g_bIsWeaponST[id][iItemID])
			{
				ChatColor(id, "You received the Stat Track status on this skin by %d percent of chance!", STATTRACK_CHANGE)
			}
			
			message_begin(MSG_ONE, g_mMessageScreenFade, .player = id)
			write_short(4300)
			write_short(0)
			write_short(0)
			write_byte(255)
			write_byte(255) 
			write_byte(255) 
			write_byte(65) 
			message_end()
				
			csgom_setmoney(id, (csgom_getmoney(id) - iPrice))
		
			saveData(id)
		}
		case 1: cmdModels(id, 0)
	}
}

readAKModels()
{
	new szConfig[MAX_PLAYERS], szIniFile[164]
	get_configsdir(szConfig, charsmax(szConfig))
	formatex(szIniFile, charsmax(szIniFile), "%s/csgom/csgom_skin_system/csgom_akmodels.ini", szConfig)
	if(!file_exists(szIniFile)) 
	{
		log_to_file("csgom_log.log", "[CSGOM]: %L", LANG_SERVER, "SERVER_NO_CONFIG_FILE", szIniFile)
		return
	}

	new szBuffer[MAX_MODEL_LENGTH + MAX_PLAYERS]
	new szKey[MAX_PLAYERS], szValue[MAX_MODEL_LENGTH], arrayData[cModelsArray]
	
	new iFile = fopen(szIniFile, "rt"), iModelsNum = 0
	while(!feof(iFile) && (iModelsNum < MAX_MODELS_SKINS))
	{
		fgets(iFile, szBuffer, charsmax(szBuffer))
		trim(szBuffer)
		
		if((szBuffer[0] == EOS) || (szBuffer[0] == ';') || ((szBuffer[0] == '/') && (szBuffer[1] == '/')))
			continue
			
		if(szBuffer[0] == '[')
		{
			if(szBuffer[strlen(szBuffer) - 1] == ']')
			{
				if(iModelsNum)
				{
					ArrayPushArray(g_arModels, arrayData)
				}
	
				iModelsNum++
				
				replace(szBuffer, charsmax(szBuffer), "[", "")
				replace(szBuffer, charsmax(szBuffer), "]", "")
				
				arrayData[szModelName] = szBuffer
			}
			else continue
		}
		else
		{
			strtok(szBuffer, szKey, charsmax(szKey), szValue, charsmax(szValue), '=')
			
			trim(szKey)
			trim(szValue)
			
			if(equal(szKey, "AK_VIEW_MODEL"))
			{
				if(precacheModel(szValue))
				{
					arrayData[szViewModel] = szValue
				}
			}
			else if(equal(szKey, "AK_PRICE"))
			{
				arrayData[iModelPrice] = str_to_num(szValue)
			}
			else if(equal(szKey, "AK_RARITY"))
			{
				arrayData[szModelRarity] = szValue
			}
		}
	}
	if(iModelsNum)
	{
		ArrayPushArray(g_arModels, arrayData)
	}
	fclose(iFile)
}

precacheModel(szModel[])
{
	if(file_exists(szModel))
	{
		precache_model(szModel)

		// Quick&Dirty Fix
		new temp[80]
		copy(temp, (strlen(szModel) - 4), szModel)
		formatex(temp, charsmax(temp), "%st.mdl", temp)
		if(file_exists(temp))
		{
			precache_model(temp)
			return true
		}
		copy(temp, (strlen(szModel) - 4), szModel)
		formatex(temp, charsmax(temp), "%sT.mdl", temp)
		if(file_exists(temp))
		{
			precache_model(temp)
			return true
		}
		return true
	}
	return false
}

saveData(id)
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save", szSteam)  
	format(vaultdata, charsmax(vaultdata), "%i", g_iUserModel[id])
	
	for(new i;i < MAX_MODELS_SKINS;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_iHasModel[id][i])    
	}
	nvault_set(g_nVault, vaultkey, vaultdata)
	
	if(g_iUserModel[id] != -1)
	{
		format(vaultkey, charsmax(vaultkey), "%s-Save_ST", szSteam)  
		format(vaultdata, charsmax(vaultdata), "%i %i", g_bIsWeaponST[id][g_iUserModel[id]], g_iWeaponKillST[id][g_iUserModel[id]])
		nvault_set(g_nVaultStattrack, vaultkey, vaultdata)
	}
	arrayset(vaultdata, 0, sizeof vaultdata)
	format(vaultkey, charsmax(vaultkey), "%s-Save_Rar", szSteam)  
	for(new i;i < MAX_MODELS_SKINS;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_iUserSkinRarity[id][i])    
	}
	nvault_set(g_nVaultRarity, vaultkey, vaultdata)

	arrayset(vaultdata, 0, sizeof vaultdata)
	format(vaultkey, charsmax(vaultkey), "%s-Save_ModelKills", szSteam)  
	for(new i;i < MAX_MODELS_SKINS;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_iUserCurrentModelKills[id][i])    
	}
	nvault_set(g_nVaultModelKills, vaultkey, vaultdata)
}

loadData(id) 
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save", szSteam)
	format(vaultdata, charsmax(vaultdata), "%i", g_iUserModel[id])
			
	for(new i;i < MAX_MODELS_SKINS;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_iHasModel[id][i])  
	}
	nvault_get(g_nVault, vaultkey, vaultdata, charsmax(vaultdata))
	
	new Data[MAX_MODELS_SKINS][8]
	
	// WTF
	parse(vaultdata, Data[0], charsmax(Data[]), Data[1], charsmax(Data[]), Data[2], charsmax(Data[]), Data[3], charsmax(Data[]), 
	Data[4], charsmax(Data[]), Data[5], charsmax(Data[]),Data[6], charsmax(Data[]), Data[7], charsmax(Data[]), Data[8], charsmax(Data[]), 
	Data[9], charsmax(Data[]), Data[10], charsmax(Data[]), Data[11], charsmax(Data[]), Data[12], charsmax(Data[]),Data[13], charsmax(Data[]), 
	Data[14], charsmax(Data[]), Data[15], charsmax(Data[]), Data[16], charsmax(Data[]), Data[17], charsmax(Data[]), Data[18], charsmax(Data[]), 
	Data[19], charsmax(Data[]), Data[20], charsmax(Data[]), Data[21], charsmax(Data[]), Data[22], charsmax(Data[]), Data[23], charsmax(Data[]), 
	Data[24], charsmax(Data[]), Data[25], charsmax(Data[]), Data[26], charsmax(Data[]), Data[27], charsmax(Data[]), Data[28], charsmax(Data[]), 
	Data[29], charsmax(Data[]))
	
	for(new i;i < sizeof Data;i++)
	{
		if(i > 0)
		{
			g_iHasModel[id][i - 1] = str_to_num(Data[i])
		}
		else 
		{
			g_iUserModel[id] = str_to_num(Data[i])
		}
	}

	arrayset(vaultdata, 0, sizeof vaultdata)
	format(vaultkey, charsmax(vaultkey), "%s-Save_Rar", szSteam)  
	for(new i;i < MAX_MODELS_SKINS;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_iUserSkinRarity[id][i])    
	}
	nvault_get(g_nVaultRarity, vaultkey, vaultdata, charsmax(vaultdata))

	parse(vaultdata, Data[0], charsmax(Data[]), Data[1], charsmax(Data[]), Data[2], charsmax(Data[]), Data[3], charsmax(Data[]), 
	Data[4], charsmax(Data[]), Data[5], charsmax(Data[]),Data[6], charsmax(Data[]), Data[7], charsmax(Data[]), Data[8], charsmax(Data[]), 
	Data[9], charsmax(Data[]), Data[10], charsmax(Data[]), Data[11], charsmax(Data[]), Data[12], charsmax(Data[]),Data[13], charsmax(Data[]), 
	Data[14], charsmax(Data[]), Data[15], charsmax(Data[]), Data[16], charsmax(Data[]), Data[17], charsmax(Data[]), Data[18], charsmax(Data[]), 
	Data[19], charsmax(Data[]), Data[20], charsmax(Data[]), Data[21], charsmax(Data[]), Data[22], charsmax(Data[]), Data[23], charsmax(Data[]), 
	Data[24], charsmax(Data[]), Data[25], charsmax(Data[]), Data[26], charsmax(Data[]), Data[27], charsmax(Data[]), Data[28], charsmax(Data[]), 
	Data[29], charsmax(Data[]))

	for(new i;i < sizeof Data;i++)
	{
		g_iUserSkinRarity[id][i] = str_to_num(Data[i])
		if(!g_iUserSkinRarity[id][i])
		{
			g_iUserSkinRarity[id][i] = _:rFactoryNew
		}
	}
	
	arrayset(vaultdata, 0, sizeof vaultdata)
	format(vaultkey, charsmax(vaultkey), "%s-Save_ModelKills", szSteam)  
	for(new i;i < MAX_MODELS_SKINS;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_iUserCurrentModelKills[id][i])    
	}
	nvault_get(g_nVaultModelKills, vaultkey, vaultdata, charsmax(vaultdata))

	parse(vaultdata, Data[0], charsmax(Data[]), Data[1], charsmax(Data[]), Data[2], charsmax(Data[]), Data[3], charsmax(Data[]), 
	Data[4], charsmax(Data[]), Data[5], charsmax(Data[]),Data[6], charsmax(Data[]), Data[7], charsmax(Data[]), Data[8], charsmax(Data[]), 
	Data[9], charsmax(Data[]), Data[10], charsmax(Data[]), Data[11], charsmax(Data[]), Data[12], charsmax(Data[]),Data[13], charsmax(Data[]), 
	Data[14], charsmax(Data[]), Data[15], charsmax(Data[]), Data[16], charsmax(Data[]), Data[17], charsmax(Data[]), Data[18], charsmax(Data[]), 
	Data[19], charsmax(Data[]), Data[20], charsmax(Data[]), Data[21], charsmax(Data[]), Data[22], charsmax(Data[]), Data[23], charsmax(Data[]), 
	Data[24], charsmax(Data[]), Data[25], charsmax(Data[]), Data[26], charsmax(Data[]), Data[27], charsmax(Data[]), Data[28], charsmax(Data[]), 
	Data[29], charsmax(Data[]))

	for(new i;i < sizeof Data;i++)
	{
		g_iUserCurrentModelKills[id][i] = str_to_num(Data[i])
	}
		
	if(!g_iHasModel[id][max(g_iUserModel[id], 0)])
	{
		g_iUserModel[id] = -1
	}
	if(g_iUserModel[id] != -1)
	{
		format(vaultkey, charsmax(vaultkey), "%s-Save_ST", szSteam)  
		format(vaultdata, charsmax(vaultdata), "%i %i", g_bIsWeaponST[id][g_iUserModel[id]], g_iWeaponKillST[id][g_iUserModel[id]])
		nvault_get(g_nVaultStattrack, vaultkey, vaultdata, charsmax(vaultdata))
	
		new iItemID = g_iUserModel[id], szIsSTT[10], szSTT[10]
		parse(vaultdata, szIsSTT, charsmax(szIsSTT), szSTT, charsmax(szSTT))
	
		g_bIsWeaponST[id][iItemID] = bool:str_to_num(szIsSTT)
		g_iWeaponKillST[id][iItemID] = str_to_num(szSTT)
	}
}


isDefaultWeapons(iWpn)
{
	switch(iWpn)
	{
		case CSW_KNIFE, CSW_M4A1, CSW_WEAPON, CSW_AWP, CSW_GLOCK18, CSW_USP, CSW_DEAGLE: return false
	}
	return true
}

HasUserWeaponSlot(id, slot)	
{
	return get_pdata_cbase(id, m_rgpPlayerItems_CBasePlayer[slot]) > 0
}

resetSkins(id)
{
	g_szCustomSkinToUse[id] = -1
	
	for (new iEntityWeaponID, i = 1; i < sizeof WEAPONENTNAMES; i++)
	{
		if(WEAPONENTNAMES[i][0])
		{
			iEntityWeaponID = get_weaponid(WEAPONENTNAMES[i])
			
			g_iRealOwner[id][iEntityWeaponID] = 0
			ExecuteForward(g_forwardGotCustomWeapon, g_iReturn, id, iEntityWeaponID, DEFAULT_CODE_VALUE)
		}
	}
}
