#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <engine>

#define ADMIN_FLAG ADMIN_RESERVATION
#define BUNNYJUMP_MAX_SPEED_FACTOR 1.7

enum
{
	SCOREATTRIB_ARG_PLAYERID = 1,
	SCOREATTRIB_ARG_FLAGS
};

enum ( <<= 1 )
{
	SCOREATTRIB_FLAG_NONE = 0,
	SCOREATTRIB_FLAG_DEAD = 1,
	SCOREATTRIB_FLAG_BOMB,
	SCOREATTRIB_FLAG_VIP
};

new pCvar_AdminVIP

public plugin_init( )
{
	register_plugin( "Admin VIP ScoreBoard", "0.0.1", "Exolent" );
	
	register_message( get_user_msgid( "ScoreAttrib" ), "MessageScoreAttrib" );
	RegisterHam(Ham_TakeDamage, "player", "OnCBasePlayer_TakeDamage")
	register_forward(FM_PlayerPreThink, "fm_PreThink")
	
	pCvar_AdminVIP = register_cvar( "amx_adminvip", "1" );
}

public MessageScoreAttrib( iMsgId, iDest, iReceiver )
{
	if( get_pcvar_num( pCvar_AdminVIP ) )
	{
		new iPlayer = get_msg_arg_int( SCOREATTRIB_ARG_PLAYERID );
	
		if( get_user_flags( iPlayer ) & ADMIN_FLAG ) 
		{
			set_msg_arg_int( SCOREATTRIB_ARG_FLAGS, ARG_BYTE, SCOREATTRIB_FLAG_VIP );
		}
	}
} 

public OnCBasePlayer_TakeDamage( id, iInflictor, iAttacker, Float:flDamage, bitsDamageType ) // return int
{
	if(bitsDamageType & DMG_FALL)
	{
		return (get_user_flags(id) & ADMIN_FLAG) ? HAM_SUPERCEDE : HAM_IGNORED
	}
	return HAM_IGNORED
} 

public fm_PreThink(id) 
{
	if(is_user_alive(id) && get_user_flags(id) & ADMIN_FLAG) 
	{
		if(entity_get_int(id, EV_INT_button) & 2) 
		{
			new flags = entity_get_int(id, EV_INT_flags)
			if (flags & FL_WATERJUMP)
				return PLUGIN_CONTINUE
				
			if ( entity_get_int(id, EV_INT_waterlevel) >= 2 )
				return PLUGIN_CONTINUE
				
			if ( !(flags & FL_ONGROUND) )
				return PLUGIN_CONTINUE
				
			new Float:velocity[3]
			pev(id, pev_velocity, velocity)
			velocity[2] = 250.0
			
			static Float:fMaxScaledSpeed
			pev(id, pev_maxspeed, fMaxScaledSpeed)
			if(fMaxScaledSpeed > 0.0)
			{
				fMaxScaledSpeed *= BUNNYJUMP_MAX_SPEED_FACTOR
				static Float:fSpeed
				fSpeed = floatsqroot(velocity[0]*velocity[0] + velocity[1]*velocity[1] + velocity[2]*velocity[2])
				if(fSpeed > fMaxScaledSpeed)
				{
					static Float:fFraction
					fFraction = ( fMaxScaledSpeed / fSpeed ) * 0.65
					velocity[0] *= fFraction
					velocity[1] *= fFraction
					velocity[2] *= fFraction
				}
			}
			set_pev(id, pev_velocity, velocity)
			entity_set_int(id, EV_INT_gaitsequence, 6)
		}
	}
	return PLUGIN_CONTINUE
}
