#include <amxmodx>
#include <cstrike>
#include <fakemeta>

#define PLUGIN "CSGOM: Menu de Armas"
#define VERSION "1.0"

#include <engine>
#include <hamsandwich>
#include <csgom>
#include <fun>

#define m_rpgPlayerItems  		367
#define m_rpgPlayerItemsDiff  		5
#define MAX_AWP_PER_ROUND		4
#define getWeaponBoxID(%1,%2) 		get_pdata_cbase(%1, (m_rpgPlayerItems + %2), m_rpgPlayerItemsDiff)

stock const m_rgpPlayerItems_CBasePlayer[6] = {367,368,...}
const FLASHLIGHT_IMPULSE =		100

enum iInfo
{
	szWeaponName[32],
	szWeaponInfo[20],
	iPrice
}

new const g_szRiflesList[][iInfo] =
{
	{"CS:GO | AK-47", "weapon_ak47", 2700},
	{"CS:GO | M4A4", "weapon_m4a1", 3100},
	{"CS:GO | M4A1-S", "weapon_m4a1", 2900},
	{"CS:GO | AWP", "weapon_awp", 4750},
	{"CS:GO | SCOUT", "weapon_scout", 3000},
	{"CS:GO | MP7", "weapon_mp5navy", 1700},
	{"CS:GO | FAMAS", "weapon_famas", 2250},
	{"CS:GO | GALIL", "weapon_galil", 2000},
	{"CS:GO | P90", "weapon_p90", 2350},
	{"CS:GO | NOVA", "weapon_m3", 2200},
	{"CS:GO | XM1014", "weapon_xm1014", 2000},
	{"CS:GO | MAC10", "weapon_mac10", 1400},
	{"CS:GO | UMP45 ", "weapon_ump45", 1200},
}

new const g_szPistolList[][iInfo] =
{
	{"CS:GO | GLOCK18", "weapon_glock18", 200},
	{"CS:GO | USP-S", "weapon_usp", 200},
	{"CS:GO | DEAGLE", "weapon_deagle", 700},
	{"CS:GO | ELITE", "weapon_elite", 500},
	{"CS:GO | FIVESEVEN", "weapon_fiveseven", 500}
}

new const g_szKevlarSound[] = "items/ammopickup2.wav"

#define EXPIRE_TIME 15
#define TASK_CHECK_BUYZONE 23131

new g_iExpireTime[33], bool:g_bReceived[33]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, "EFFx")
	
	RegisterHam(Ham_Spawn, "player", "ham_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Player_ImpulseCommands, "player", "ham_PlayerImpulse")
}

public plugin_precache() 
{
	precache_sound(g_szKevlarSound)
}

public CS_OnBuy(id, iItem)
{
	return PLUGIN_HANDLED
}

public client_command(id)
{
	if(!is_user_alive(id))
		return PLUGIN_CONTINUE
    
	static cmd_list[][] = { "buy", "buyequip", "autobuy", "cl_autobuy", "cl_rebuy" }
	static command[16], i; read_argv(0, command, 15)

	for(i = 0; i < sizeof cmd_list; i++) if(equal(command, cmd_list[i]))
		return PLUGIN_HANDLED
    
	if(equal(command, "client_buy_open"))
	{
		if(task_exists(id + TASK_CHECK_BUYZONE))
		{
			xMenuGuns(id)
		}
		static msg_buyclose; if(!msg_buyclose) msg_buyclose = get_user_msgid("BuyClose")
		message_begin(MSG_ONE, msg_buyclose, _, id), message_end()
	}
	return PLUGIN_CONTINUE
} 

public ham_PlayerImpulse(id)
{
	if(!is_user_alive(id))
		return HAM_IGNORED

	if(pev(id, pev_impulse) == FLASHLIGHT_IMPULSE)	
	{
		set_pev(id, pev_impulse, 0)
		return HAM_SUPERCEDE
	}
	return HAM_IGNORED
}

public ham_PlayerSpawn_Post(id)
{
	if(is_user_alive(id))
	{
		g_bReceived[id] = false
		g_iExpireTime[id] = EXPIRE_TIME
		
		remove_task(id + TASK_CHECK_BUYZONE)
		set_task(1.0, "expireTime", id + TASK_CHECK_BUYZONE, .flags = "b")
		
		show_menu(id, 0, "^n")
		set_task(1.0, "xMenuGuns", id)
	}
}

new bool:g_bClosedMenu[33]
public expireTime(id)
{
	id -= TASK_CHECK_BUYZONE
	
	if(!is_user_alive(id))
	{
		remove_task(id + TASK_CHECK_BUYZONE)
		return
	}
	
	if(!cs_get_user_buyzone(id) && !g_bClosedMenu[id])
	{
		g_bClosedMenu[id] = true
		show_menu(id, 0, "^n")
	}

	if(cs_get_user_buyzone(id) && g_bClosedMenu[id])
	{
		xMenuGuns(id)
		g_bClosedMenu[id] = false
	}

	g_iExpireTime[id]--
	if(!g_iExpireTime[id])
	{
		remove_task(id + TASK_CHECK_BUYZONE)
		show_menu(id, 0, "^n")
	}
}

// Menu Guns
public xMenuGuns(id)
{
	if(!is_user_alive(id))
		return
	
	if(get_user_team(id) == 2)
	{
		cs_set_user_defuse(id, 1)
	}
	
	if(!g_bReceived[id])
	{
		g_bReceived[id] = true
		
		give_item(id, "weapon_hegrenade")
		give_item(id, "weapon_flashbang")
		give_item(id, "weapon_smokegrenade")
		cs_set_user_bpammo(id, CSW_FLASHBANG, 2)
	
		emit_sound(id, CHAN_BODY, g_szKevlarSound, VOL_NORM, ATTN_NONE, 0, PITCH_NORM)
		cs_set_user_armor(id, 100, CS_ARMOR_VESTHELM)	
	}
	new iWeapons[32], iNum
	get_user_weapons(id, iWeapons, iNum)
	for(new i, iWeaponEntity, iWeaponID, szWeapon[20];i < iNum;i++)
	{
		if(!(iWeaponID = iWeapons[i]))
			continue
			
		if(!getMaxBpAmmo(iWeaponID))
			continue
			
		cs_set_user_bpammo(id, iWeaponID, getMaxBpAmmo(iWeaponID))
		get_weaponname(iWeaponID, szWeapon, charsmax(szWeapon))
		
		iWeaponEntity = find_ent_by_owner(-1, szWeapon, id)
		if(iWeaponEntity > 0)
		{
			cs_set_weapon_ammo(iWeaponEntity, getWeaponAmmo(iWeaponID))
		}
	}
	
	new menu = menu_create("\r[ \wCSGOM \d| \yBuy Menu\r ]", "_xMenuGuns")
	new szItem[64]
	
	menu_additem(menu, "Skip for pistol menu", "1")
	for(new i, iWeaponID;i < sizeof g_szRiflesList;i++)
	{
		iWeaponID = get_weaponid(g_szRiflesList[i][szWeaponInfo])
		if(iWeaponID == CSW_AWP)
		{
			if(getAwpNum() >= MAX_AWP_PER_ROUND)
			{
				formatex(szItem, charsmax(szItem), "\d%s \r| \y%d $ \d[ %d Max. ]", g_szRiflesList[i][szWeaponName], g_szRiflesList[i][iPrice], MAX_AWP_PER_ROUND)
			}
			else formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ \d[ %d Max. ]", ((cs_get_user_money(id) < g_szRiflesList[i][iPrice]) || user_has_weapon(id, iWeaponID)) ? "\d" : "\w", g_szRiflesList[i][szWeaponName], g_szRiflesList[i][iPrice], MAX_AWP_PER_ROUND)
		}
		else 
		{
			if((iWeaponID == CSW_M4A1) || (iWeaponID == CSW_FAMAS))
			{
				if(iWeaponID == CSW_M4A1)
				{
					if(user_has_weapon(id, CSW_M4A1))
					{
						if(csgom_has_m4a4skin(id) || csgom_using_m4a4_default(id))
						{
							formatex(szItem, charsmax(szItem), "\dCS:GO | M4A4 \r| \y%d $ \d[ALREADY HAVE]", g_szRiflesList[i][iPrice])
							menu_additem(menu, szItem)
							
							formatex(szItem, charsmax(szItem), "CS:GO | M4A1-S \r| \y%d $", g_szRiflesList[i][iPrice])
							menu_additem(menu, szItem)
							
							i++
							continue
						}
						else if(csgom_has_m4a1skin(id) || csgom_using_m4a1_default(id))
						{
							formatex(szItem, charsmax(szItem), "CS:GO | M4A4 \r| \y%d $", g_szRiflesList[i][iPrice])
							menu_additem(menu, szItem)
							
							formatex(szItem, charsmax(szItem), "\dCS:GO | M4A1-S \r| \y%d $ \d[ALREADY HAVE]", g_szRiflesList[i][iPrice])
							menu_additem(menu, szItem)
							
							i++
							continue
						}
					}
					else formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $", ((get_user_team(id) == 1) || (cs_get_user_money(id) < g_szRiflesList[i][iPrice])) ? "\d" : "\w", g_szRiflesList[i][szWeaponName], g_szRiflesList[i][iPrice])
				}
				else formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ %s", ((get_user_team(id) == 1) || user_has_weapon(id, iWeaponID)) ? "\d" : "\w", g_szRiflesList[i][szWeaponName], g_szRiflesList[i][iPrice], user_has_weapon(id, iWeaponID) ? "\d[ALREADY HAVE]" : "")
			}
			else if((iWeaponID == CSW_AK47) || (iWeaponID == CSW_GALIL) || (iWeaponID == CSW_MAC10))
			{
				formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ %s", ((get_user_team(id) == 2) || user_has_weapon(id, iWeaponID) || (cs_get_user_money(id) < g_szRiflesList[i][iPrice])) ? "\d" : "\w", g_szRiflesList[i][szWeaponName], g_szRiflesList[i][iPrice], user_has_weapon(id, iWeaponID) ? "\d[ALREADY HAVE]" : "")
			}
			else formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ %s", ((cs_get_user_money(id) < g_szRiflesList[i][iPrice]) || user_has_weapon(id, iWeaponID)) ? "\d" : "\w", g_szRiflesList[i][szWeaponName], g_szRiflesList[i][iPrice], user_has_weapon(id, iWeaponID) ? "\d[ALREADY HAVE]" : "")
		}
		menu_additem(menu, szItem)
	}
	
	menu_display(id, menu)
}

public _xMenuGuns(id, menu, item)
{
	if((item == MENU_EXIT) || !is_user_alive(id))
	{
		menu_destroy(menu); 
		return PLUGIN_HANDLED;
	}

	if(!cs_get_user_buyzone(id))
	{
		ChatColor(id, "Turn back to the buyzone!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	
	if(item == 0)
	{
		menu_destroy(menu)
		openPistolsMenu(id)
		return PLUGIN_HANDLED
	}
	item -= 1

	new iCswWeapon = get_weaponid(g_szRiflesList[item][szWeaponInfo])
	if(user_has_weapon(id, iCswWeapon))
	{
		new bool:bShouldBlock = true
		if(iCswWeapon == CSW_M4A1)
		{
			if((containi(g_szRiflesList[item][szWeaponName], "M4A1-S") != -1) && (csgom_has_m4a4skin(id) || csgom_using_m4a4_default(id)))
			{
				bShouldBlock = false
			}
			else if((containi(g_szRiflesList[item][szWeaponName], "M4A4") != -1) && (csgom_has_m4a1skin(id) || csgom_using_m4a1_default(id)))
			{
				bShouldBlock = false
			}
		}
		
		if(bShouldBlock)
		{
			ChatColor(id, "You already have that weapon!")
			menu_display(id, menu)
			return PLUGIN_HANDLED
		}
	}
	
	new iUserMoney = cs_get_user_money(id), iCost = g_szRiflesList[item][iPrice]
	if(iUserMoney < iCost)
	{
		ChatColor(id, "You do not have enough money!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if((iCswWeapon == CSW_M4A1) && (get_user_team(id) == 1))
	{
		ChatColor(id, "Only CT's can buy this weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if((iCswWeapon == CSW_AWP) && (getAwpNum() >= MAX_AWP_PER_ROUND))
	{
		ChatColor(id, "The awp is no longer avaliable.")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if(((iCswWeapon == CSW_AK47) || (iCswWeapon == CSW_GALIL) || (iCswWeapon == CSW_GALIL)) && (get_user_team(id) == 2))
	{
		ChatColor(id, "Only T's can buy this weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	
	if(iCswWeapon == CSW_M4A1)
	{
		if(containi(g_szRiflesList[item][szWeaponName], "M4A1-S") != -1)
		{
			csgom_reset_m4a4skin(id)
			csgom_use_m4a4_default(id, false)
			csgom_use_m4a1_default(id, true)
		}
		
		if(containi(g_szRiflesList[item][szWeaponName], "M4A4") != -1)
		{
			csgom_reset_m4a1skin(id)
			csgom_use_m4a4_default(id, true)
			csgom_use_m4a1_default(id, false)
		}
	}
	
	checkAlreadyExistingWeapon(id, 1)

	give_item(id, g_szRiflesList[item][szWeaponInfo])
	cs_set_user_bpammo(id, iCswWeapon, getMaxBpAmmo(iCswWeapon))
	cs_set_user_money(id, (iUserMoney - iCost))
	
	openPistolsMenu(id)
	return PLUGIN_HANDLED
}

openPistolsMenu(id)
{
	new menu = menu_create("\r[ \wCSGOM \d| \yBuy Menu\r ]", "_pistols_handler")
	new szItem[64]
	
	for(new i, iWeaponID;i < sizeof g_szPistolList;i++)
	{
		iWeaponID = get_weaponid(g_szPistolList[i][szWeaponInfo])
		if((iWeaponID == CSW_ELITE) || (iWeaponID == CSW_GLOCK18))
		{
			formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ %s", ((get_user_team(id) == 2) || user_has_weapon(id, iWeaponID)) ? "\d" : "\w", g_szPistolList[i][szWeaponName], g_szPistolList[i][iPrice], user_has_weapon(id, iWeaponID) ? "\d[ALREADY HAVE]" : "")
		}
		else if((iWeaponID == CSW_FIVESEVEN) || (iWeaponID == CSW_USP))
		{
			formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ %s", ((get_user_team(id) == 1) || user_has_weapon(id, iWeaponID)) ? "\d" : "\w", g_szPistolList[i][szWeaponName], g_szPistolList[i][iPrice], user_has_weapon(id, iWeaponID) ? "\d[ALREADY HAVE]" : "")
		}
		else formatex(szItem, charsmax(szItem), "%s%s \r| \y%d $ %s", ((cs_get_user_money(id) < g_szPistolList[i][iPrice]) || user_has_weapon(id, iWeaponID)) ? "\d" : "\w", g_szPistolList[i][szWeaponName], g_szPistolList[i][iPrice], user_has_weapon(id, iWeaponID) ? "\d[ALREADY HAVE]" : "")
		menu_additem(menu, szItem)
	}
	
	menu_display(id, menu)
}

public _pistols_handler(id, menu, item)
{
	if((item == MENU_EXIT) || !is_user_alive(id))
	{
		if(!HasUserWeaponSlot(id, 2))
		{
			new isTerrorist = (get_user_team(id) == 1), iWeapon = isTerrorist ? CSW_GLOCK18 : CSW_USP
			give_item(id, isTerrorist ? "weapon_glock18" : "weapon_usp")
			cs_set_user_bpammo(id, iWeapon, getMaxBpAmmo(iWeapon))
		}
		menu_destroy(menu); 
		return PLUGIN_HANDLED;
	}

	new iCswWeapon = get_weaponid(g_szPistolList[item][szWeaponInfo])
	if(user_has_weapon(id, iCswWeapon))
	{
		ChatColor(id, "You already have that weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	
	new iUserMoney = cs_get_user_money(id), iCost = g_szPistolList[item][iPrice]
	if(iUserMoney < iCost)
	{
		ChatColor(id, "You do not have enough money!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if((iCswWeapon == CSW_USP) && (get_user_team(id) == 1))
	{
		ChatColor(id, "Only CT's can buy this weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if((iCswWeapon == CSW_FIVESEVEN) && (get_user_team(id) == 1))
	{
		ChatColor(id, "Only CT's can buy this weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if((iCswWeapon == CSW_ELITE) && (get_user_team(id) == 2))
	{
		ChatColor(id, "Only T's can buy this weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	else if((iCswWeapon == CSW_GLOCK18) && (get_user_team(id) == 2))
	{
		ChatColor(id, "Only T's can buy this weapon!")
		menu_display(id, menu)
		return PLUGIN_HANDLED
	}
	
	checkAlreadyExistingWeapon(id, 2)

	give_item(id, g_szPistolList[item][szWeaponInfo])
	cs_set_user_bpammo(id, iCswWeapon, getMaxBpAmmo(iCswWeapon))
	cs_set_user_money(id, (iUserMoney - iCost))
	return PLUGIN_HANDLED
}

checkAlreadyExistingWeapon(id, iSlotCheck)
{
	if(HasUserWeaponSlot(id, iSlotCheck))
	{
		new iWeapon = -1, iAttempts = 0
		while((iWeapon = getWeaponBoxID(id, iSlotCheck)) > 0)
		{
			if(iWeapon == CSW_P228)
				continue
				
			static szClassName[MAX_PLAYERS]
			pev(iWeapon, pev_classname, szClassName, charsmax(szClassName))
			engclient_cmd(id, "drop", szClassName)
			
			iAttempts++
			if(iAttempts > 10)
				break
		}
	}
}

getAwpNum()
{
	new iPlayers[32], iNum, iAwpNum
	get_players(iPlayers, iNum, "a")
	for(new i;i < iNum;i++)
	{
		if(user_has_weapon(iPlayers[i], CSW_AWP))
		{
			iAwpNum++
		}
	}
	return iAwpNum
}

getMaxBpAmmo(iWeaponID)
{
	switch(iWeaponID)
	{
		case CSW_AK47, CSW_M4A1, CSW_FAMAS, CSW_GALIL: 			return 90
		case CSW_P90, CSW_MAC10, CSW_UMP45, CSW_FIVESEVEN, CSW_USP: 	return 100
		case CSW_MP5NAVY, CSW_GLOCK18, CSW_ELITE: 			return 120
		case CSW_AWP, CSW_SCOUT: 					return 30
		case CSW_XM1014, CSW_M3: 					return 32
		case CSW_DEAGLE: 						return 35
		case CSW_P228: 							return 52
	}
	return 0
}

getWeaponAmmo(iWeaponID)
{
	switch(iWeaponID)
	{
		case CSW_AK47, CSW_MAC10, CSW_MP5NAVY, CSW_M4A1, CSW_ELITE: 	return 30
		case CSW_P90: 							return 50
		case CSW_FAMAS, CSW_UMP45: 					return 25
		case CSW_GALIL: 						return 35
		case CSW_FIVESEVEN, CSW_USP: 					return 12
		case CSW_GLOCK18: 						return 20
		case CSW_AWP, CSW_SCOUT: 					return 10
		case CSW_M3: 							return 8
		case CSW_DEAGLE, CSW_XM1014: 					return 7
		case CSW_P228: 							return 13
	}
	return 0
}

HasUserWeaponSlot(id, slot)
{
	return get_pdata_cbase(id, m_rgpPlayerItems_CBasePlayer[slot]) > 0;
} 
