#include <amxmodx>
#include <amxmisc>

new const grenade_snds[][] = 
{
	"csgom/radio/grenades/ct_flashbang01.wav",
	"csgom/radio/grenades/ct_flashbang02.wav",
	"csgom/radio/grenades/ct_flashbang03.wav",
	"csgom/radio/grenades/ct_grenade01.wav",
	"csgom/radio/grenades/ct_grenade02.wav",
	"csgom/radio/grenades/ct_grenade03.wav",
	"csgom/radio/grenades/ct_smoke01.wav",
	"csgom/radio/grenades/ct_smoke02.wav",
	"csgom/radio/grenades/ct_smoke03.wav",
	"csgom/radio/grenades/t_flashbang01.wav",
	"csgom/radio/grenades/t_flashbang02.wav",
	"csgom/radio/grenades/t_flashbang03.wav",
	"csgom/radio/grenades/t_grenade01.wav",
	"csgom/radio/grenades/t_grenade02.wav",
	"csgom/radio/grenades/t_grenade03.wav",
	"csgom/radio/grenades/t_smoke01.wav",
	"csgom/radio/grenades/t_smoke02.wav",
	"csgom/radio/grenades/t_smoke03.wav"
}

new const g_szRoundStartSounds[][] =
{
	"csgom/radio/roundstart/roundstart1.wav",
	"csgom/radio/roundstart/roundstart2.wav",
	"csgom/radio/roundstart/roundstart3.wav",
	"csgom/radio/roundstart/roundstart4.wav",
	"csgom/radio/roundstart/roundstart5.wav",
	"csgom/radio/roundstart/roundstart6.wav"
}

new grenade_txts[sizeof grenade_snds][65]

public plugin_init()
{
	register_plugin("CS:GO Grenade Callouts", "1.0", "hellmonja");
	register_message(get_user_msgid("SendAudio"), "Block_Msg_Audio");
	register_message(get_user_msgid("TextMsg"), "Block_Msg_Text");
	
	register_logevent("event_new_round",2,"0=World triggered","1=Round_Start")
	
	//Config File
	new szFilepath[64];
	get_configsdir(szFilepath, charsmax(szFilepath));
	add(szFilepath, charsmax(szFilepath), "/callouts.ini");

	new f = fopen(szFilepath, "rt");
	new szData[64], i = 0;

	while( !feof(f) && i < sizeof(grenade_snds)) 
	{ 
		fgets(f, szData, charsmax(szData));
		trim(szData);
		if(!szData[0] || szData[0] == ';' || szData[0] == '/' && szData[1] == '/')
			continue;
		
		copy(grenade_txts[i], charsmax(szData), szData);
		i++;
	}
	fclose(f);
}

public plugin_precache()
{
	for(new i; i < sizeof grenade_snds - 1; i++)
		precache_sound(grenade_snds[i]);

	for(new a;a < sizeof g_szRoundStartSounds;a++)
		precache_sound(g_szRoundStartSounds[a])
}

 
public event_new_round()
{
	set_task(0.1, "stopSound")
}

public stopSound()
{
	client_cmd(0, "stopsound")
	client_cmd(0, "spk ^"%s^"", g_szRoundStartSounds[random_num(0, sizeof g_szRoundStartSounds - 1)])
}
    
public Block_Msg_Audio(msg_id, msg_dest, msg_entity)
{
	if(get_msg_args() != 3 || get_msg_argtype(2) != ARG_STRING)
		return PLUGIN_CONTINUE

	new arg2[20];
	get_msg_arg_string(2, arg2, 19);
	
	if(equal(arg2[1], "!MRAD_FIREINHOLE"))
		return PLUGIN_HANDLED

	return PLUGIN_CONTINUE
}

public Block_Msg_Text()
{
	if(get_msg_args() != 5 || get_msg_argtype(3) != ARG_STRING || get_msg_argtype(5) != ARG_STRING)
		return PLUGIN_CONTINUE

	new arg3[16];
	get_msg_arg_string(3, arg3, 15);
    
	if(!equal(arg3, "#Game_radio"))
		return PLUGIN_CONTINUE

	new arg5[20];
	get_msg_arg_string(5, arg5, 19);
    
	if(equal(arg5, "#Fire_in_the_hole"))
		return PLUGIN_HANDLED

	return PLUGIN_CONTINUE
}

public grenade_throw(id, grenid, wpnid)
{
	if(!is_user_alive(id))
		return
	
	new players[32], pnum, playername[32];
	new team = get_user_team(id), flag, temp;
	
	get_players(players, pnum, "a");
	get_user_name(id, playername, charsmax(playername));
	if(team == 2) flag = 0; else flag = 9;
	
	for(new i = 1; i < pnum + 1; i++)
		if(get_user_team(i) == team)
		{
			switch(wpnid)
			{    
				case CSW_FLASHBANG:
					temp = random_num(0, 2) + flag;
				case CSW_HEGRENADE:
					temp = random_num(3, 5) + flag;
				case CSW_SMOKEGRENADE:
					temp = random_num(6, 8) + flag;
			}

			client_cmd(i,"spk ^"%s^"", grenade_snds[temp]);
			client_print(i, print_chat, "%s (RADIO): %s", playername, grenade_txts[temp]);
		}
}
