#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <csgom>
#include <nvault>

#define PLUGIN		"CSGOM: Music Kit"
#define VERSION		"1.0"
#define AUTHOR		"EFFEX"

#define MAX_MUSIC_KIT	30

enum iInfo
{
	szMusicName[32],
	szPrecache[64],
	iMusicPrice,
}

new const g_szMusicKits[][iInfo] =
{
	{"25 Bucks", "csgom/25.wav", 500},
	{"Faucet Failure", "csgom/bitch.wav", 800},
	{"Blessings", "csgom/blessings.wav", 500},
	{"Bugatti", "csgom/bugatti.wav", 700},
	{"Clout", "csgom/clout.wav", 650},
	{"DNA", "csgom/dna.wav", 1500},
	{"Baphomet", "csgom/dreaming.wav", 2200},
	{"Faster", "csgom/faster.wav", 500},
	{"Fkin Problems", "csgom/fkin.wav", 700},
	{"Act a Fool", "csgom/fool.wav", 650},
	{"Forever", "csgom/forever.wav", 500},
	{"Gucci Gang", "csgom/gang.wav", 1100},
	{"Godzilla", "csgom/godzilla.wav", 2200},
	{"Gooba", "csgom/gooba.wav", 2200},
	{"Where the hood", "csgom/hood.wav", 1200},
	{"Be humble", "csgom/humble.wav", 2200},
	{"Kush Coma", "csgom/kush.wav", 1500},
	{"M.A.A.D CITY", "csgom/maad.wav", 1100},
	{"Mercy", "csgom/mercy.wav", 650},
	{"Fort Minor", "csgom/name.wav", 750},
	{"No Limit", "csgom/nolimit.wav", 650},
	{"I'm not AFRAID", "csgom/notafraid.wav", 1700},
	{"Peso", "csgom/peso.wav", 550},
	{"PIMP", "csgom/pimp.wav", 1350},
	{"Welcome to the rodeo", "csgom/rodeo.wav", 1350},
	{"Shots go Off", "csgom/shots.wav", 550},
	{"I love strippers", "csgom/stripper.wav", 760}
}

new player_kit[33]

new g_nVault

new bool:g_bHasMusicKit[33][MAX_MUSIC_KIT]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	g_nVault = nvault_open("MusicKit")
}

public plugin_precache()
{
	for(new i;i < sizeof g_szMusicKits;i++)
	{
		precache_sound(g_szMusicKits[i][szPrecache])
	}
}

public plugin_natives()
{
	register_native("openMusicKitMenu", "_open")
	register_native("getUserMusicKit", "_getMusicKit")
}

public _getMusicKit()
{
	new id = get_param(1)
	if(!player_kit[id])
	{
		set_string(2, "None", charsmax(g_szMusicKits[]))
	}
	else set_string(2, g_szMusicKits[player_kit[id] - 1][szMusicName], charsmax(g_szMusicKits[]))	
}

public _open()
{
	openMusicKitMenu(get_param(1))
}

public client_connect(id)
{
	loadData(id)
}

public openMusicKitMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yMusic Kit Menu\r ]", "musick_handler")

	for(new i, szMenu[32];i < sizeof g_szMusicKits;i++)
	{
		if(g_bHasMusicKit[id][i])
		{
			 formatex(szMenu, charsmax(szMenu), "%s %s", g_szMusicKits[i][szMusicName], ((player_kit[id] - 1) == i) ? "\y[ON]" : "\r[OFF]")
		}
		else formatex(szMenu, charsmax(szMenu), "%s \r%d$", g_szMusicKits[i][szMusicName], g_szMusicKits[i][iMusicPrice])
		menu_additem(iMenu, szMenu)
	}
	
	menu_display(id, iMenu)
}

public musick_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	new iKey = iItem + 1
	if(g_bHasMusicKit[id][iItem])
	{
		if(player_kit[id] == iKey)
		{
			player_kit[id] = 0
		}
		else player_kit[id] = iKey
		openMusicKitMenu(id)
		return PLUGIN_HANDLED
	}
	
	if(csgom_getmoney(id) < g_szMusicKits[iItem][iMusicPrice])
	{
		ChatColor(id, "You do not have enough money.")
		menu_display(id, iMenu)
		return PLUGIN_HANDLED
	}
	
	player_kit[id] = iKey
	g_bHasMusicKit[id][iItem] = true
	
	csgom_setmoney(id, csgom_getmoney(id) - g_szMusicKits[iItem][iMusicPrice])
	ChatColor(id, "You successfuly bought^x04 %s", g_szMusicKits[iItem][szMusicName])
	
	saveData(id)
	return PLUGIN_HANDLED
}

public Event_Start_Round()
{
	client_cmd(0, "stopsound")
}

public user_mvp(iUserMVP)
{
	if(iUserMVP && player_kit[iUserMVP])
	{
		new szMVPName[32], iKey = player_kit[iUserMVP] - 1
		get_user_name(iUserMVP, szMVPName, charsmax(szMVPName))

		ChatColor(0, "Player^x03 %s^x01 Did a Great Play so we are Playing his Selected Music:^x04 %s", szMVPName, g_szMusicKits[iKey][szMusicName])
		client_cmd(0, "stopsound")
		client_cmd(0, "spk ^"%s^"", g_szMusicKits[iKey][szPrecache])
	}
}

saveData(id)
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save_Musickit", szSteam)
	format(vaultdata, charsmax(vaultdata), "%i", player_kit[id])
	
	for(new i;i < MAX_MUSIC_KIT;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_bHasMusicKit[id][i])    
	}
	nvault_set(g_nVault, vaultkey, vaultdata)
}

loadData(id) 
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save_Musickit", szSteam)
	format(vaultdata, charsmax(vaultdata), "%i", player_kit[id])
	
	for(new i;i < MAX_MUSIC_KIT;i++)
	{
		formatex(vaultdata, charsmax(vaultdata), "%s %i", vaultdata, g_bHasMusicKit[id][i])  
	}
	nvault_get(g_nVault, vaultkey, vaultdata, charsmax(vaultdata))
	
	new Data[MAX_MUSIC_KIT][8]
	
	// WTF
	parse(vaultdata, Data[0], charsmax(Data[]), Data[1], charsmax(Data[]), Data[2], charsmax(Data[]), Data[3], charsmax(Data[]), 
	Data[4], charsmax(Data[]), Data[5], charsmax(Data[]),Data[6], charsmax(Data[]), Data[7], charsmax(Data[]), Data[8], charsmax(Data[]), 
	Data[9], charsmax(Data[]), Data[10], charsmax(Data[]), Data[11], charsmax(Data[]), Data[12], charsmax(Data[]),Data[13], charsmax(Data[]), 
	Data[14], charsmax(Data[]), Data[15], charsmax(Data[]), Data[16], charsmax(Data[]), Data[17], charsmax(Data[]), Data[18], charsmax(Data[]), 
	Data[19], charsmax(Data[]), Data[20], charsmax(Data[]), Data[21], charsmax(Data[]), Data[22], charsmax(Data[]), Data[23], charsmax(Data[]), 
	Data[24], charsmax(Data[]), Data[25], charsmax(Data[]), Data[26], charsmax(Data[]), Data[27], charsmax(Data[]), Data[28], charsmax(Data[]), 
	Data[29], charsmax(Data[]))
	
	for(new i;i < sizeof Data;i++)
	{
		if(i > 0)
		{
			g_bHasMusicKit[id][i - 1] = bool:str_to_num(Data[i])
		}
		else player_kit[id] = str_to_num(Data[i])
	}
}
