#include <amxmodx>
#include <fakemeta>
#include <xs>
#include <csgom>

#define PLUGIN  "CSGOM: Gun Drop Effect"
#define VERSION "1.0"
#define AUTHOR  "EFFEX"

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_forward(FM_Think, "xFwThink")
	register_forward(FM_Touch, "xFwTouch") 
}

public plugin_precache()
{
	for(new i;i < sizeof g_szRarityModels;i++)
	{
		precache_model(g_szRarityModels[i])
	}
}

public xFwTouch(touched, ent)
{
	if(!pev_valid(ent))
		return FMRES_IGNORED
	
	static xClassName[32]
	pev(ent, pev_classname, xClassName, charsmax(xClassName))
	
	if(equal(xClassName, "weaponbox") || equal(xClassName, DROP_GUN_CLASSNAME))
	{
		xFlatEnt(ent)
	}
	return FMRES_IGNORED
}

public xFwThink(ent)
{
	if(!pev_valid(ent))
		return FMRES_IGNORED
	
	static xClassName[32]
	pev(ent, pev_classname, xClassName, charsmax(xClassName))
	
	if(!equal(xClassName, DROP_GUN_CLASSNAME))
		return FMRES_IGNORED

	static xWpn
	xWpn = pev(ent, pev_iuser1)

	if(!pev_valid(xWpn))
	{
		engfunc(EngFunc_RemoveEntity, ent)
		return FMRES_SUPERCEDE
	}
	set_pev(ent, pev_nextthink, get_gametime())
	return FMRES_IGNORED
}

xFlatEnt(ent)
{
	if(pev(ent, pev_flags) & ~FL_ONGROUND) return
	
	static Float:origin[3], Float:traceto[3], trace = 0, Float:fraction, Float:angles[3], Float:angles2[3]
	
	pev(ent, pev_origin, origin)
	pev(ent, pev_angles, angles)
	
	xs_vec_sub(origin, Float:{0.0, 0.0, 10.0}, traceto)

	engfunc(EngFunc_TraceLine, origin, traceto, IGNORE_MONSTERS, ent, trace)

	get_tr2(trace, TR_flFraction, fraction)

	if(fraction == 1.0) return
	
	static Float:original_forward[3]
	angle_vector(angles, ANGLEVECTOR_FORWARD, original_forward)
	
	static Float:right[3], Float:up[3], Float:fwd[3]
	
	get_tr2(trace, TR_vecPlaneNormal, up)
	
	if(up[2] == 1.0) return
	
	xs_vec_cross(original_forward, up, right)
	xs_vec_cross(up, right, fwd)
	vector_to_angle(fwd, angles)
	vector_to_angle(right, angles2)

	angles[2] = -1.0 * angles2[0]
	
	set_pev(ent, pev_angles, angles)
}
