#include <amxmodx>
#include <amxmisc>
#include <csgom>

#define PLUGIN 		"CSGOM: Giveaway"
#define VERSION 	"1.0"
#define AUTHOR 		"EFFEX"

#define GIVE_AWAY_DELAY 25
#define MIN_PLAYERS	8

native getRandomAK(szWeaponSkinName[])
native getRandomAWP(szWeaponSkinName[])
native getRandomDeagle(szWeaponSkinName[])
native getRandomGlock(szWeaponSkinName[])
native getRandomKnife(szWeaponSkinName[])
native getRandomM4A1(szWeaponSkinName[])
native getRandomM4A4(szWeaponSkinName[])
native getRandomUsp(szWeaponSkinName[])

new g_forwardGiveWeapon, g_iReturn
new g_iWeaponSkinID, g_iWeaponID, g_szWeaponSkinName[MAX_MODEL_LENGTH + MAX_PLAYERS], bool:g_bM4A4

new bool:g_bJoinedGiveAway[MAX_PLAYERS + 1], bool:g_bGiveAwayStarted
new g_iCurrentRound

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	g_forwardGiveWeapon = CreateMultiForward("giveUserSkin", ET_STOP, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	getGiveAwaySkin()
	
	register_event("HLTV", "event_RoundStart", "a", "1=0", "2=0")
	
	register_clcmd("say /giveaway", "joinGiveaway")
	register_clcmd("amx_reload_giveaway", "cmdReloadGiveaway", ADMIN_BAN)
}

public plugin_natives()
{
	register_native("getSkinGiveForwardID", "_get")
	register_native("openGiveawayMenu", "joinGiveaway", 1)
}

public _get() return g_forwardGiveWeapon

public client_putinserver(id)
{
	g_bJoinedGiveAway[id] = false
}

public event_RoundStart()
{
	if(g_bGiveAwayStarted)
		return
		
	if(enoughPlayers())
		return

	g_iCurrentRound++
	if(g_iCurrentRound == GIVE_AWAY_DELAY)
	{
		if(!getGiveAwayPlayersNum())
		{
			g_bGiveAwayStarted = true
			ChatColor(0, "Nobody joined the ^4Giveaway")
			return
		}
		set_task(1.0, "countDown", .flags = "a", .repeat = 10)
	}
}

public cmdReloadGiveaway(id, iLevel, iCid)
{
	if(!cmd_access(id, iLevel, iCid, 1))
		return PLUGIN_HANDLED
		
	console_print(id, "[AMXX]: Successfuly reloaded the giveaway system!")
	
	new iPlayers[MAX_PLAYERS], iNum
	get_players(iPlayers, iNum, "ch")
	for(new i;i < iNum;i++)
	{
		g_bJoinedGiveAway[iPlayers[i]] = false
	}
	g_bGiveAwayStarted = false
	g_iCurrentRound = 0
	
	getGiveAwaySkin()
	return PLUGIN_HANDLED
}

public joinGiveaway(id)
{
	if(g_bGiveAwayStarted)
	{
		ChatColor(id, "The Giveaway is only avaible in the first^x04 %d rounds^x01 of every match.", GIVE_AWAY_DELAY)
		return PLUGIN_HANDLED
	}
	else if(enoughPlayers())
	{
		ChatColor(id, "The Giveaway is only avaible in with more than^x04 %d^x01 players.", MIN_PLAYERS)
		return PLUGIN_HANDLED
	}
	new iMenu = menu_create("\r[CSGOM] \wGiveaway", "ga_handler"), szItem[128]

	formatex(szItem, charsmax(szItem), "Skin \r[StatTrack (TM) %s]", g_szWeaponSkinName)
	menu_additem(iMenu, szItem)

	formatex(szItem, charsmax(szItem), "Players \r[%d]", getGiveAwayPlayersNum())
	menu_additem(iMenu, szItem)

	if((GIVE_AWAY_DELAY - g_iCurrentRound) == 0)
	{
		formatex(szItem, charsmax(szItem), "Countdown \r[Now]^n", (GIVE_AWAY_DELAY - g_iCurrentRound))
	}
	else
	{
		formatex(szItem, charsmax(szItem), "Countdown \r[%d rounds left]^n", (GIVE_AWAY_DELAY - g_iCurrentRound))
	}
	menu_additem(iMenu, szItem)

	formatex(szItem, charsmax(szItem), g_bJoinedGiveAway[id] ? "\rAlready Joined" : "Join Giveaway")
	menu_additem(iMenu, szItem)

	menu_display(id, iMenu)
	return PLUGIN_HANDLED
}

public ga_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}

	switch(iItem)
	{
		case 0, 1, 2: 
		{
			joinGiveaway(id)
			menu_destroy(iMenu)
			return PLUGIN_HANDLED
		}
		case 3:
		{
			if(g_bJoinedGiveAway[id])
			{
				joinGiveaway(id)
				menu_destroy(iMenu)
				return PLUGIN_HANDLED
			}	
			g_bJoinedGiveAway[id] = true
			
			new szName[32]
			get_user_name(id, szName, charsmax(szName))
			ChatColor(0, "Player^x04 %s^1 has joined the ^4Giveaway.", szName)
		}
	}
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}

public countDown()
{
	static iTime
	if(!iTime)
		iTime = 10
		
	set_hudmessage(47, 79, 79, -1.0, 0.22, 0, 0.1, 1.0)
	show_hudmessage(0, "The Giveaway winner will be choosen in %d second%s", iTime, (iTime == 1) ? "" : "s")
	iTime--
	
	if(!iTime)
	{
		new iWinner = getRandomWinner()
		if(iWinner == -1)
			return

		ExecuteForward(g_forwardGiveWeapon, g_iReturn, iWinner, g_iWeaponID, g_iWeaponSkinID, true, g_bM4A4, true) 
		
		new szWinnerName[MAX_PLAYERS]
		get_user_name(iWinner, szWinnerName, charsmax(szWinnerName))
		ChatColor(0, "Player^x04 %s^x01 won^x04 StatTrack (TM) %s^x01 at the ^x04Giveaway", szWinnerName, g_szWeaponSkinName)

		new iPlayers[MAX_PLAYERS], iNum
		get_players(iPlayers, iNum, "ch")
		for(new i;i < iNum;i++)
		{
			g_bJoinedGiveAway[iPlayers[i]] = false
		}
		g_bGiveAwayStarted = true
	}
}

enoughPlayers()
{
	new iPlayers[MAX_PLAYERS], iNum
	get_players(iPlayers, iNum, "ch")
	return bool:(iNum < MIN_PLAYERS)
}

getRandomWinner()
{
	if(!getGiveAwayPlayersNum())
		return -1
		
	new iPlayers[MAX_PLAYERS], iNum, iPlayer
	get_players(iPlayers, iNum, "ch")
	
	do 
	{
		iPlayer = iPlayers[random(iNum)]
	}
	while(!g_bJoinedGiveAway[iPlayer] || !is_user_connected(iPlayer))
	
	return g_bJoinedGiveAway[iPlayer] ? iPlayer : iPlayers[random(iNum)]
}

getGiveAwayPlayersNum()
{
	new iPlayers[MAX_PLAYERS], iNum, iCount
	get_players(iPlayers, iNum, "ch")
	
	for(new i;i < iNum;i++)
	{
		if(!g_bJoinedGiveAway[iPlayers[i]])
			continue
			
		iCount++
	}
	return iCount
}

getGiveAwaySkin()
{
	new randomi = random_num(0, 7)
	switch(randomi)
	{
		case 0:	g_iWeaponSkinID = getRandomAK(g_szWeaponSkinName), g_iWeaponID = CSW_AK47
		case 1:	g_iWeaponSkinID = getRandomAWP(g_szWeaponSkinName), g_iWeaponID = CSW_AWP
		case 2:	g_iWeaponSkinID = getRandomDeagle(g_szWeaponSkinName), g_iWeaponID = CSW_DEAGLE
		case 3: g_iWeaponSkinID = getRandomGlock(g_szWeaponSkinName), g_iWeaponID = CSW_GLOCK18
		case 4:	g_iWeaponSkinID = getRandomKnife(g_szWeaponSkinName), g_iWeaponID = CSW_KNIFE
		case 5:	g_iWeaponSkinID = getRandomM4A1(g_szWeaponSkinName), g_iWeaponID = CSW_M4A1, g_bM4A4 = false
		case 6:	g_iWeaponSkinID = getRandomM4A4(g_szWeaponSkinName), g_iWeaponID = CSW_M4A1, g_bM4A4 = true
		case 7:	g_iWeaponSkinID = getRandomUsp(g_szWeaponSkinName), g_iWeaponID = CSW_USP
	}
}
