#include <amxmodx>
#include <fakemeta>
#include <engine>
#include <hamsandwich>

new const EXPLOSION_SOUNDS[][] = { "csgom/weapons/he_explode1.wav", "csgom/weapons/he_explode2.wav", "csgom/weapons/he_explode3.wav" };
new Float:g_flGameTime, g_pGrenade;

new const g_szSmokeExplosionSound[] = "csgom/weapons/sg_explode.wav"
new const g_szNewFlashBangSound[] = "csgom/weapons/flashbang.wav"
new const g_szSGBounceSound[] = "csgom/weapons/grenade_hit1.wav"

public plugin_init()
{
	register_plugin("HE Explosion Sound", "1.0", "Crazy")
	
	register_message(SVC_TEMPENTITY, "MsgFunc_TempEntity");
	RegisterHam(Ham_Think, "grenade", "CGrenade_Think");
    
	register_forward(FM_EmitSound, "fw_EmitSound")
}

public plugin_precache()
{
	precache_sound(g_szNewFlashBangSound)
	precache_sound(g_szSmokeExplosionSound)
	precache_sound(g_szSGBounceSound)

	for (new i = 0; i < sizeof EXPLOSION_SOUNDS; i++)
		precache_sound(EXPLOSION_SOUNDS[i]);
}

public MsgFunc_TempEntity(iMsgId, iMsgDest, pMsgEnt)
{
	if (get_msg_arg_int(1) != TE_EXPLOSION)
		return PLUGIN_CONTINUE;

	if (get_gametime() != g_flGameTime)
		return PLUGIN_CONTINUE;
    
	set_msg_arg_int(8, ARG_BYTE, TE_EXPLFLAG_NOSOUND);
	emit_sound(g_pGrenade, CHAN_WEAPON, EXPLOSION_SOUNDS[random(sizeof EXPLOSION_SOUNDS)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	return PLUGIN_CONTINUE;
}

public CGrenade_Think(this)
{
	if(!is_valid_ent(this))
		return HAM_IGNORED;

	if (entity_get_float(this, EV_FL_dmg) <= 40.0)
		return HAM_IGNORED;

	static Float:flGameTime;
	flGameTime = get_gametime();

	if (entity_get_float(this, EV_FL_dmgtime) > flGameTime)
		return HAM_IGNORED;

	g_pGrenade = this;
	g_flGameTime = flGameTime;
	return HAM_IGNORED;
} 

public fw_EmitSound( id, iChannel, const szSound[ ] )
{
	if(equal(szSound, "weapons/sg_explode.wav"))
	{
		emit_sound( id, iChannel, g_szSmokeExplosionSound, 1.0, ATTN_NORM, 0, PITCH_NORM ) ;
		return FMRES_SUPERCEDE
	}
	else if( equal( szSound, "weapons/flashbang-1.wav" ) || equal( szSound, "weapons/flashbang-2.wav" ) ) 
	{
		emit_sound( id, iChannel, g_szNewFlashBangSound, 1.0, ATTN_NORM, 0, PITCH_NORM )
		return FMRES_SUPERCEDE
	}
	else if(equal(szSound, "weapons/grenade_hit1.wav") 
	|| equal(szSound, "weapons/grenade_hit2.wav") 
	|| equal(szSound, "weapons/grenade_hit3.wav")) 
	{
		emit_sound( id, iChannel, g_szSGBounceSound, 1.0, ATTN_NORM, 0, PITCH_NORM )
		return FMRES_SUPERCEDE
	}
	return FMRES_IGNORED
}
