#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN "CSGOM: Kill Sounds"
#define VERSION "1.0"
#define AUTHOR "EFFEX"

#define IsHeadShot(%1)			(get_pdata_int(%1,75) == HIT_HEAD)

new const Kills_Sounds[][] = 
{
	"csgom/kills/firstkill.wav",
	"csgom/kills/doublekill.wav",
	"csgom/kills/triplekill.wav",
	"csgom/kills/multikill.wav",
	"csgom/kills/excellent.wav",
	"csgom/kills/monster.wav",
	"csgom/kills/gotit.wav",
	"csgom/kills/craz.wav",
	"csgom/kills/headshot.wav"
}

new g_iUserKills[MAX_PLAYERS + 1]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	RegisterHam(Ham_Spawn,"player", "PlayerSpawn",1)
	RegisterHam(Ham_Killed, "player", "ham_Player_Killed_Post", 1)
}

public plugin_precache()
{
	for(new i; i < sizeof Kills_Sounds;i++)
	{
		precache_sound(Kills_Sounds[i])
	}
}

public PlayerSpawn(id)
{
	g_iUserKills[id] = 0
}

public ham_Player_Killed_Post(iVictim, iKiller, iShouldGib)
{
	if(!is_user_connected(iKiller) || iVictim == iKiller)
		return HAM_IGNORED
		
	g_iUserKills[iKiller]++

	set_dhudmessage(random(256), random(256), random(256), -1.0, 0.20, 0, 1.0, 3.0, 1.0, 1.0)
	show_dhudmessage(iKiller, "%dx", g_iUserKills[iKiller])
	
	set_dhudmessage(200, 200, 200, -1.0, 0.24, 0, 1.0, 3.0, 1.0, 1.0)
	show_dhudmessage(iKiller, "KILL!", g_iUserKills[iKiller])
	
	if(IsHeadShot(iVictim))
	{
		client_cmd(iKiller, "spk %s", Kills_Sounds[8])
			
		set_dhudmessage(200, 0, 0, -1.0, 0.28, 0, 1.0, 3.0, 1.0, 1.0)
		show_dhudmessage(iKiller, "HEAD SHOT")
	}
	else 
	{
		if(g_iUserKills[iKiller] > 7)
			return HAM_IGNORED
		
		client_cmd(iKiller, "spk ^"%s^"", Kills_Sounds[g_iUserKills[iKiller] - 1])
	}
	return HAM_IGNORED
}
