#include <amxmodx>
#include <amxmisc>
#include <csgom>
#include <nvault>

#define PLUGIN "CSGOM: Main Menu"
#define VERSION "1.0"
#define AUTHOR "EFFEX"

#define DELAY_ROUNDS 5
#define MAX_RANDOM_PLAYERS	4

native is_user_registered(id)
native openGraffitiMenu(id)
native openMusicKitMenu(id)
native openCrosshairMenu(id)
native openExchangeMenu(id)
native openMarketMenu(id)
native openGiveawayMenu(id)

native giveRandomAK(id)
native giveRandomAWP(id)
native giveRandomKnife(id)
native giveRandomUSP(id)
native giveRandomM4A1(id)
native giveRandomM4A4(id)
native giveRandomDeagle(id)
native giveRandomGlock(id)
native giveRandomGraffiti(id)

native openAkMenu(id, iMethod)
native openAwpMenu(id, iMethod)
native openKnifeMenu(id, iMethod)
native openUspMenu(id, iMethod)
native openM4A1Menu(id, iMethod)
native openM4A4Menu(id, iMethod)
native openDeagleMenu(id, iMethod)
native openGlockMenu(id, iMethod)
				
new userKeys[33], userCases[33]
new g_nVault
new round_count

new const g_szCaseSound[] = "csgom/case.wav"
new const g_szCaseSoundKnife[] = "csgom/case_holyshit.wav"

new g_szServerName[32]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	get_user_name(0, g_szServerName, charsmax(g_szServerName))
	
	g_nVault = nvault_open("Keys")

	register_concmd("amx_give_key", "cmdGiveKey", ADMIN_KICK, "<nick> <value> - give/took key to an user (use negative value to take from)")
	register_concmd("amx_give_case", "cmdGiveCase", ADMIN_KICK, "<nick> <value> - give/took case to an user (use netative value to take from)")
	
	register_message(get_user_msgid("TextMsg"), "MSG_TextMessage")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	register_clcmd("chooseteam", "cmdChooseTeam")
}

public plugin_natives()
{
	register_native("openSkinsMenu", "_open")
}

public _open() openSkinsMenu(get_param(1), get_param(2))

public cmdGiveKey(id, iLevel, iCid)
{
	if(!cmd_access(id, iLevel, iCid, 3))
		return PLUGIN_HANDLED

	new szTarget[MAX_PLAYERS], szValue[10]
	read_argv(1, szTarget, charsmax(szTarget))
	read_argv(2, szValue, charsmax(szValue))
	
	new iTarget = cmd_target(id, szTarget, CMDTARGET_NO_BOTS)
	if(!iTarget)
		return PLUGIN_HANDLED
		
	new szAdminName[MAX_PLAYERS], szTargetName[MAX_PLAYERS]
	get_user_name(id, szAdminName, charsmax(szAdminName))
	get_user_name(iTarget, szTargetName, charsmax(szTargetName))
	
	new iValue = str_to_num(szValue)
	new bool:bValueType = bool:(containi(szValue, "-") != -1)

	userKeys[iTarget] += iValue
	ChatColor(0, "Admin^x04 %s^x01 %s^x04 %d^x01 key%s %s^x01 %s.", szAdminName, bValueType ? "took" : "gave", iValue, (iValue > 1) ? "s" : "", bValueType ? "from" : "to", szTargetName)
	saveData(iTarget)
	return PLUGIN_HANDLED
}

public cmdGiveCase(id, iLevel, iCid)
{
	if(!cmd_access(id, iLevel, iCid, 3))
		return PLUGIN_HANDLED

	new szTarget[MAX_PLAYERS], szValue[10]
	read_argv(1, szTarget, charsmax(szTarget))
	read_argv(2, szValue, charsmax(szValue))
	
	new iTarget = cmd_target(id, szTarget, CMDTARGET_NO_BOTS)
	if(!iTarget)
		return PLUGIN_HANDLED
		
	new szAdminName[MAX_PLAYERS], szTargetName[MAX_PLAYERS]
	get_user_name(id, szAdminName, charsmax(szAdminName))
	get_user_name(iTarget, szTargetName, charsmax(szTargetName))
	
	new iValue = str_to_num(szValue)
	new bool:bValueType = bool:(containi(szValue, "-") != -1)

	userCases[iTarget] += iValue
	ChatColor(0, "Admin^x04 %s^x01 %s^x04 %d^x01 case%s %s^x01 %s.", szAdminName, bValueType ? "took" : "gave", iValue, (iValue > 1) ? "s" : "", bValueType ? "from" : "to", szTargetName)
	saveData(iTarget)
	return PLUGIN_HANDLED
}

public plugin_precache()
{
	precache_sound(g_szCaseSound)
	precache_sound(g_szCaseSoundKnife)
}

public plugin_end()
{
	nvault_close(g_nVault)
}

public client_connect(id)
{
	loadData(id)
}

public MSG_TextMessage() 
{
	static TextMsg[22];
	get_msg_arg_string(2, TextMsg, charsmax(TextMsg))
	if(equal(TextMsg, "#Terrorists_Win")) 
	{
		return PLUGIN_HANDLED;
	}
	else if(equal(TextMsg, "#CTs_Win")) 
	{
		return PLUGIN_HANDLED;
	}
	else if(equal(TextMsg, "#Bomb_Defused")) 
	{
		return PLUGIN_HANDLED;
	}
	else if(equal(TextMsg, "#Target_Bombed")) 
	{
		return PLUGIN_HANDLED;
	}
	else if(equal(TextMsg, "#Target_Saved")) 
	{
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;
}

public user_mvp(id)
{
	if(!(1 <= id <= get_maxplayers()))
		return

	new szUserName[32]
	get_user_name(id, szUserName, charsmax(szUserName))
	ChatColor(0, "Player^x03 %s^x01 received a case because of^x04 Great Play.", szUserName)
	
	userCases[id]++
	saveData(id)
}

public event_round_start()
{
	round_count++
	if(round_count == DELAY_ROUNDS)
	{
		set_task(0.1, "giveRandomPlayerAward")
	}
}

public giveRandomPlayerAward()
{
	new iPlayers[32], iNum, iRandomPlayers, iRandomPlayerID, bool:bPlayerAdded[33], szUserName[32]
	get_players(iPlayers, iNum, "ach")
		
	new iLoopValue = (iNum < MAX_RANDOM_PLAYERS) ? iNum : MAX_RANDOM_PLAYERS
	while(iRandomPlayers < iLoopValue)
	{
		iRandomPlayerID = iPlayers[random_num(0, iNum)]
		if(!bPlayerAdded[iRandomPlayerID] && is_user_connected(iRandomPlayerID))
		{
			get_user_name(iRandomPlayerID, szUserName, charsmax(szUserName))
			if(!equal(szUserName, g_szServerName))
			{
				switch(random_num(0, 2))
				{
					case 0: 
					{
						ChatColor(0, "Player^x03 %s^x01 received a case randomly.", szUserName)
						userCases[iRandomPlayerID]++
					}
					case 1: 
					{
						ChatColor(0, "Player^x03 %s^x01 received a free key randomly.", szUserName)
						userKeys[iRandomPlayerID]++
					}
					case 2: 
					{
						new iRandomValue = random_num(25, 40)
						ChatColor(0, "Player^x03 %s^x01 received a^x04 %d$^x01 CSGO Coins randomly.", szUserName, iRandomValue)
						
						csgom_setmoney(iRandomPlayerID, csgom_getmoney(iRandomPlayerID) + iRandomValue)
					}
				}
				saveData(iRandomPlayerID)
					
				bPlayerAdded[iRandomPlayerID] = true
				iRandomPlayers++
			}
		}
	}
	round_count = 0
}

public cmdChooseTeam(id)
{
	if(!is_user_registered(id))
		return PLUGIN_CONTINUE
		
	openMainMenu(id)
	return PLUGIN_HANDLED
}

public openMainMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yMain Menu\r ]", "main_handler")
	menu_additem(iMenu, "\rSkins Menu")
	menu_additem(iMenu, "Open Case")
	
	new szFormat[35]
	formatex(szFormat, charsmax(szFormat), "Fix your weapon: \y(%d$ CSGO Gold)", PRICE_TO_RESTORE)
	menu_additem(iMenu, szFormat)
	
	menu_additem(iMenu, "Join Giveaway")
	menu_additem(iMenu, "Exchange CSGO Coins")
	menu_additem(iMenu, "\yMarket Place")
	menu_additem(iMenu, "Music Kit")
	menu_additem(iMenu, "Crosshair Menu")
	menu_additem(iMenu, "Graffiti Shop")
	
	menu_display(id, iMenu)
}

public main_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	switch(iItem)
	{
		case 0: askWhichMenu(id)
		case 1: openCaseMenu(id)
		case 2: 
		{
			if(csgom_get_goldmoney(id) < PRICE_TO_RESTORE)
			{
				ChatColor(id, "You do not have enough Gold to restore!")
				menu_display(id, iMenu)
				return PLUGIN_HANDLED
			}
			openSkinsMenu(id, FIX_WEAPON)
		}
		case 3:	openGiveawayMenu(id)
		case 4: openExchangeMenu(id)
		case 5: openMarketMenu(id)
		case 6: openMusicKitMenu(id)
		case 7: openCrosshairMenu(id)
		case 8: openGraffitiMenu(id)
	}
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}

askWhichMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yWhich Menu?\r ]", "ask_handler")
	
	menu_additem(iMenu, "Use Skins")
	menu_additem(iMenu, "\yBuy Skins")
	menu_additem(iMenu, "Open Inventory")
	menu_additem(iMenu, "\rSell Skins")
	menu_additem(iMenu, "Trade SKins")

	menu_display(id, iMenu)
}

public ask_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	openSkinsMenu(id, iItem)
	return PLUGIN_HANDLED
}

openCaseMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yCase Menu\r ]", "case_handler"), szItem[64]
	
	if(userKeys[id] > 0)
	{
		formatex(szItem, charsmax(szItem), "Use Keys \r[%d]", userKeys[id])
	}
	else formatex(szItem, charsmax(szItem), "\dBuy Keys \r[No Keys]")
	menu_additem(iMenu, szItem)
	
	if(userCases[id] > 0)
	{
		formatex(szItem, charsmax(szItem), "Use Cases \r[%d]", userCases[id])
	}
	else formatex(szItem, charsmax(szItem), "\dBuy Cases")
	menu_additem(iMenu, szItem)
	
	menu_display(id, iMenu)
}

public case_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	switch(iItem)
	{
		case 0: openKeysMenu(id)
		case 1:
		{
			if(!userKeys[id])
			{
				ChatColor(id, "You do not have keys to open cases!")
				menu_display(id, iMenu)
				return PLUGIN_HANDLED
			}
			else if(!userCases[id])
			{
				openCasesMenu(id)
				menu_display(id, iMenu)
				return PLUGIN_HANDLED
			}
			else
			{
				userKeys[id] -= 1
				userCases[id] -= 1
				
				new iRandom = random_num(1, 100)
				switch(iRandom)
				{
					case 1..10: giveRandomAK(id)
					case 11..21: giveRandomAWP(id)
					case 22..23: giveRandomKnife(id)
					case 24..40: giveRandomUSP(id)
					case 41..48: giveRandomM4A1(id)
					case 49..55: giveRandomM4A4(id)
					case 56..66: giveRandomDeagle(id)
					case 67..75: giveRandomGlock(id)
					case 76..100: giveRandomGraffiti(id)
				}
				client_cmd(id, "spk ^"%s^"", (iRandom == 2) ? g_szCaseSoundKnife : g_szCaseSound)

				message_begin(MSG_ONE, get_user_msgid("ScreenFade"), .player = id)
				write_short(4300)
				write_short(0)
				write_short(0)
				write_byte(255)
				write_byte(255) 
				write_byte(255) 
				write_byte(65) 
				message_end()
				
				saveData(id)
			}
		}
	}
	return PLUGIN_HANDLED
}

openKeysMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yKey Menu\r ]", "keys_handler")
	menu_additem(iMenu, "Buy Key for \d5000$")
	
	menu_display(id, iMenu)
}

public keys_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	if(csgom_getmoney(id) < 5000)
	{
		ChatColor(id, "You do not have enough money to buy the key!")
		menu_display(id, iMenu)
		return PLUGIN_HANDLED
	}

	message_begin(MSG_ONE, get_user_msgid("ScreenFade"), .player = id)
	write_short(4300)
	write_short(0)
	write_short(0)
	write_byte(255)
	write_byte(255) 
	write_byte(255) 
	write_byte(65) 
	message_end()
	
	userKeys[id] += 1
	saveData(id)
	
	csgom_setmoney(id, csgom_getmoney(id) - 100)
	ChatColor(id, "You successfuly bought a key, now try your luck and open it for gain skins!")
	return PLUGIN_HANDLED
}

openCasesMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yCases Menu\r ]", "cases_handler")
	menu_additem(iMenu, "Buy Key for \d2000$")
	
	menu_display(id, iMenu)
}

public cases_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	if(csgom_getmoney(id) < 2000)
	{
		ChatColor(id, "You do not have enough money to buy the case!")
		menu_display(id, iMenu)
		return PLUGIN_HANDLED
	}

	message_begin(MSG_ONE, get_user_msgid("ScreenFade"), .player = id)
	write_short(4300)
	write_short(0)
	write_short(0)
	write_byte(255)
	write_byte(255) 
	write_byte(255) 
	write_byte(65) 
	message_end()
	
	userCases[id] += 1
	saveData(id)
	
	csgom_setmoney(id, csgom_getmoney(id) - 100)
	ChatColor(id, "You successfuly bought a case, now try your luck and open it for gain skins!")
	return PLUGIN_HANDLED
}

openSkinsMenu(id, iMethod)
{
	log_amx("iMethod: %d", iMethod)
	new iMenu = menu_create("\r[ \wCSGOM \d| \ySkins Menu\r ]", "skins_handler")
	
	new szMethod[2]
	num_to_str(iMethod, szMethod, charsmax(szMethod))
	
	menu_additem(iMenu, "AK47 Skins", szMethod)
	menu_additem(iMenu, "AWP Skins", szMethod)
	menu_additem(iMenu, "Knife Skins", szMethod)
	menu_additem(iMenu, "M4A1-S Skins", szMethod)
	menu_additem(iMenu, "M4A4 Skins", szMethod)
	menu_additem(iMenu, "Desert Eagle Skins", szMethod)
	menu_additem(iMenu, "Glock-18 Skins", szMethod)
	menu_additem(iMenu, "USP-S Skins", szMethod)
	
	menu_display(id, iMenu)
}

public skins_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	new szData[6], szItemName[64]
	new _access, item_callback
	menu_item_getinfo(iMenu, iItem, _access, szData, charsmax(szData), szItemName, charsmax(szItemName), item_callback)
	
	new iMethod = str_to_num(szData)
	switch(iItem)
	{
		case 0: openAkMenu(id, iMethod)
		case 1: openAwpMenu(id, iMethod)
		case 2: openKnifeMenu(id, iMethod)
		case 3: openM4A1Menu(id, iMethod)
		case 4: openM4A4Menu(id, iMethod)
		case 5: openDeagleMenu(id, iMethod)
		case 6: openGlockMenu(id, iMethod)
		case 7: openUspMenu(id, iMethod)
	}
	return PLUGIN_HANDLED
}

saveData(id)
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save_CaseS", szSteam)  
	format(vaultdata, charsmax(vaultdata), "%i %i", userKeys[id], userCases[id])
	nvault_set(g_nVault, vaultkey, vaultdata)
}

loadData(id) 
{
	new szSteam[35]
	get_user_authid(id, szSteam, charsmax(szSteam)) 
    
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save_CaseS", szSteam)  
	format(vaultdata, charsmax(vaultdata), "%i %i", userKeys[id], userCases[id])
	nvault_get(g_nVault, vaultkey, vaultdata, charsmax(vaultdata))

	new szKeys[10], szCases[10]
	parse(vaultdata, szKeys, charsmax(szKeys), szCases, charsmax(szCases))
	
	userKeys[id] = str_to_num(szKeys)
	userCases[id] = str_to_num(szCases)
}
