#include <amxmodx>
#include <csgom>

#define PLUGIN "CSGOM: Market Place"
#define VERSION "1.0"
#define AUTHOR "EFFEX"

new g_forwardBoughtItem

enum _:cMarketData
{
	szSkinName[MAX_PLAYERS],
	iSkinSellerID,
	iSkinSellingCSW,
	iSkinSellingID,
	iSkinPrice,
	bool:bIsStatt
}

new Array:g_arrayMarketSkins
new g_iReturn

new g_iItemToDelete[MAX_PLAYERS + 1]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd("say /market", "marketMenu")
	g_forwardBoughtItem = CreateMultiForward("boughtSkinFromMarket", ET_STOP, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
}

public plugin_natives()
{
	g_arrayMarketSkins = ArrayCreate(cMarketData)
	
	register_native("registerItemInInventory", "_register")
	register_native("openMarketMenu", "marketMenu", 1)
}

public _register()
{
	new szNativeParams[MAX_MODEL_LENGTH], arrayData[cMarketData]
	get_string(6, szNativeParams, charsmax(szNativeParams))
	copy(arrayData[szSkinName], charsmax(arrayData), szNativeParams)
	
	arrayData[iSkinSellerID] = get_param(1)
	arrayData[iSkinSellingCSW] = get_param(2)
	arrayData[iSkinSellingID] = get_param(3)
	arrayData[iSkinPrice] = get_param(4)
	arrayData[bIsStatt] = bool:get_param(5)
	
	ArrayPushArray(g_arrayMarketSkins, arrayData)
}

public marketMenu(id)
{
	new iSize = ArraySize(g_arrayMarketSkins)
	if(!iSize)
	{
		ChatColor(id, "There are no items in the market place yet!")
		client_cmd(id, "chooseteam")
		return
	}
	static szTittle[60]
	formatex(szTittle, charsmax(szTittle), "CSGOM - Market Place^n\dGOMoney: %d", csgom_getmoney(id))
	
	new iMenu = menu_create(szTittle, "market_handler")
	for(new i, arrayData[cMarketData], szSellerName[MAX_PLAYERS], szItemFmt[120];i < iSize;i++)
	{
		ArrayGetArray(g_arrayMarketSkins, i, arrayData)
		
		get_user_name(arrayData[iSkinSellerID], szSellerName, charsmax(szSellerName))
		formatex(szItemFmt, charsmax(szItemFmt), "%s - %s%s \r[%d$]", szSellerName, arrayData[bIsStatt] ? "\dStatTrack (TM)\w " : "", arrayData[szSkinName], arrayData[iSkinPrice])
		menu_additem(iMenu, szItemFmt)
	}
	menu_display(id, iMenu)
}

public market_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	new arrayData[cMarketData]
	ArrayGetArray(g_arrayMarketSkins, iItem, arrayData)
	
	if(id == arrayData[iSkinSellerID])
	{
		g_iItemToDelete[id] = iItem
		askToDeleteItem(id)
		return PLUGIN_HANDLED
	}
	ExecuteForward(g_forwardBoughtItem, g_iReturn, id, arrayData[iSkinSellerID], arrayData[iSkinSellingID], arrayData[iSkinSellingCSW], arrayData[bIsStatt], arrayData[iSkinPrice])
	ArrayDeleteItem(g_arrayMarketSkins, iItem)
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}

public askToDeleteItem(id)
{
	static szTittle[60]
	formatex(szTittle, charsmax(szTittle), "CSGOM - Do you wanna delete your item?^n\dGOMoney: %d", csgom_getmoney(id))
	new iMenu = menu_create(szTittle, "delete_handler")
	
	menu_additem(iMenu, "\yYes")
	menu_additem(iMenu, "\rNo")
	menu_display(id, iMenu)
}

public delete_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	if(iItem == 0)
	{
		ChatColor(id, "You successfuly deleted your skin from the market place.")
		ArrayDeleteItem(g_arrayMarketSkins, g_iItemToDelete[id])
	}
	else ChatColor(id, "Alright then...")
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}