#include <amxmodx>
#include <amxmisc>
#include <csgom>
#include <nvault>

#define PLUGIN 				"CSGOM: Money system"
#define VERSION 			"1.0"
#define AUTHOR 				"EFFEX"

#define EXCHANGE_VALUE_CALC 5

new g_iUserCSM[MAX_PLAYERS + 1], g_iUserGCSC[MAX_PLAYERS + 1]

new pCvarNormalKill, pCvarHeadShotKill, pCvarHeKill, pCvarKnifeKill
new pCvarKnifeKillVictim

new g_nVaultMoney

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	g_nVaultMoney = nvault_open("PlayersMoney")

	pCvarNormalKill = register_cvar("csgom_normalkill", "500")
	pCvarHeadShotKill = register_cvar("csgom_hskill", "1000")
	pCvarHeKill = register_cvar("csgom_hekill", "800")
	pCvarKnifeKill = register_cvar("csgom_knifekill", "2000")
	pCvarKnifeKillVictim = register_cvar("csgom_knifekill_victim", "500")
	
	register_clcmd("amx_set_csgoc", "cmdSetCSGOM", ADMIN_CVAR, "<nick> <value - use negative to take a value>")
	register_clcmd("[CSGOM]Exchange_value", "exChangeValue")
	
	register_event("DeathMsg", "event_DeathMsg", "a")
}

public plugin_end()
{
	nvault_close(g_nVaultMoney)
}

public client_connect(id)
{
	loadData(id)
}

public plugin_natives()
{
	register_native("csgom_get_goldmoney", "_get_gold_money")
	register_native("csgom_set_goldmoney", "_set_gold_money")

	register_native("csgom_getmoney", "_getmoney")
	register_native("csgom_setmoney", "_setmoney")
	register_native("openExchangeMenu", "openExchange", 1)
}

public _get_gold_money() return g_iUserGCSC[get_param(1)]

public _set_gold_money()
{
	new id = get_param(1)
	
	g_iUserGCSC[id] = get_param(2)
	saveData(id)
}

public _getmoney() return g_iUserCSM[get_param(1)]

public _setmoney()
{
	new id = get_param(1)
	g_iUserCSM[id] = get_param(2)
	saveData(id)
}

public openExchange(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yExchange Menu\r ]", "exchange_handler")
	new szItem[64]
	
	formatex(szItem, charsmax(szItem), "\d%d CSGO Coins = 1 CSGO Gold", EXCHANGE_VALUE_CALC)
	menu_additem(iMenu, szItem)
	
	formatex(szItem, charsmax(szItem), "Your CSGO Coins:%s %d", g_iUserCSM[id] ? "\y" : "\r", g_iUserCSM[id])
	menu_additem(iMenu, szItem)
	
	formatex(szItem, charsmax(szItem), "Your CSGO Gold:%s %d", g_iUserGCSC[id] ? "\y" : "\r", g_iUserGCSC[id])
	menu_additem(iMenu, szItem)

	formatex(szItem, charsmax(szItem), "%sSelect to exchange to\y %d\w CSGO Gold^n----------------", (g_iUserCSM[id] < EXCHANGE_VALUE_CALC) ? "\d" : "\w", (g_iUserCSM[id] / EXCHANGE_VALUE_CALC))
	menu_additem(iMenu, szItem)

	formatex(szItem, charsmax(szItem), "\ySelect exchange manually")
	menu_additem(iMenu, szItem)
	
	menu_display(id, iMenu)
}

public exchange_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	switch(iItem)
	{
		case 0, 1, 2:
		{
			if(iItem == 2)
			{
				if(g_iUserCSM[id] < EXCHANGE_VALUE_CALC)
				{
					ChatColor(id, "You do not have enough CSGO Coin to exchange!")
					menu_display(id, iMenu)
					return PLUGIN_HANDLED
				}
			}
			menu_display(id, iMenu)
			return PLUGIN_HANDLED
		}
		case 3:
		{
			if(g_iUserCSM[id] < EXCHANGE_VALUE_CALC)
			{
				ChatColor(id, "You do not have enough CSGO Coin to exchange!")
				return PLUGIN_HANDLED
			}
		
			new iAwardValue = (g_iUserCSM[id] / EXCHANGE_VALUE_CALC)
			ChatColor(id, "You successfuly exchanged^x04 %d$^x01 CSGO Coin to^x04 %d$^x01 CSGO Gold!", g_iUserCSM[id], iAwardValue)
		
			g_iUserCSM[id] -= (iAwardValue * EXCHANGE_VALUE_CALC)
			g_iUserGCSC[id] += iAwardValue
		
			ChatColor(id, "Your new CSGO Coins value is^x04 %d.", g_iUserCSM[id])
			saveData(id)
		}
		case 4:
		{
			client_cmd(id, "messagemode [CSGOM]Exchange_value")
		}
	}
	
	return PLUGIN_HANDLED
}

new g_iExchangeGoal[MAX_PLAYERS + 1]

public exChangeValue(id)
{
	new szMessage[192]
	read_args(szMessage, charsmax(szMessage))
	remove_quotes(szMessage)	

	new iExchangeValue = str_to_num(szMessage), iAwardValue = (g_iUserCSM[id] / EXCHANGE_VALUE_CALC)
	if(g_iUserCSM[id] < EXCHANGE_VALUE_CALC)
	{
		ChatColor(id, "You do not have enough CSGO Coin to exchange!")
		client_cmd(id, "messagemode [CSGOM]Exchange_value")
		return PLUGIN_HANDLED
	}
	else if(iExchangeValue < EXCHANGE_VALUE_CALC)
	{
		ChatColor(id, "Invalid value!")
		client_cmd(id, "messagemode [CSGOM]Exchange_value")
		return PLUGIN_HANDLED
	}
	else if(iAwardValue < iExchangeValue)
	{
		ChatColor(id, "You do not have enough CSGO Coin to exchange to that value!")
		client_cmd(id, "messagemode [CSGOM]Exchange_value")
		return PLUGIN_HANDLED
	}
	
	g_iExchangeGoal[id] = iExchangeValue
	
	ChatColor(id, "To exchange^x04 %d^x01 CSGO Gold, you'll spent^x04 %d^x01 CSGO Coins, select confirm to continue..!", g_iExchangeGoal[id], (g_iExchangeGoal[id] * EXCHANGE_VALUE_CALC))
	confirmationMenu(id)
	return PLUGIN_HANDLED
}

confirmationMenu(id)
{
	new iMenu = menu_create("\r[ \wCSGOM \d| \yExchange Menu\r ]", "exchange2_handler")

	menu_additem(iMenu, "Confirm")
	menu_additem(iMenu, "Nah I give up")
	
	menu_display(id, iMenu)
}

public exchange2_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	if(!iItem)
	{		
		new iGoal = (g_iExchangeGoal[id] * EXCHANGE_VALUE_CALC)
		ChatColor(id, "You successfuly exchanged^x04 %d$^x01 CSGO Coin to^x04 %d$^x01 CSGO Gold!", iGoal, g_iExchangeGoal[id])
		
		g_iUserCSM[id] -= iGoal
		g_iUserGCSC[id] += g_iExchangeGoal[id]
		
		saveData(id)
		ChatColor(id, "Your new Balance is ^x04 %d^x01 CSGO Coin and^x04 %d^x01 CSGO Gold.", g_iUserCSM[id], g_iUserGCSC[id])
	}
	return PLUGIN_HANDLED
}

public cmdSetCSGOM(id, iLevel, iCid)
{
	if(!cmd_access(id, iLevel, iCid, 3))
		return PLUGIN_HANDLED

	new szTarget[MAX_PLAYERS], szValue[10]
	read_argv(1, szTarget, charsmax(szTarget))
	read_argv(2, szValue, charsmax(szValue))
	
	new iTarget = cmd_target(id, szTarget, CMDTARGET_NO_BOTS)
	if(!iTarget)
		return PLUGIN_HANDLED
		
	new szAdminName[MAX_PLAYERS], szTargetName[MAX_PLAYERS]
	get_user_name(id, szAdminName, charsmax(szAdminName))
	get_user_name(iTarget, szTargetName, charsmax(szTargetName))
	
	new iValue = str_to_num(szValue)
	new bool:bValueType = bool:(containi(szValue, "-") != -1)
	
	g_iUserCSM[iTarget] += iValue
	ChatColor(0, "Admin^x04 %s^x01 %s^x04 %d$^x01 csgom %s^x01 %s.", szAdminName, bValueType ? "took" : "gave", iValue, bValueType ? "from" : "to", szTargetName)
	saveData(iTarget)
	return PLUGIN_HANDLED
}

public event_DeathMsg()
{
	new iAttacker = read_data(1), iVictim = read_data(2)
	if(!is_user_connected(iAttacker) || (iAttacker == iVictim))
		return
		
	new szMessage[192], iValue
	if(read_data(3))
	{
		iValue = get_pcvar_num(pCvarHeadShotKill)
		if(access(iAttacker, ADMIN_RESERVATION))
		{
			iValue *= 2
		}
		formatex(szMessage, charsmax(szMessage), "Received ^x04+%d$^x01 for killing an enemy with headshot!", iValue)
		
		g_iUserCSM[iAttacker] += iValue
	}
	else
	{
		new szWeapon[20]
		read_data(4, szWeapon, charsmax(szWeapon))
		if(containi(szWeapon, "knife") != -1)
		{
			iValue = get_pcvar_num(pCvarKnifeKill)
			if(access(iAttacker, ADMIN_RESERVATION))
			{
				iValue *= 2
			}
			formatex(szMessage, charsmax(szMessage), "Received ^x04+%d$^x01 for killing an enemy with knife!", iValue)
			g_iUserCSM[iAttacker] += iValue
			
			if(!access(iVictim, ADMIN_RESERVATION))
			{
				new iCvar = get_pcvar_num(pCvarKnifeKillVictim)
				if(iCvar > 0)
				{
					ChatColor(iVictim, "You lost^x04 %d$^x01 for being killed with a knife!", iCvar)
					g_iUserCSM[iVictim] -= get_pcvar_num(pCvarKnifeKillVictim)
					saveData(iVictim)
				}
			}
		}
		else if(containi(szWeapon, "grenade") != -1)
		{
			iValue = get_pcvar_num(pCvarHeKill)
			if(access(iAttacker, ADMIN_RESERVATION))
			{
				iValue *= 2
			}
			
			formatex(szMessage, charsmax(szMessage), "Received ^x04+%d$^x01 for killing an enemy with grenade!", iValue)
			g_iUserCSM[iAttacker] += iValue
		}
		else 
		{
			replace(szWeapon, charsmax(szWeapon), "weapon_", "")
			replace(szWeapon, charsmax(szWeapon), "mp5navy", "mp7")
			replace(szWeapon, charsmax(szWeapon), "sg552", "sig")
			replace(szWeapon, charsmax(szWeapon), "m3", "nova")
			strtoupper(szWeapon)
			
			if(equal(szWeapon, "M4A1"))
			{
				szWeapon = (csgom_has_m4a4skin(iAttacker) || csgom_using_m4a4_default(iAttacker)) ? "M4A4" : "M4A1-S"
			}
	
			iValue = get_pcvar_num(pCvarNormalKill)
			if(access(iAttacker, ADMIN_RESERVATION))
			{
				iValue *= 2
			}
			formatex(szMessage, charsmax(szMessage), "Received ^x04+%d$^x01 for killing an enemy with %s.", iValue, szWeapon)
			g_iUserCSM[iAttacker] += iValue
		}
	}
	
	set_dhudmessage(random(255), random(255), random(255), -1.0, 0.16, 0, 1.0, 3.0, 1.0, 1.0)
	show_dhudmessage(iAttacker, "+%d CSGO Coins", iValue)
	
	ChatColor(iAttacker, szMessage)
	saveData(iAttacker)
}

saveData(id)
{
	new szAuthID[35]
	get_user_authid(id, szAuthID, charsmax(szAuthID))
	
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save", szAuthID)
	format(vaultdata, charsmax(vaultdata), "%i %i", g_iUserCSM[id], g_iUserGCSC[id])

	nvault_set(g_nVaultMoney, vaultkey, vaultdata)
}

loadData(id) 
{
	new szAuthID[35]
	get_user_authid(id, szAuthID, charsmax(szAuthID))
	
	new vaultkey[64], vaultdata[128]
	format(vaultkey, charsmax(vaultkey), "%s-Save", szAuthID)
	format(vaultdata, charsmax(vaultdata), "%i %i", g_iUserCSM[id], g_iUserGCSC[id])
	nvault_get(g_nVaultMoney, vaultkey, vaultdata, charsmax(vaultdata))
	
	new szCSGOC[10], szGCSGOC[10]
	parse(vaultdata, szCSGOC, charsmax(szCSGOC), szGCSGOC, charsmax(szGCSGOC))
		
	g_iUserCSM[id] = str_to_num(szCSGOC)
	g_iUserGCSC[id] = str_to_num(szGCSGOC)
}
