/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fakemeta_util>
#include <csx>

#define PLUGIN "MVP"
#define VERSION "1.0.3"
#define AUTHOR "Kia"

// ===============================================================================
// 	Variables
// ===============================================================================

/* Defines */

#define NO_BOMB_PLANTED 9191
#define NO_BOMB_DEFUSED 1919

#define CHECK_DELAY 0.1

/* Integers */

new g_iEnemiesKilled[33]
new g_iHostagesRescued[33]

new g_iBombPlanter
new g_iBombDefuser

/* Boolean */

new bool:g_bBombExploded
new bool:g_bAllHostagesRescued

// ===============================================================================
// 	plugin_init
// ===============================================================================

new g_iForward, g_iReturn
new g_iTeamWin

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	/* Events */
	
	g_iForward = CreateMultiForward("user_mvp", ET_STOP, FP_CELL)
	
	register_event("HLTV", "Event_NewRound", "a", "1=0", "2=0") 
	
	register_event("SendAudio", "Event_RoundWon_T" , "a", "2&%!MRAD_terwin") 
	register_event("SendAudio", "Event_RoundWon_CT", "a", "2&%!MRAD_ctwin")
	register_event("TextMsg", "Event_AllHostagesRescued", "a", "2&#All_Hostages_R");
	
	register_logevent("Event_HostageRescued", 3, "2=Rescued_A_Hostage") 
	
	register_event("DeathMsg", "Event_DeathMsg", "a")
}

// ===============================================================================
// 	Event_NewRound - Called when a new Round begins
// ===============================================================================

public Event_NewRound()
{
	g_iTeamWin = 0
	g_iBombPlanter = NO_BOMB_PLANTED
	g_iBombDefuser = NO_BOMB_DEFUSED
	
	g_bBombExploded = false
	g_bAllHostagesRescued = false
	
	arrayset(g_iEnemiesKilled, 0, sizeof(g_iEnemiesKilled))
	arrayset(g_iHostagesRescued, 0 , sizeof(g_iHostagesRescued))
}

// ===============================================================================
// 	Event_RoundWon_T - Called when the Counter-Terrorists when the Round
// ===============================================================================

public Event_RoundWon_T()
{
	set_task(CHECK_DELAY, "CheckTConditions")
	g_iTeamWin = 1
}

public CheckTConditions()
{
	if(g_bBombExploded)
		return PLUGIN_HANDLED

	if(g_iBombPlanter != NO_BOMB_PLANTED && g_bBombExploded == false)
	{
		new iTopKiller = GetTopKiller(1)
		ShowMVPMessage(iTopKiller)
		return PLUGIN_HANDLED
	}
	
	new iTopKiller = GetTopKiller(1)
	ShowMVPMessage(iTopKiller)
	return PLUGIN_HANDLED
}

// ===============================================================================
// 	Event_RoundWon_CT - Called when the Counter-Terrorists when the Round
// ===============================================================================

public Event_RoundWon_CT()
{
	set_task(CHECK_DELAY, "CheckCTConditions")
	g_iTeamWin = 2
}

public CheckCTConditions()
{
	if(g_iBombDefuser != NO_BOMB_DEFUSED)
	{
		ShowMVPMessage(g_iBombDefuser)
		return PLUGIN_HANDLED
	}
	
	if(g_bAllHostagesRescued)
	{
		new iTopRescuer = GetTopRescuer()
		ShowMVPMessage(iTopRescuer)
		return PLUGIN_HANDLED
	}
	
	new iTopKiller = GetTopKiller(2)
	ShowMVPMessage(iTopKiller)
	
	return PLUGIN_HANDLED
}

// ===============================================================================
// 	Event_AllHostagesRescued - Called when ALL Hostages were rescued
// ===============================================================================

public Event_AllHostagesRescued()
{
	g_bAllHostagesRescued = true
	
	new iTopRescuer = GetTopRescuer()
	ShowMVPMessage(iTopRescuer)	
}

// ===============================================================================
// 	Event_HostageRescued - Called when ONE Hostage was rescued
// ===============================================================================

public Event_HostageRescued()
{
	static szLog[80], szName[32], id
	
	read_logargv(0, szLog, charsmax(szLog))
	parse_loguser(szLog, szName, charsmax(szName))
	
	id = get_user_index(szName)
	
	g_iHostagesRescued[id]++
}	

// ===============================================================================
// 	Event_DeathMsg - Called when someone dies
// ===============================================================================

public Event_DeathMsg()
	g_iEnemiesKilled[read_data(1)]++

// ===============================================================================
// 	bomb_planted - Called when the Bomb was planted
// ===============================================================================

public bomb_planted(iPlanter)
	g_iBombPlanter = iPlanter
	
// ===============================================================================
//  	bomb_explode - Called when the Bomb exploded
// ===============================================================================

public bomb_explode(iPlanter, iDefuser)
{
	g_bBombExploded = true
	ShowMVPMessage(g_iBombPlanter)
}
	
// ===============================================================================
// 	bomb_defused - Called when the Bomb was defused
// ===============================================================================

public bomb_defused(iDefuser)
	g_iBombDefuser = iDefuser
	
// ===============================================================================
// 	GetTopKiller - Returns the id of the player who made the most kills
// ===============================================================================

public GetTopKiller(iTeam) // 1 : Terrorist - 2 : Counter-Terrorists
{
	new iPlayers[32], iPlayersnum;
	
	get_players(iPlayers, iPlayersnum, "e", iTeam == 1 ? "TERRORIST" : "CT")
	SortCustom1D(iPlayers, iPlayersnum, "SortByKills")
	
	return iPlayers[0]
}

public SortByKills(elem1, elem2) 
{
	if ( g_iEnemiesKilled[elem1] > g_iEnemiesKilled[elem2] )
		return -1
	else if ( g_iEnemiesKilled[elem1] < g_iEnemiesKilled[elem2] )
		return 1
	return 0
}

// ===============================================================================
// 	GetTopRescuer - Returns the id of the player who rescued the most hostages
// ===============================================================================

public GetTopRescuer() // 1 : Terrorist - 2 : Counter-Terrorists
{
	new iPlayers[32], iPlayersnum;
	
	get_players(iPlayers, iPlayersnum, "e", "CT")
	SortCustom1D(iPlayers, iPlayersnum, "SortByHostages")
	
	return iPlayers[0]
}

public SortByHostages(elem1, elem2) 
{
	if ( g_iHostagesRescued[elem1] > g_iHostagesRescued[elem2] )
		return -1
	else if ( g_iHostagesRescued[elem1] < g_iHostagesRescued[elem2] )
		return 1
	return 0
}

// ===============================================================================
// 	ShowMVPMessage - Shows the Director HUD Message
// ===============================================================================

ShowMVPMessage(iMVP) // 1 : Kills - 2 : Bomb defused - 3 : Bomb exploded - 4 : Hostage rescued
{
	if(!is_user_connected(iMVP))
		return

	new iPlayers[32], iPlayersnum
	get_players(iPlayers, iPlayersnum, "ch")
	if(iPlayersnum < 4)
		return

	new szMVPName[32]
	get_user_name(iMVP, szMVPName, charsmax(szMVPName))
	
	set_dhudmessage(random(256), random(256), random(256), -1.0, 0.07, 0, 6.0, 12.0)
	show_dhudmessage(0, "%s Win!^n%s has got the MVP because of Great Play!.", (g_iTeamWin == 1) ? "Terrorists" : "CTs", szMVPName)	
	
	ExecuteForward(g_iForward, g_iReturn, iMVP)
}
