#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN 			"CSGOM: Player Sounds"
#define VERSION 		"1.0"
#define AUTHOR 			"EFFEX"

#define m_LastHitGroup		75
#define isHeadShot(%1)		(get_pdata_int(%1, m_LastHitGroup) == HIT_HEAD)

new const g_szSimpleDeathSounds[][] =
{
	"csgom/player/sdeath1.wav",
	"csgom/player/sdeath2.wav",
	"csgom/player/sdeath3.wav",
	"csgom/player/sdeath4.wav"
}

new const g_szHeadShotsSounds[][] =
{
	"csgom/player/headshot1.wav",
	"csgom/player/headshot2.wav",
	"csgom/player/headshot3.wav"
}

new const g_szFallDamageSounds[][] =
{
	"csgom/player/bhit_flesh-1.wav",
	"csgom/player/bhit_flesh-2.wav",
	"csgom/player/bhit_flesh-3.wav"
}

new const g_szHelmetDeathSound[] = "csgom/player/helmet_deathsound.wav"
new const g_szSpraySound[] = "csgom/player/sprayer.wav"

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_forward(FM_EmitSound, "forward_EmitSound")
	
	RegisterHam(Ham_TakeDamage, "player", "ham_PlayerTakeDamage_Pre", 0)
	RegisterHam(Ham_Killed, "player", "ham_PlayerKilled_Pre", 0)
}

public plugin_precache()
{
	for(new i;i < sizeof g_szSimpleDeathSounds;i++)
	{
		precache_sound(g_szSimpleDeathSounds[i])
	}
	
	for(new i;i < sizeof g_szHeadShotsSounds;i++)
	{
		precache_sound(g_szHeadShotsSounds[i])
	}

	for(new i;i < sizeof g_szFallDamageSounds;i++)
	{
		precache_sound(g_szFallDamageSounds[i])
	}
	precache_sound(g_szSpraySound)
	precache_sound(g_szHelmetDeathSound)
}

public forward_EmitSound(iEnt, channel, const szSample[])
{
	if(equal(szSample, "player/headshot1.wav")
	|| equal(szSample, "player/headshot2.wav")
	|| equal(szSample, "player/headshot3.wav"))
	{ 
		return FMRES_SUPERCEDE 
	} 
	else if(equal(szSample, "player/die1.wav")
	|| equal(szSample, "player/die2.wav")
	|| equal(szSample, "player/die3.wav"))
	{
		return FMRES_SUPERCEDE
	}
	else if(equal(szSample, "player/bhit_flesh-1.wav")
	|| equal(szSample, "player/bhit_flesh-2.wav")
	|| equal(szSample, "player/bhit_flesh-3.wav"))
	{
		emit_sound(iEnt, channel, g_szFallDamageSounds[random_num(0, sizeof g_szFallDamageSounds - 1)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		return FMRES_SUPERCEDE
	}
	else if(equal(szSample, "player/bhit_helmet-1.wav")
	|| equal(szSample, "player/bhit_kevlar-1.wav"))
	{
		return FMRES_SUPERCEDE
	}
	else if(equal(szSample, "player/sprayer.wav"))
    	{
      		emit_sound(iEnt, channel, g_szSpraySound, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
      		return FMRES_SUPERCEDE
    	}
	return FMRES_IGNORED
}

public ham_PlayerTakeDamage_Pre(iVictim, iInflictor, iAttacker, Float:fDamage, iDamageBits)
{	
	if(!is_user_connected(iAttacker) || !is_user_connected(iVictim))
		return HAM_IGNORED

	if(isHeadShot(iVictim))
	{
		new CsArmorType:iArmorType
		cs_get_user_armor(iVictim, iArmorType)
	
		emit_sound
		(
			iVictim, 
			CHAN_WEAPON, 
			(iArmorType < CS_ARMOR_VESTHELM) ? g_szHeadShotsSounds[random_num(0, sizeof g_szHeadShotsSounds - 1)] : g_szHelmetDeathSound, 
			VOL_NORM, 
			ATTN_NORM, 0, 
			PITCH_NORM
		)
	}
	return HAM_IGNORED
}

public ham_PlayerKilled_Pre(iVictim, iKiller, iShouldGib)
{
	if(!is_user_connected(iKiller) || !is_user_connected(iVictim))
		return HAM_IGNORED
			
	if(!isHeadShot(iVictim))
	{
		emit_sound(iVictim, CHAN_WEAPON, g_szSimpleDeathSounds[random_num(0, sizeof g_szSimpleDeathSounds - 1)], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	}
	return HAM_IGNORED
}
