/*----------------------------------------------------------------------------------------------------------------
					[Advance Register System]
		
		* Description: Use the Natives and Forwards for Create Miscellaneous Plugins
		
		* Credits: 
			- Odair: Author of Plugin
			- William: For Remove Unecessary contents
			- [P]erfec[T] [S]cr[@]s[H]: For Add the Natives and Lang

----------------------------------------------------------------------------------------------------------------*/
#include <amxmodx>
#include <cstrike>	// Includes
#include <fvault>
#include <fakemeta>

#define PLUGIN "Advance Register System"
#define VERSION "1.0"
#define AUTHOR "Odair | [P]erfec[T] [S]cr[@]s[H] | William"

// Variaveis
new register_login[33][20], register_pw[33][20], user_login[33][10], user_password[33][10], g_attemps[33]
new change_pw_old[33], change_pw_new[33], g_is_logged[33], user_steam[33], g_is_logged_steam[33]

#define REGISTER_HANDLED 100	// Forward Return

enum
{
	LOGGED_PRE = 0,
	LOGGED_POST,
	LOGOUT_POST,
	MAX_FORWARDS
}

new g_forward[MAX_FORWARDS], g_fwDummyResult	// Forwards
new cvar_maxchar, cvar_minchar, cvar_attemps, cvar_bantime	// Cvars
new const accounts_data[] = "registred_accounts" // File Data

/*---------------------------------------------[Plugin Register]----------------------------------------------*/
public plugin_init() {
	
	register_plugin(PLUGIN, VERSION, AUTHOR)		// Plugin Register
	register_dictionary("advance_register_system.txt")	// Lang Register
	
	register_message(get_user_msgid("ShowMenu"), "message_show_menu")
	register_message(get_user_msgid("VGUIMenu"), "message_vgui_menu")
	register_clcmd("chooseteam", "jointeam_protection");			// Protection for play without login
	register_clcmd("jointeam", "jointeam_protection");
	register_menucmd(register_menuid("Terrorist_Select",1),511,"cmd_joinclass");
	register_menucmd(register_menuid("CT_Select",1),511,"cmd_joinclass");
	
	register_clcmd("[Register]User_name", "register_user_name")	// Register Cmds
	register_clcmd("[Register]User_pass", "register_user_password")
	
	register_clcmd("[Login]User_name", "login_user_name")	// Login Cmds
	register_clcmd("[Login]User_pass", "login_user_password")
	
	register_clcmd("[Change_PW]Current_pw", "cmd_old_pw")	// Change Password Cmds
	register_clcmd("[Change_PW]New_pw", "cmd_new_pw")
	
	register_clcmd("say", "commands")	// Register Commands
	register_clcmd("say_team", "commands")
	
	cvar_maxchar = register_cvar("register_max_char", "15")	// Max of Chars for Create Account
	cvar_minchar = register_cvar("register_min_char", "3") // Min of Chars for Create Account
	cvar_attemps = register_cvar("register_login_attemps", "4") // Max Attemps Number
	cvar_bantime = register_cvar("register_bantime", "5")	// Ban Time for wrong password X Times.
	
	g_forward[LOGGED_PRE] = CreateMultiForward("user_logged_pre", ET_CONTINUE, FP_CELL)
	g_forward[LOGGED_POST] = CreateMultiForward("user_logged_post", ET_IGNORE, FP_CELL)
	g_forward[LOGOUT_POST] = CreateMultiForward("user_logout_post", ET_IGNORE, FP_CELL)
}

/*---------------------------------------------[Native Register]----------------------------------------------*/
public plugin_natives()
{
	register_native("get_user_account_name", "native_get_user_account_name")
	register_native("is_user_registered", "native_is_user_logged", 1);
	register_native("is_user_logged_steam", "native_is_user_logged_steam", 1);
}

/*---------------------------------------------[Some Protections for play without login]----------------------------------------------*/
public jointeam_protection(id) {
	
	static Team; Team = get_user_team(id)
	if((Team == 0 || Team == 3) && !g_is_logged[id]) {
		register_menu(id)
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

public cmd_joinclass(id) return PLUGIN_HANDLED;

public message_show_menu(msgid, dest, id) 
{	
	if(!g_is_logged[id]) return PLUGIN_HANDLED
	
	static team_select[] = "#Team_Select"
	
	static menu_text_code[sizeof team_select]
	get_msg_arg_string(4, menu_text_code, sizeof menu_text_code - 1)
	
	if (!equal(menu_text_code, team_select)) return PLUGIN_CONTINUE
	
	static param_menu_msgid[2]
	param_menu_msgid[0] = msgid
	
	set_force_team_join_task(id, msgid)
	
	return PLUGIN_HANDLED
}

public message_vgui_menu(msgid, dest, id) 
{	
	if (get_msg_arg_int(1) != 2) return PLUGIN_CONTINUE
	
	if(!g_is_logged[id]) return PLUGIN_HANDLED
	
	static param_menu_msgid[2]
	param_menu_msgid[0] = msgid
	
	set_force_team_join_task(id, msgid)
	
	return PLUGIN_HANDLED
}

set_force_team_join_task(id, menu_msgid) 
{
	static param_menu_msgid[2]
	param_menu_msgid[0] = menu_msgid
	set_task(0.1, "task_force_team_join", id, param_menu_msgid, sizeof param_menu_msgid)
}

public task_force_team_join(menu_msgid[], id) 
{	
	static msg_block; msg_block = get_msg_block(menu_msgid[0])
	
	set_msg_block(menu_msgid[0], BLOCK_SET)
	set_msg_block(menu_msgid[0], msg_block)
}

/*---------------------------------------------[Client Vars Section]----------------------------------------------*/
public client_putinserver(id) {
	
	if(!is_user_bot(id) && !is_user_hltv(id)) {
		set_task(0.5, "register_menu", id)
	}
	return PLUGIN_CONTINUE
}
public client_connect(id) {
	
	g_is_logged[id] = false
	g_is_logged_steam[id] = false
	register_login[id] = ""
	register_pw[id] = ""
	user_login[id] = ""
	user_password[id] = ""
}
public client_disconnect(id) {
	
	g_is_logged[id] = false
	g_is_logged_steam[id] = false
	register_login[id] = ""
	register_pw[id] = ""
	user_login[id] = ""
	user_password[id] = ""
}

/*---------------------------------------------[Register Main Menu]----------------------------------------------*/
public register_menu(id) {

	new SteamID[32]; get_user_authid(id, SteamID, 31)
	get_user_authid(id, SteamID, 31);
	if (equal("4294967295", SteamID) || equal("HLTV", SteamID) || equal("STEAM_ID_LAN", SteamID) || equal("VALVE_ID_LAN", SteamID)) user_steam[id] = false; 
	else user_steam[id] = true; 

	new szMenu[128]
	formatex(szMenu,127,"%L %L", LANG_PLAYER, "REGISTER_MENU_TAG", LANG_PLAYER, "REGISTER_MENU_TITLE")
	
	new Menu = menu_create(szMenu,"register_menu_handler")
	
	formatex(szMenu,63, "%s%L", g_is_logged[id] ? "\d" : "\w", LANG_PLAYER, "REGISTER_MENU_ITEM1")
	menu_additem(Menu,szMenu,"1",0)
	
	formatex(szMenu,63, "%s%L^n", g_is_logged[id] ? "\d" : "\w", LANG_PLAYER, "REGISTER_MENU_ITEM2")
	menu_additem(Menu,szMenu,"2",0)
	
	formatex(szMenu,63, "%s%L", g_is_logged[id] ? "\w" : "\d", LANG_PLAYER, "REGISTER_MENU_ITEM3")
	menu_additem(Menu,szMenu,"3",0)
	
	formatex(szMenu,63, "%s%L^n", g_is_logged[id] ? "\w" : "\d", LANG_PLAYER, "REGISTER_MENU_ITEM4")
	menu_additem(Menu,szMenu,"4",0)
	
	if(!user_steam[id]) formatex(szMenu,63, "\d%L", LANG_PLAYER, "REGISTER_MENU_ITEM5")
	else formatex(szMenu,63, "%s%L", g_is_logged[id] ? "\d" : "\w", LANG_PLAYER, "REGISTER_MENU_ITEM5")
	menu_additem(Menu,szMenu,"5",0)
	
	formatex(szMenu,63, "%L", LANG_PLAYER, "REGISTER_MENU_EXIT")
	menu_setprop(Menu,MPROP_EXITNAME, szMenu)
	menu_display(id, Menu, 0)

	return PLUGIN_HANDLED;
}
public register_menu_handler(id, menu, item) 
{
	if((item == MENU_EXIT) || !g_is_logged[id]) 
	{
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}
	new data[6], iName[64], access, callback
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
	new key = str_to_num(data)
	
	switch(key) 
	{
		case 1: {
			if(!g_is_logged[id]) {
				client_cmd(id, "messagemode [Register]User_name")
				set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
				show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_INFO_MSG")
				ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_INFO_MSG")
			}
			else register_menu(id), ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "IS_ALTERADY_LOGGED")
		}
		case 2: {
			if(!g_is_logged[id]) {
				
				client_cmd(id, "messagemode [Login]User_name")
				set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
				show_hudmessage(id, "%L", LANG_PLAYER, "LOGIN_INFO_MSG")
				ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "LOGIN_INFO_MSG")
			}
			else register_menu(id), ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "IS_ALTERADY_LOGGED")
		}
		
		case 3: {
			if(!g_is_logged[id]) {
				
				register_menu(id)
				set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
				show_hudmessage(id, "%L", LANG_PLAYER, "IS_NOT_LOGGED")
				ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "IS_NOT_LOGGED")
			}
			if(g_is_logged_steam[id])
			{
				set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
				show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PASSWORD_ERR1")
				ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "CHANGE_PASSWORD_ERR1")
			}
			else change_password(id)
		}
		case 4: {
			if(!g_is_logged[id]) {
				register_menu(id)
				set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
				show_hudmessage(id, "%L", LANG_PLAYER, "IS_NOT_LOGGED")
				ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "IS_NOT_LOGGED")
			}
			else user_logoff(id), ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "LOGOFF_SUCCESS")
		}
		case 5:
		{	
			if(!g_is_logged[id]) steam_login(id);
			else register_menu(id);
		}
		
		default: if(!g_is_logged[id]) register_menu(id)
	}
	return PLUGIN_HANDLED
}

/*---------------------------------------------[Register Section]----------------------------------------------*/
public register_user_name(id) {
	
	if(g_is_logged[id]) return PLUGIN_HANDLED
	
	read_args(register_login[id], 99); remove_quotes(register_login[id]); trim(register_login[id])
	new symbol[30]; read_args(symbol, charsmax(symbol)); remove_quotes(symbol); trim(symbol);
	
	if (!valid_symbol(symbol, strlen(symbol)))
	{
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_ERROR1")
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_ERROR1")
		
		return PLUGIN_HANDLED
	}
	if (strlen(register_login[id]) < get_pcvar_num(cvar_minchar))
	{
		register_menu(id)
		
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_ERROR2", get_pcvar_num(cvar_minchar))
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_ERROR2", get_pcvar_num(cvar_minchar))
		
		return PLUGIN_HANDLED
	}
	if (strlen(register_login[id]) > get_pcvar_num(cvar_maxchar))
	{
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_ERROR3", get_pcvar_num(cvar_maxchar))
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_ERROR3", get_pcvar_num(cvar_maxchar))
		
		return PLUGIN_HANDLED
	}
	
	static data[128]
	if(fvault_get_data(accounts_data, register_login[id], data, charsmax(data))) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_ERROR4")
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_ERROR4")
	}
	else {
		
		client_cmd(id, "messagemode [Register]User_pass")
		set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_PW_INFO_MSG_HUD")
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_PW_INFO_MSG")
	}
	return PLUGIN_CONTINUE
}
public register_user_password(id) {
	
	if(g_is_logged[id]) return PLUGIN_HANDLED
	
	read_args(register_pw[id], 99); remove_quotes(register_pw[id]); trim(register_pw[id])
	new symbol[30]; read_args(symbol, charsmax(symbol)); remove_quotes(symbol); trim(symbol)
	
	if(!valid_symbol(symbol, strlen(symbol))) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_PW_ERROR1")
		return PLUGIN_HANDLED
	}
	if (strlen(register_pw[id]) <= get_pcvar_num(cvar_minchar)) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_PW_ERROR2", get_pcvar_num(cvar_minchar))
		return PLUGIN_HANDLED
	}
	if (strlen(register_pw[id]) >= get_pcvar_num(cvar_maxchar)) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_PW_ERROR3", get_pcvar_num(cvar_maxchar))
		return PLUGIN_HANDLED
	}
	if (equal(register_pw[id], register_login[id])) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_PW_ERROR4")
		return PLUGIN_HANDLED
	}
	if (contain(register_pw[id], register_login[id]) != -1) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_PW_ERROR5")
		return PLUGIN_HANDLED
	}
	
	menu_confirm(id)
	set_hudmessage(1, 255, 1, 0.04, 0.15, 2, 3.0, 10.0, 0.04, 1.5)
	show_hudmessage(id, "%L", LANG_PLAYER, "REGISTER_CONFIRM")
	ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "REGISTER_CONFIRM")
	
	return PLUGIN_HANDLED
}


public menu_confirm(id)
{
	static item[255]
	
	formatex(item, charsmax(item), "%L %L", LANG_PLAYER, "REGISTER_MENU_TAG", LANG_PLAYER, "MENU_REGISTER_CONFIRM_TITLE", register_login[id], register_pw[id])
	new menu = menu_create(item, "menu_confirm_handler")
	
	formatex(item, charsmax(item), "%L", LANG_PLAYER, "MENU_REGISTER_CONFIRM_ITEM1")
	menu_additem(menu, item, "1")
	formatex(item, charsmax(item), "%L", LANG_PLAYER, "MENU_REGISTER_CONFIRM_ITEM2")
	menu_additem(menu, item, "2")
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER)
	menu_display(id, menu, 0)
	
	return PLUGIN_HANDLED;
}

public menu_confirm_handler(id, menu, item)
{
	new data[6], iName[64], access, callback;
	menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback);
	
	switch (str_to_num(data))
	{
		case 1: 
		{
			register_menu(id)
			fvault_pset_data(accounts_data, register_login[id], register_pw[id])
			set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
			show_hudmessage(id, "%L", LANG_PLAYER, "ACCOUNT_CREATE_SUCCEFULL_MSG1")
			ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "ACCOUNT_CREATE_SUCCEFULL_MSG1")
			ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "ACCOUNT_POS_CREATE_INFO", register_login[id], register_pw[id])
		}
		case 2: 
		{
			register_menu(id)
			set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
			show_hudmessage(id, "%L", LANG_PLAYER, "ACCOUNT_NOT_CONFIRMED_MSG")
			ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "ACCOUNT_NOT_CONFIRMED_MSG")
		}
	}
	return PLUGIN_HANDLED;
}

/*---------------------------------------------[User Login Section]----------------------------------------------*/
public login_user_name(id) {
	
	if(g_is_logged[id]) return PLUGIN_HANDLED
	
	read_args(user_login[id], 99); remove_quotes(user_login[id]); trim(user_login[id])
	new players[32], pnum, tempid; get_players(players, pnum)
	
	for( new i; i<pnum; i++ )  {
		tempid = players[i]
		if(id != tempid) if(equal(user_login[id], user_login[tempid])) {
			register_menu(id)
			set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
			show_hudmessage(id, "%L", LANG_PLAYER, "LOGIN_ERROR1")
			return PLUGIN_HANDLED
		}
	}
	
	new data[192]
	if(!fvault_get_data(accounts_data, user_login[id], data, charsmax(data))) {
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "LOGIN_ERROR2")
		return PLUGIN_HANDLED
	}
	else {
		ExecuteForward(g_forward[LOGGED_PRE], g_fwDummyResult, id)
		
		if (g_fwDummyResult >= REGISTER_HANDLED) 
		{
			g_is_logged[id] = false
			g_is_logged_steam[id] = false
			register_login[id] = ""
			register_pw[id] = ""
			user_login[id] = ""
			user_password[id] = ""
			register_menu(id)
			return PLUGIN_HANDLED;
		}
		
		
		client_cmd(id, "messagemode [Login]User_pass")
		set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "LOGIN_PW")
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "LOGIN_PW")
	}
	return PLUGIN_HANDLED
}

public login_user_password(id) {
	
	if(g_is_logged[id]) return PLUGIN_HANDLED
	
	read_args(user_password[id], 20)
	remove_quotes(user_password[id])
	trim(user_password[id])
	
	new players[32], pnum, tempid
	get_players(players, pnum)
	for(new i; i < pnum; i++) {
		tempid = players[i]
		if(id != tempid) {
			
			if(equal(user_login[id], user_login[tempid])) {
				
				register_menu(id)
				set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
				show_hudmessage(id, "%L", LANG_PLAYER, "LOGIN_ERROR1")
				return PLUGIN_HANDLED
			}
		}
	}
	
	read_args(user_password[id], 99)
	remove_quotes(user_password[id])
	trim(user_password[id])
	
	new data[140]
	fvault_get_data(accounts_data, user_login[id], data, charsmax(data))
	
	if(equali(data, user_password[id])) {

		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "LOGIN_SUCCESS_MSG", user_login[id])
		
		engclient_cmd(id,"jointeam","5") 
		engclient_cmd(id,"joinclass","5")
		
		g_is_logged[id] = true
		
		ExecuteForward(g_forward[LOGGED_POST], g_fwDummyResult, id)
	}
	else
	{
		register_menu(id)
		
		g_attemps[id]++
		if(g_attemps[id] >= get_pcvar_num(cvar_attemps)) server_cmd("amx_banip #%i %i ^"%L^"", get_user_userid(id), get_pcvar_num(cvar_bantime), LANG_PLAYER, "USER_BANNED", get_pcvar_num(cvar_bantime))
		
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "LOGIN_PW_ERROR_HUD", g_attemps[id], get_pcvar_num(cvar_attemps))
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "LOGIN_PW_ERROR_CHAT", g_attemps[id], get_pcvar_num(cvar_attemps))
	}
	return PLUGIN_HANDLED
}

public steam_login(id)
{
	if(user_steam[id]) 
	{
		g_is_logged_steam[id] = true
		
		ExecuteForward(g_forward[LOGGED_PRE], g_fwDummyResult, id)
		
		if (g_fwDummyResult >= REGISTER_HANDLED) 
		{
			g_is_logged[id] = false
			g_is_logged_steam[id] = false
			register_login[id] = ""
			register_pw[id] = ""
			user_login[id] = ""
			user_password[id] = ""
			register_menu(id)
			return PLUGIN_HANDLED;
		}
		
		new steamid[32]; get_user_authid(id, steamid, 31)
		
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "LOGIN_STEAM_MSG", steamid)
		
		engclient_cmd(id,"jointeam","5") 
		engclient_cmd(id,"joinclass","5")
		
		g_is_logged[id] = true
		
		ExecuteForward(g_forward[LOGGED_POST], g_fwDummyResult, id)
	}
	else 
	{
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "IS_NOT_STEAM_MSG")
		ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "IS_NOT_STEAM_MSG")
		register_menu(id)
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

/*-------------------------------------[Change Password]-----------------------------------------*/
public change_password(id) {
	
	if(!g_is_logged[id] || g_is_logged_steam[id]) return PLUGIN_HANDLED
	
	client_cmd(id, "messagemode [Change_PW]Current_pw")
	set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
	show_hudmessage(id, "Digite a senha atual da sua conta.")
	return PLUGIN_CONTINUE
}
public cmd_old_pw(id) {
	
	if(!g_is_logged[id] || g_is_logged_steam[id]) return PLUGIN_HANDLED
	
	read_args(change_pw_old[id], charsmax(change_pw_old))
	remove_quotes(change_pw_old[id])
	trim(change_pw_old[id])
	
	new data[521]; fvault_get_data(accounts_data, user_login[id], data[id], charsmax(data))
	parse(data[id], user_password[id], 190)		
	
	if(equal(change_pw_old[id], user_password[id])) {
		
		client_cmd(id, "messagemode [Change_PW]New_pw")
		set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_MSG2")
	}
	else {
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_ERROR1")
		register_menu(id)
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}
public cmd_new_pw(id) {
	
	if(!g_is_logged[id] || g_is_logged_steam[id]) return PLUGIN_HANDLED
	
	read_args(change_pw_new[id], charsmax(change_pw_new))
	remove_quotes(change_pw_new[id]); trim(change_pw_new[id])
	
	new symbol[30]; read_args(symbol, charsmax(symbol)); remove_quotes(symbol); trim(symbol)
	
	if(!valid_symbol(change_pw_new[id], strlen(change_pw_new[id]))) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_ERROR2")
		return PLUGIN_HANDLED
	}
	if(strlen(change_pw_new[id]) <= get_pcvar_num(cvar_minchar)) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_ERROR3", get_pcvar_num(cvar_minchar))
		return PLUGIN_HANDLED
	}
	if(strlen(change_pw_new[id]) >= get_pcvar_num(cvar_maxchar)) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_ERROR4", get_pcvar_num(cvar_maxchar))
		return PLUGIN_HANDLED
	}
	if(equal(change_pw_new[id], register_login[id])) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_ERROR5")
		return PLUGIN_HANDLED
	}
	if(contain(change_pw_new[id], register_login[id]) != -1) {
		
		register_menu(id)
		set_hudmessage(255, 0, 0, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
		show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_ERROR6")
		return PLUGIN_HANDLED
	}
	
	set_hudmessage(0, 0, 255, 0.04, 0.15, 2, 3.0, 3.0, 0.04, 1.5)
	show_hudmessage(id, "%L", LANG_PLAYER, "CHANGE_PW_SUCCESS_HUD")
	ChatColor(id, "%L %L", LANG_PLAYER, "REGISTER_CHAT_TAG", LANG_PLAYER, "CHANGE_PW_SUCCESS_CHAT", change_pw_new[id])
	fvault_pset_data(accounts_data, user_login[id], change_pw_new[id])
	
	return PLUGIN_CONTINUE
}

/*---------------------------------------------[User Logoff]----------------------------------------------*/
public user_logoff(id) {
	
	if(!g_is_logged[id]) return PLUGIN_HANDLED
	
	ExecuteForward(g_forward[LOGOUT_POST], g_fwDummyResult, id)
	
	g_is_logged[id] = false
	g_is_logged_steam[id] = false
	register_login[id] = ""
	register_pw[id] = ""
	user_login[id] = ""
	user_password[id] = ""
	user_silentkill(id)
	cs_set_user_team(id, CS_TEAM_UNASSIGNED)
	register_menu(id)

	return PLUGIN_HANDLED
}

/*---------------------------------------------[Commands]----------------------------------------------*/
public commands(id) {
	
	new text[70], arg1[32], arg2[32], arg3[6]
	read_args(text, sizeof(text) - 1); remove_quotes(text)
	arg1[0] = '^0'
	arg2[0] = '^0'
	arg3[0] = '^0'
	parse(text, arg1, sizeof(arg1) - 1, arg2, sizeof(arg2) - 1, arg3, sizeof(arg3) - 1)
	
	if (equali(arg1, "/", 1) || equali(arg1, ".", 1) || equali(arg1, "!", 1)) format(arg1, 31, arg1[1])
	
	if (arg3[0]) return;
	
	if (equali(arg1, "register") || equali(arg1, "reg") || equali(arg1, "login") || equali(arg1, "account")) {
		
		register_menu(id)
		return;
	} 
}

/*---------------------------------------------[Natives]----------------------------------------------*/

public native_get_user_account_name(plugin_id, param_nums)
{
	if (param_nums != 3)
		return -1;
	
	static id; id = get_param(1)
	
	static current_account[50]
	static steamid[32]; get_user_authid(id, steamid, 31)
	
	formatex(current_account, charsmax(current_account), "%s", g_is_logged_steam[id] ? steamid : user_login[id])
	
	set_string(2, current_account, get_param(3))
	
	return 1;
}

public fw_PreThink(iPlayer)
{
	if(g_is_logged[iPlayer] || g_is_logged_steam[iPlayer])
	{
		return FMRES_IGNORED;
	}
	
	static iMsgScreenFade;
	if (!iMsgScreenFade)
	{
		iMsgScreenFade = get_user_msgid("ScreenFade");
	}
	
	message_begin(MSG_ONE, iMsgScreenFade, _, iPlayer);
	write_short((1<<12));
	write_short(0);
	write_short(0x0004);
	write_byte(1);
	write_byte(1);
	write_byte(1);
	write_byte(255);
	message_end();
	
	return FMRES_IGNORED;
}

public native_is_user_logged(id) return g_is_logged[id];
public native_is_user_logged_steam(id) return g_is_logged_steam[id];

bool:valid_symbol(const symbol[], len) {
	
	new const valid_chars[][] = {
		"0" ,"1" ,"2" ,"3" ,"4" ,"5" ,"6" ,"7" ,"8" ,"9",
		"a", "b", "c", "d", "e", "f", "g", "h", "i", "j",
		"k", "l", "m", "n", "o", "p", "q", "r", "s", "t",
		"u", "v", "w", "x", "y", "z"
	}
	static i, a, valids; valids = 0
	
	for(i = 0; i < len; i++)	{
		for(a = 0; a < sizeof(valid_chars); a++)	{
			if(symbol[i] == valid_chars[a][0]) {
				valids++
				break
			}
		}
	}
	if(valids != len) return false;
	return true
}

stock ChatColor(const id, const input[], any:...) {
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
	
	replace_all(msg, 190, "!g", "^x04")
	replace_all(msg, 190, "!y", "^x01")
	replace_all(msg, 190, "!t", "^x03")
	
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++) {
			if (is_user_connected(players[i])) {
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
				write_byte(players[i])
				write_string(msg)
				message_end()
			}
		}
	}
}
