#include <amxmodx>
#include <csgom>

#define PLUGIN "CSGOM: Trade System"
#define VERSION "1.0"
#define AUTHOR "EFFEX"

#define TRADE_ACCEPT_DELAY		10
#define TASK_AUTO_REFUSE		203133

native openAkMenu(id, iMethod)
native openAwpMenu(id, iMethod)
native openKnifeMenu(id, iMethod)
native openUspMenu(id, iMethod)
native openM4A1Menu(id, iMethod)
native openM4A4Menu(id, iMethod)
native openDeagleMenu(id, iMethod)
native openGlockMenu(id, iMethod)

new g_iTradeItemRegistered[MAX_PLAYERS + 1], g_iTradeItemWID[MAX_PLAYERS + 1]
new bool:g_bTradeItemStattrack[MAX_PLAYERS + 1], bool:g_bAlreadyInTrade[MAX_PLAYERS + 1], bool:g_bConfirmed[MAX_PLAYERS + 1]
new g_szTradeItemName[MAX_PLAYERS + 1][MAX_PLAYERS]

new g_iTradeItemTarget[MAX_PLAYERS + 1]
new g_iTradeTargetSender[MAX_PLAYERS + 1]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
}

public plugin_natives()
{
	register_native("openTradeMenu", "cmdTradeMenu", 1)
	register_native("registerTradeItem", "_Register")
}

public _Register()
{
	new iPlayer = get_param(1)
	g_iTradeItemRegistered[iPlayer] = get_param(2)
	g_iTradeItemWID[iPlayer] = get_param(5)
	g_bTradeItemStattrack[iPlayer] = bool:get_param(3)
	
	new szSkinName[MAX_PLAYERS]
	get_string(4, szSkinName, charsmax(szSkinName))
	g_szTradeItemName[iPlayer] = szSkinName
}

public client_disconnected(id)
{
	if(g_bAlreadyInTrade[id])
	{
		resetTradeHistory(id)
		
		if(is_user_connected(g_iTradeItemTarget[id]))
		{
			resetTradeHistory(g_iTradeItemTarget[id])
		}
		
		if(is_user_connected(g_iTradeTargetSender[id]))
		{
			resetTradeHistory(g_iTradeTargetSender[id])
		}
	}
}

public client_putinserver(id)
{
	resetTradeHistory(id)
}

public cmdTradeMenu(id)
{
	new iMenu = menu_create("CSGOM: Trade Menu", "trade_handler")
	new szItemFormat[128]
	
	if(g_iTradeItemRegistered[id] == -1)
	{
		menu_additem(iMenu, "Trading:\d Select Skin")
	}
	else
	{
		formatex(szItemFormat, charsmax(szItemFormat), "Trading:\r %s%s", g_bTradeItemStattrack[id] ? "Stattrack (TM) " : "", g_szTradeItemName[id])
		menu_additem(iMenu, szItemFormat)
	}
	
	if(!is_user_connected(g_iTradeItemTarget[id]) && !is_user_connected(g_iTradeTargetSender[id]))
	{
		menu_additem(iMenu, "Target:\d Select Player^n")
	}
	else
	{
		new szTargetName[MAX_PLAYERS]
		get_user_name(g_iTradeItemTarget[id], szTargetName, charsmax(szTargetName))
		formatex(szItemFormat, charsmax(szItemFormat), "Target:\r %s^n", szTargetName)
		menu_additem(iMenu, szItemFormat)
	}
	menu_additem(iMenu, g_bAlreadyInTrade[id] ? "\yConfirm Trade Offer" : "\ySend Trade Offer")
	
	menu_display(id, iMenu)
}
	
public trade_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	
	switch(iItem)
	{
		case 0:
		{
			menu_display(id, iMenu)
			return PLUGIN_HANDLED
		}
		case 1:
		{
			if(g_bAlreadyInTrade[id])
			{
				menu_display(id, iMenu)
				return PLUGIN_HANDLED
			}
			openTargetMenu(id)
		}
		case 2:
		{
			if(!is_user_connected(g_iTradeItemTarget[id]))
			{
				ChatColor(id, "You did not select any target to trade!")
				menu_display(id, iMenu)
				return PLUGIN_HANDLED
			}
			else if(g_bAlreadyInTrade[id])
			{
				bothConfirmations(id)
				return PLUGIN_HANDLED
			}
			sendTradeOffer(id, g_iTradeItemTarget[id])
			
			new szTargetName[MAX_PLAYERS]
			get_user_name(g_iTradeItemTarget[id], szTargetName, charsmax(szTargetName))
			ChatColor(id, "Trade successfuly sent. Player^x04 %s^x01 has^x04 %d^x01 seconds to accept!", szTargetName, TRADE_ACCEPT_DELAY)
		}
	}
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}

bothConfirmations(id)
{
	new iMenu = menu_create("CSGOM: Do you confirm the trade?", "confirm_trade_handler")
	menu_additem(iMenu, "\rNo")
	menu_additem(iMenu, "\yYes")
	
	menu_setprop(iMenu, MPROP_EXIT, MEXIT_NEVER)
	menu_display(id, iMenu)
}
	
native getSkinGiveForwardID()
new g_iReturn

public confirm_trade_handler(id, iMenu, iItem)
{
	if(iItem)
	{
		new iTarget = g_iTradeItemTarget[id]
		new szSenderName[MAX_PLAYERS]
		get_user_name(iTarget, szSenderName, charsmax(szSenderName))
		
		if(g_bConfirmed[iTarget])
		{
			ChatColor
			(
				id, 
				"You successfuly traded your^x04 %s%s^x01 to %s's^x04 %s%s.",
				g_bTradeItemStattrack[id] ? "Stattrack (TM) " : "", g_szTradeItemName[id],
				szSenderName, g_bTradeItemStattrack[iTarget] ? "Stattrack (TM) " : "", g_szTradeItemName[iTarget]
			)
			
			new szTargetName[MAX_PLAYERS]
			get_user_name(id, szTargetName, charsmax(szTargetName))
			ChatColor
			(
				iTarget, 
				"You successfuly traded your^x04 %s%s^x01 to %s's^x04 %s%s.",
				g_bTradeItemStattrack[iTarget] ? "Stattrack (TM) " : "", g_szTradeItemName[iTarget],
				szTargetName, g_bTradeItemStattrack[id] ? "Stattrack (TM) " : "", g_szTradeItemName[id]
			)
						
			new iWID, iForward = getSkinGiveForwardID()
			new bool:bM4A4 = getWeaponID(id, iWID)
			ExecuteForward(iForward, g_iReturn, iTarget, iWID, g_iTradeItemRegistered[id], g_bTradeItemStattrack[id], bM4A4, true) 
			ExecuteForward(iForward, g_iReturn, iTarget, iWID, g_iTradeItemRegistered[iTarget], g_bTradeItemStattrack[iTarget], bM4A4, false) 
			
			bM4A4 = getWeaponID(iTarget, iWID)
			ExecuteForward(iForward, g_iReturn, id, iWID, g_iTradeItemRegistered[iTarget], g_bTradeItemStattrack[iTarget], bM4A4, true) 
			ExecuteForward(iForward, g_iReturn, id, iWID, g_iTradeItemRegistered[id], g_bTradeItemStattrack[id], bM4A4, false) 
			
			new iData[2]
			iData[0] = id
			iData[1] = iTarget
			set_task(0.1, "resetBothTradeHistory",_, iData, sizeof iData)
			return
		}
		else iTarget = g_iTradeTargetSender[iTarget]
		
		g_bConfirmed[id] = true
		
		bothConfirmations(iTarget)
		ChatColor(id, "Trade confirmed, waiting the other player's confirmation...")
		ChatColor(iTarget, "Do you confirm^x04 %s^x01's trade with his^x04 %s%s?", szSenderName, g_bTradeItemStattrack[id] ? "Stattrack (TM) " : "", g_szTradeItemName[id])
		ChatColor(iTarget, "You have^x04 %d^x01 seconds to accept.", TRADE_ACCEPT_DELAY)
		
		set_task(float(TRADE_ACCEPT_DELAY), "autoRefuseTrade", iTarget + TASK_AUTO_REFUSE)
	}
	else autoRefuseTrade(id + TASK_AUTO_REFUSE)
}

public resetBothTradeHistory(iData[2])
{
	resetTradeHistory(iData[0])
	resetTradeHistory(iData[1])
}

bool:getWeaponID(id, &iWID)
{
	new bool:bM4A4 = false
	if(containi(g_szTradeItemName[id], "AK-47") != -1) iWID = CSW_AK47
	else if(containi(g_szTradeItemName[id], "AWP") != -1) iWID = CSW_AWP
	else if(containi(g_szTradeItemName[id], "DEAGLE") != -1) iWID = CSW_DEAGLE
	else if(containi(g_szTradeItemName[id], "GLOCK") != -1) iWID = CSW_GLOCK18
	else if(containi(g_szTradeItemName[id], "KNIFE") != -1) iWID = CSW_KNIFE
	else if(containi(g_szTradeItemName[id], "M4A1-S") != -1) iWID = CSW_M4A1
	else if(containi(g_szTradeItemName[id], "M4A4") != -1) iWID = CSW_M4A1, bM4A4 = true
	else if(containi(g_szTradeItemName[id], "USP-S") != -1) iWID = CSW_USP	
	return bM4A4
}
sendTradeOffer(id, iTarget)
{
	g_iTradeTargetSender[iTarget] = id
	
	g_bAlreadyInTrade[id] = true
	g_bAlreadyInTrade[iTarget] = true
	
	new szSenderName[MAX_PLAYERS]
	get_user_name(id, szSenderName, charsmax(szSenderName))
	ChatColor(iTarget, "Player^x04 %s^x01 wants to trade his^x04 %s%s^x01, do you accept?", szSenderName, g_bTradeItemStattrack[id] ? "Stattrack (TM) " : "", g_szTradeItemName[id])
	ChatColor(iTarget, "You have^x04 %d^x01 seconds to accept otherwise it'll automatically be refused!", TRADE_ACCEPT_DELAY)
	
	set_task(float(TRADE_ACCEPT_DELAY), "autoRefuseTrade", iTarget + TASK_AUTO_REFUSE)
	
	new iMenu = menu_create("CSGOM: Do you accept the trade?", "accept_trade_handler")
	menu_additem(iMenu, "\rNo")
	menu_additem(iMenu, "\yYes")
	
	menu_setprop(iMenu, MPROP_EXIT, MEXIT_NEVER)
	menu_display(id, iMenu)
}
	
native openSkinsMenu(id, iMethod)

public accept_trade_handler(id, iMenu, iItem)
{
	if(iItem)
	{
		remove_task(id + TASK_AUTO_REFUSE)
		openSkinsMenu(id, TRADE)
	}
	else autoRefuseTrade(id + TASK_AUTO_REFUSE)
}

public autoRefuseTrade(id)
{
	id -= TASK_AUTO_REFUSE
	
	
	new iSender = g_iTradeTargetSender[id]
	resetTradeHistory(id)
	resetTradeHistory(iSender)
	
	show_menu(id, 0, "^n")
	show_menu(iSender, 0, "^n")
	
	new szTargetName[MAX_PLAYERS], szSenderName[MAX_PLAYERS]
	get_user_name(id, szTargetName, charsmax(szTargetName))
	get_user_name(iSender, szTargetName, charsmax(szTargetName))
	ChatColor(iSender, "Player^x04 %s^x01 did not accept your trade, trade refused!", szTargetName)
	ChatColor(id, "You did not accept the trade from^x04 %s.^x01 The trade has been cancelled!", szSenderName)
}

openTargetMenu(id)
{
	new iMenu = menu_create("CSGOM: Target Menu", "target_handler")
	
	new iPlayers[MAX_PLAYERS], iNum
	get_players(iPlayers, iNum, "ch")
	for(new i, iTarget, szTarget[3], szTargetName[MAX_PLAYERS];i < iNum;i++)
	{
		iTarget = iPlayers[i]
		if(iTarget != id)
			continue
			
		if(g_bAlreadyInTrade[iTarget])
			continue
			
		num_to_str(iTarget, szTarget, charsmax(szTarget))
		get_user_name(iTarget, szTargetName, charsmax(szTargetName))
		menu_additem(iMenu, szTargetName, szTarget)
	}
	menu_display(id, iMenu)
}

public target_handler(id, iMenu, iItem)
{
	if(iItem == MENU_EXIT)
	{
		menu_destroy(iMenu)
		return PLUGIN_HANDLED
	}
	new itemdata[5], dummy, iTarget
	menu_item_getinfo(iMenu, iItem, dummy, itemdata, charsmax(itemdata), {0}, 0, dummy)
	
	iTarget = str_to_num(itemdata)
	if(!is_user_connected(iTarget))
	{
		ChatColor(id, "This player is not connected")
		menu_display(id, iMenu)
		return PLUGIN_HANDLED
	}
	else if(g_bAlreadyInTrade[iTarget])
	{
		ChatColor(id, "This player is already trading with someone else!")
		menu_display(id, iMenu)
		return PLUGIN_HANDLED
	}
	g_iTradeItemTarget[id] = iTarget
	
	ChatColor(id, "Target successfuly selected!")
	cmdTradeMenu(id)
	menu_destroy(iMenu)
	return PLUGIN_HANDLED
}

resetTradeHistory(iPlayer)
{
	remove_task(iPlayer + TASK_AUTO_REFUSE)
	
	g_iTradeItemRegistered[iPlayer] = -1
	g_iTradeItemTarget[iPlayer] = -1
	g_iTradeTargetSender[iPlayer] = -1
	
	g_bTradeItemStattrack[iPlayer] = false
	g_bAlreadyInTrade[iPlayer] = false
	g_bConfirmed[iPlayer] = false
	
	g_szTradeItemName[iPlayer] = ""
}
